#! /bin/sh
# This is a shell archive, meaning:
# 1. Remove everything above the #! /bin/sh line.
# 2. Save the resulting text in a file.
# 3. Execute the file with /bin/sh (not csh) to create the files:
#	README
#	ltugboat.sty
#	module.sty
#	msam.sty
#	msbm.sty
#	stmary10.mf
#	stmary5.mf
#	stmary6.mf
#	stmary7.mf
#	stmary8.mf
#	stmary9.mf
#	stmaryaj.mf
#	stmaryba.mf
#	stmarych.mf
#	stmaryjg.mf
#	stmaryrd.mf
#	stmaryrd.sty
#	stmaryrd.tex
#	tugboat.com
# This archive created: Thu Jun 27 14:44:55 1991
export PATH; PATH=/bin:$PATH
if test -f 'README'
then
	echo shar: will not over-write existing file "'README'"
else
cat << \SHAR_EOF > 'README'
This is the St Mary's Road symbol package.  It consists of the following files:

README		msbm.sty	stmary7.mf	stmaryba.mf	stmaryrd.sty
ltugboat.sty	stmary10.mf	stmary8.mf	stmarych.mf	stmaryrd.tex
module.sty	stmary5.mf	stmary9.mf	stmaryjg.mf	tugboat.com
msam.sty	stmary6.mf	stmaryaj.mf	stmaryrd.mf

Please do not distribute these files individually.

This is a beta release of the St Mary's Road package, although we have
no plans for major alterations.  Upgrades we expect to perform before
the full release are:

   \binampsersand and \bindnasrepma don't look very nice, and need
      redrawn from scratch.
   The various square symbols, \boxbar, \boxbox, etc. need
      digitization kludges added.
   At the moment, there are too many chardp values---this is caused
      by mixing text and extension characters.  Unforunately, there's
      not much that can be done about this one. 

The St Mary's Road package is brought to you by Jeremy Gibbons 
(jg@prg.ox.ac.uk) and Alan Jeffrey (jeffrey@cs.chalmers.se), and
maintained by Alan Jeffrey.  Please drop us a line if you have any
comments, queries, words of undying praise, etc.

25 Jun 1991
SHAR_EOF
fi # end of overwriting check
if test -f 'ltugboat.sty'
then
	echo shar: will not over-write existing file "'ltugboat.sty'"
else
cat << \SHAR_EOF > 'ltugboat.sty'
\def\fileversion{v1.02 ch FMi}
\def\filedate{6 Feb 90}
% Change history at bottom of file


%               *****   LTUGBOAT.STY    *****
%
%
%       Incorporates ideas and elements from these TUGboat authors:
%               Adrian Clark
%               Frank Mittelbach
%               Rainer Sch\"opf


%  Stop here if this file has been read already

\ifx\tugstyloaded@\relax
 \endinput\else\let\tugstyloaded@\relax\fi

\typeout{Document Style `ltugboat' \fileversion \space\space <\filedate>}

% **********************************************************************
%
%  Macros common to ltugboat.sty and tugboat.sty


\input tugboat.com


% ***********************************************************************
%
%  Fonts

\font\sevbf=cmbx7
\font \svtnsfb=cmssbx10 scaled \magstep3        % for section titles;

\font \twlsfb=cmssbx10 scaled \magstep1         % definition of \LaTeX
\newfam\sectitlefam                             % requires a family
\textfont\sectitlefam=\svtnsfb
\scriptfont\sectitlefam=\twlsfb

\font\tenuit=cmu10                              % for Editor's Note

% specials for new font selection (FMi)
\ifx\selectfont\undefined

%  redo definition of 10pt from latex (lfonts), to install \sevbf as
%  \*scriptfont of \bffam
\toks0=\expandafter{\xpt\scriptfont\bffam\sevbf \scriptscriptfont\bffam\sevbf}
\xdef\xpt{\the\toks0}

\else
\def\tensl{\family{cmr}\series{m}\shape{sl}\size{10}{12pt}\selectfont}
\fi


% ***********************************************************************
%
%  normal TUGboat dimensions, glue values, penalties

\@twosidetrue           % for odd/even asymmetry in running heads
\sloppy                 % make those columns justify
%\flushbottom           % but ensure they line up
\columnsep 1.5pc        % space between columns
\columnwidth 18.75pc    % width of each column
\parindent \normalparindent     % paragraph indent
\parskip 0pt            % no inter-paragraph space
\leftmargini 2em        % unchanged
\leftmarginv .5em       % unchanged
\leftmarginvi .5em      % unchanged
\oddsidemargin 0pt      % was 42pt
\evensidemargin 0pt     % was 84pt
\topmargin -2.5pc       % was 0pt
\headheight 12pt        % height of running head, unchanged
\headsep 20pt           % distance between header and text
\marginparwidth 48pt    % don't use marginal notes
\marginparsep 10pt      %  in TUGboat
\textheight 54pc        % height of text on page
\textwidth 39pc         % total width of a page
\twocolumn              % two columns %FMi placed after setting of \textwidth


\partopsep=\z@
\topsep=3pt plus1pt minus1pt
\parsep=3pt plus 1pt minus 1pt
\itemsep=\parsep


\def\@normalsize{\@setsize\normalsize{12pt}\xpt\@xpt
\abovedisplayskip=3pt plus 3pt minus 1pt \belowdisplayskip=\abovedisplayskip
\abovedisplayshortskip=\z@ plus3pt \belowdisplayshortskip=1pt plus3pt minus1pt}

\def\small{\@setsize\small{11pt}\ixpt\@ixpt
\abovedisplayskip=2.5pt plus2.5pt minus1pt\belowdisplayskip=\abovedisplayskip
\abovedisplayshortskip=\z@ plus2pt \belowdisplayshortskip=1pt plus2pt minus1pt}

\def\footnotesize{\@setsize\footnotesize{12pt}\xpt\@xpt
\abovedisplayskip=3pt plus 3pt minus 1pt \belowdisplayskip=\abovedisplayskip
\abovedisplayshortskip=\z@ plus3pt \belowdisplayshortskip=1pt plus3pt minus1pt}


% ***********************************************************************
%
%  Lists

\def\@listi{\leftmargin\leftmargini\parsep=1pt plus 1pt minus 1pt
  \itemsep=\parsep}

\def\@listii{\leftmargin\leftmarginii
  \labelwidth=\leftmarginii \advance\labelwidth-\labelsep
  \topsep=2pt plus 1pt minus 1pt
  \parsep=1pt plus 1pt minus 1pt
  \itemsep=\parsep}

\def\@listiii{\leftmargin=\leftmarginiii
  \labelwidth=\leftmarginiii \advance\labelwidth-\labelsep
  \topsep=1pt plus 1pt minus 1pt
  \parsep=\z@
  \itemsep=\topsep}






% ***********************************************************************
%
%  Titles, authors, addresses, signatures

\def\sectitlefont{\fam\sectitlefam\svtnsfb\baselineskip\stbaselineskip}
\setbox\T@stBox=\hbox{\sectitlefont O}
\newdimen\stfontheight          \stfontheight=\ht\T@stBox
\def \sectitle#1{\SecTitletrue \def\s@ctitle{#1}}

\newcount\authornumber
\authornumber=0

\def\author#1{%
  \global\advance\authornumber\@ne
  \expandafter\def\csname theauthor\number\authornumber\endcsname
      {\ignorespaces#1\unskip}%
  \expandafter\let\csname theaddress\number\authornumber\endcsname\relax
  \expandafter\let\csname thenetaddress\number\authornumber\endcsname\relax
  }

\def\address#1{%
  \expandafter\def\csname theaddress\number\authornumber\endcsname
      {\ignorespaces#1\unskip}}

\def\network#1{\def\@network{#1: }}
\def\netaddress{%
  \begingroup
  \let\@network\relax
  \@ifnextchar[{\@netaddress}{\@netaddress[]}%
  }

{\makeactive\@
 \gdef\netaddrat{\makeactive\@\def@{\char"40\discretionary{}{}{}}}
 \makeactive\%
 \gdef\netaddrpercent{\makeactive\%\def%{\char"25\discretionary{}{}{}}}
}

\def\@netaddress[#1]{#1\@sanitize\makeactive\@\makeactive\%\@@netaddress}

\def\@@netaddress#1{%
  \toks@{#1}%
  \ifx\@network\relax \def\@@network{}%
  \else \def\@@network{\@network}\fi
  \expandafter\xdef\csname thenetaddress\number\authornumber\endcsname
    {{\noexpand\rm\@@network}%
     {\noexpand\netaddrat\noexpand\netaddrpercent\noexpand\net
      \ignorespaces\the\toks@\unskip}}%
  \endgroup
  }

\def\net{\tt}

%  Overrides to default author and signature formats

\def\authorlist#1{\def\@author{#1}}
\def\@author{\@defaultauthorlist}


\def\maketitle{\par
 \ifdim\PreTitleDrop > 0pt
   \loop
   \ifdim \PreTitleDrop > \textheight
     \vbox{}\vfil\eject
     \advance\PreTitleDrop by -\textheight
   \repeat
   \vbox to \PreTitleDrop{}
   \global\PreTitleDrop=0pt
 \fi
 \begingroup
 \setcounter{footnote}{0}
 \def\thefootnote{\fnsymbol{footnote}}
 \def\@makefnmark{\hbox to 0pt{$^{\@thefnmark}$\hss}}
 \@maketitle
 \@thanks
 \endgroup
 \setcounter{footnote}{0}
% \let\maketitle\relax
% \let\@maketitle\relax
 \gdef\@thanks{}\gdef\@author{}\gdef\@title{}%
%\let\thanks\relax
 }

\def\@maketitle{\ifSecTitle \global\SecTitlefalse
                \@sectitle{\s@ctitle}%
        \else \vskip\AboveTitleSkip
                \kern\topskip
                \hrule height\z@ depth\z@ width 10pt
                \kern-\topskip
                \kern-\strulethickness
                \hrule height\strulethickness depth\z@
                \kern\medskipamount
        \fi
        {\nohyphens \interlinepenalty\@M
        \setbox0=
          \hbox{\let\thanks\@gobble
                \let\\=\quad
                \let\and=\quad
                \ignorespaces\@author}%
        {\noindent\bf\raggedright\ignorespaces\@title\endgraf}%
        \ifdim \wd0 < 5pt               % omit if author is null
        \else \nobreak \vskip 4pt       % 4pt + \BelowTitleSkip = \baselineskip
                {\leftskip=\normalparindent
                 \def\and{\unskip\\}%
                 \noindent\@author\endgraf}%
        \fi \nobreak \vskip\BelowTitleSkip }}


\def\abstract{
\section*{Abstract}
}
\def\endabstract{}


%  Redefine style of section headings to look more like TUGboat.
%  Start with definitions from art10.sty .  (Only \section correct so far.)
%
%  \vskip 8pt \vskip\parskip before; \vskip 4pt after
%  Negative beforeskip suppresses following parindent.

\def\section{\@startsection {section}{1}{\z@}{-8pt}{4pt}%
        {\normalsize\bf\raggedright}}

\def\subsection{\@startsection{subsection}{2}{\z@}{-8pt}{4pt}%
        {\normalsize\bf\raggedright}}

\def\subsubsection
        {\@startsection{subsubsection}{3}{\z@}{-8pt}{4pt}{\normalsize\bf}}

\def\paragraph{\@startsection
 {paragraph}{4}{\z@}{3.25ex plus 1ex minus .2ex}{-1em}{\normalsize\bf}}

\def\subparagraph{\@startsection
 {subparagraph}{4}{\parindent}{3.25ex plus 1ex minus
 .2ex}{-1em}{\normalsize\bf}}

%       Modify \appendix from art10.sty, to add ``Appendix''
%       1 May 89 Mittelach comments that we need to put ``Appendix''
%         somewhere other than \thesection if \tableofcontents is used.
%\def\appendix{\par
% \setcounter{section}{0}
% \setcounter{subsection}{0}
% \def\thesection{Appendix \Alph{section}}}


\def\l@part#1#2{\addpenalty{\@secpenalty}
 \addvspace{2.25em plus 1pt} \begingroup
 \@tempdima 3em \parindent \z@ \rightskip \z@ \parfillskip \z@
 {\large \bf \leavevmode #1\hfil \hbox to\@pnumwidth{\hss #2}}\par
 \nobreak \endgroup}
\def\l@section#1#2{\addpenalty{\@secpenalty} \addvspace{1.0em plus 1pt}
\@tempdima 1.5em \begingroup
 \parindent \z@ \rightskip \z@  % article style makes \rightskip > 0
 \parfillskip \z@
 \bf \leavevmode \advance\leftskip\@tempdima \hskip -\leftskip #1\nobreak\hfil
\nobreak\hbox to\@pnumwidth{\hss #2}\par
 \endgroup}


\def \EdNote{{\tenuit Editor's note:\enspace }}


% ***********************************************************************
%
%  Footnotes

\long\def\@makefntext#1{\parindent 1em\noindent\hbox to 2em{}%
  \llap{\@makefnmark}\null$\;$#1}
%  \llap{$^{\@thefnmark}\,$}#1}


% ***********************************************************************
%
%  Figures

\def\fnum@figure{{\bf Figure \thefigure}}




% ***********************************************************************
%
%  Quotes

\def\quote{\list{}{\rightmargin.5\leftmargin}\item[]}

%       From Dominik Wujastyk's font article.  First paragraph of a quotation
%       will not be indented, and right margin is decreased for narrow columns.
\renewcommand{\quotation}{\list{}{\listparindent 1.5em
        \rightmargin.5\leftmargin\parsep 0pt plus 1pt}\item[]}


% ***********************************************************************
%
%  Signature

%  Moved to TUGboat.com

% ***********************************************************************
%
%  Running heads, output routine

\def \rtitlex{\def\tubfont{\normalsize\rm}\TUB, \volx }

\def\PrelimDraftfooter{%
  \dlap{\kern\textheight\kern3pc
        \rlap{\hbox to \pagewd{\midrtitle\hfil\midrtitle}}
  }}

% registration marks; these are temporarily inserted in the running head
\def\MakeRegistrationMarks{}
\def\UseTrimMarks{%
  \def\MakeRegistrationMarks{%
    \ulap{\rlap{%
       \vbox{\dlap{\vbox to\trimlgt{\vfil\botregister}}%
             \topregister\vskip \headmargin \vskip 10pt}}}}%
  }

\def\@oddhead{\MakeRegistrationMarks\PrelimDraftfooter
  \hbox{}\rm\rtitlex\qquad\midrtitle \hfil \thepage}
\def\@evenhead{\MakeRegistrationMarks\PrelimDraftfooter
  \rm \thepage\hfil\midrtitle\qquad\rtitlex}
\def\@oddfoot{}
\def\@evenfoot{}

\def\ps@headings{}
\pagestyle{headings}


% ***********************************************************************
%
%  Macros for Mittelbach's self-documenting style

\def\SelfDocumenting{%
  \setlength\textwidth{31pc}
  \onecolumn
  \parindent 0pt
  \parskip 2pt plus 1pt minus 1pt
  \oddsidemargin 8pc
  \evensidemargin 8pc
  \toks@\expandafter{\@oddhead}%
  \xdef\@oddhead{\hss\hbox to \pagewd{\the\toks@}}%
  \toks@\expandafter{\@evenhead}%
  \xdef\@evenhead{\hss\hbox to \pagewd{\the\toks@}}%
  \def\ps@titlepage{}%
}



% ***********************************************************************
%
%  MISCELLANEOUS defs for compatibility with tugboat.sty

\newif\ifFirstPar       \FirstParfalse

\newdimen\pagewd        \pagewd=39pc
\newdimen\trimwd        \trimwd=\pagewd
\newdimen\trimlgt       \trimlgt=11in
\newdimen\headmargin    \headmargin=3.5pc
\def\smc{\sc}
\def\ninepoint{\small}



%*************************************************************************
%
%       Start-up

\setcounter{page}{1} %FMi reset to 1
\PrelimDrafttrue

\endinput



% **********************************************************************
%
%   Change history
%

12 Feb 90	v1.02
modified definition of \@makefntext; now uses \@makefnmark (as one
   might expect)

 6 Feb 90	v1.01
removed "\font\manual=manfnt"; tugboat.com already sets \font\manual=logo10
adjusted definition of \netaddress to remove mis-timed \@sanitize-ation

29 Nov 89       v1.00
changed \titlefont to \sectitlefont
added setting of \baselineskip to defintion of \sectitlefont
changed \TUBparindent to \normalparindent (already in tugboat.com)
removed additions of amcsc* fonts
new definitions of \ragged... in tugboat.com include \nohyphens
moved most of section title material to tugboat.com
moved writing mechanism and multiple document handling to local .drv file
redefined \author to be consistent with tugboat.sty
added \address, \netaddress
moved \signature stuff to tugboat.com
made titles raggedright


20 Oct 89       v0.53
Zeroed \@signature for multiple documents

19 Oct 89       v0.52
Moved \rtitlex to tugboat.com

18 Oct 89       v0.51
Disallowed hyphenations in \section and \subsection

SHAR_EOF
fi # end of overwriting check
if test -f 'module.sty'
then
	echo shar: will not over-write existing file "'module.sty'"
else
cat << \SHAR_EOF > 'module.sty'
% Filename: module.sty
% Author: Alan Jeffrey
% E-mail: jeffrey@cs.chalmers.se
% Last modified: 25 May 1991

% A style for modularizing definitions.

% Copyright 1991 Alan Jeffrey.

% 23 May 1991: Created file.
%
% 24 May 1991: Hacked around with it quite a bit, redefined how
%    \iftag...\fi works, allowed \else, \isunsettag and conjunction.
%    Came up with the \modulefredloaded trick, implimented the settags
%    environment, rewrote some of the comments, defined tags so that
%    using one as a command causes an error message, changed the syntax
%    of \ifdef, and generally nicened it up a bit.
%
% 25 May 1991: More hackery.  Renamed \iftag to \iftest ... \then, and
%    reimplemented it.  Renamed \issettag to \tagisset, ditto
%    \tagisunset.  Introduced \truetest, \falsetest, \andtest, \ortest,
%    \nottest and \newfontselection.  Went back to the original syntax
%    for \ifdef.

% This style allows you to define modules for LaTeX, which the user can
% then use all or none of, depending on their fancy.  This is mainly
% useful for loading in new symbol fonts, which may define over 200 new
% commands, of which the user only wants a handful.  At the moment, the
% AMS gets round this by defining a command \newsymbol, but here we
% present a more user-friendly way of getting the same effect.
%
% The main concept the user needs is that of a {\em tag\/} which is a
% request to a module saying `please give me this facility'.  Usually
% these are just command names that the module will define---for
% example the module stmaryrd has tags \varoplus, \bindnasrepma, and so
% on.  But there are other tags which control how the module behaves,
% for example the tag \substitutefonts means `We don't have the
% necessary fonts, please use substitutes instead.'
%
% To set the tag \foo, you say \settag{\foo}.  To set \foo, \baz and
% \bar, you can say \begin{settags} \foo\baz\bar \end{settags}.
%
% To unset the tag \foo, you say \unsettag{\foo}.  To unset \foo, \baz
% and \bar, you can say \begin{unsettags} \foo\baz\bar \end{unsettags}.
%
% You can then import a module.  This can be done in various ways:
%
% a) By saying \import{fred}, which only loads the commands whose tags
%    you set.
%
% b) By saying \import*{fred}, which loads in all the commands.
%
% c) As a \documentstyle option, e.g. \documentstyle[module,fred]{article}.
%    This is equivalent to \import*{fred}.
%
% And that's it.

% This all works by keeping a file fred.sty, which is loaded in when fred
% is imported.  This can have any sort of definition you like (including the
% character @, which is made into a letter for the occasion).  It should
% include a command:
%
%    \settag\modulefredloaded
%
% to tell other modules (including itself) that fred.sty has been loaded.
% You also get a special command:
%
%    \iftest <test> \then <true text>  \fi
%
% or
%
%    \iftest <test> \then <true text> \else <false text> \fi
%
% meaning `if the test is true, do the true text, otherwise do
% the false text.'  A test is of the form
%
%    \truetest
%    \falsetest
%    \tagisset<tag>
%    \ortest{<test>}{<test>}
%    \andtest{<test>}{<test>}
%    \nottest{<test>}
%
% For example, there is a special tag called \everything, which is set if we
% are meant to define every command we can.  So if we are defining a
% command \fred, we would like to test if either \fred or \everything has
% been set.  We can do this by saying
%
%    \iftest \ortest{\tagisset\fred}{\tagisset\everything} \then \def\foo... \fi
%
% This is so common as to warrant its own syntactic sugar:
%
%    \ifdef \then \def\foo... \fi
%
% You can also say \ifdef\then\mathchardef\foo...\fi,
% \ifdef\then\let\foo...\fi, or any other defining command.  Since
% these are so common in modules, I've included the extra commands:
%
%    \delimiterdef\foo"1234567  \textchardef\foo"123
%
% Another common usage is
%
%    \iftest \tagisset\foo \then \settag\baz \fi
%
% meaning `If we are exporting \foo, we should export \baz as well.'
% This sort of dependency information is so common as to warrant its own
% syntactic sugar:
%
%    \dependent\foo\baz
%
% Note that since modules may well be loaded in more than once, you have
% to make sure your commands can be obeyed many times.  To get round
% this, the module `fred' can look at the value of \modulefredloaded to
% see whether or not it's been loaded before.  For example, if you have
% some sensitive definitions (such as loading fonts) which shoudn't be
% done more than once, you can say (before setting \modulefredloaded):
%
%    \iftest \tagisunset\modulefredloaded \then ...sensitive material... \fi
%
% If your module does some font loading, it can look at the tag
% \newfontselection to see whether the new font selection scheme has been
% installed.

% So how is this all done?  Well, the name of the game is to use TeX's
% primitive \if ... \fi constructs in such a way that they always group
% nicely.  So a <test> is a command that expands out to either \iftrue
% or \iffalse.  NB: \iffalse and \iftrue are *not* valid tests, as they'd
% foul up the \if...\fi matching.

\def\truetest{\iftrue}
\def\falsetest{\iffalse}

\def\ortest#1{#1\expandafter\K@true\else\expandafter\@identity\fi}
\def\@identity#1{#1}
\def\K@true#1{\iftrue}

\def\andtest#1#2{#1\@fi#2}
\def\@fi{\fi}

\def\nottest#1{#1\expandafter\falsetest\else\expandafter\truetest\fi}

% Then all that \iftest...\then has to do is expand out the test.

\def\iftest#1\then{#1}

% In order to make sure that \if ... \fi matching works properly, we need
% to define \then to be an \if-like command.

\let\then\iftrue

% To test whether a tag is set or not we just look to see if it
% is the same as \magic@value.

\def\tagisset#1{\ifx\magic@value#1}

% So to set a tag, we just \let it to \magic@value.

\def\settag#1{\let#1\magic@value}
\def\unsettag#1{\let#1\unmagic@value}

% If the user says something like \settag\foo \import{fred} but fred
% doesn't define \foo, we'd like some way of failing gracefully.  We do
% this by defining \magic@value and \unmagic@value to produce error messages.

\def\magic@value{\set@error}
\def\set@error{\@latexerr{This command is a set tag}{You just used a tag
   where LaTeX expected an ordinary command.^^JIf you press return now, I'll
   ignore the tag.^^JSee `A module system for LaTeX' by Alan Jeffrey for
   details.}}

\def\unmagic@value{\unset@error}
\def\unset@error{\@latexerr{This command is an unset tag}{You just used a tag
   where LaTeX expected an ordinary command.^^JIf you press return now, I'll
   ignore the tag.^^JSee `A module system for LaTeX' by Alan Jeffrey for
   details.}}

% Then \ifdef and \dependent are just syntactic sugar, speeded up a bit.

\def\ifdef\then#1#2%
   {\tagisset\everything\expandafter\iftrue
      \else\expandafter\tagisset\expandafter#2\fi#1#2}
\def\dependent#1#2%
   {\tagisset#1\settag#2\fi}

% The settags and unsettags environments:

\def\settags#1%
   {\ifx#1\end\expandafter\end\else\settag#1\expandafter\settags\fi}
\def\unsettags#1%
   {\ifx#1\end\expandafter\end\else\unsettag#1\expandafter\unsettags\fi}

% The trouble with \import is getting it to save the current values of
% \everything and the catcode for @ correctly.  Oh, if only I could
% use TeX grouping for this, but I can't, because the font selection
% scheme doesn't allow you to load fonts globally.  Oh well.

\def\import
   {\@ifstar{\@import\settag}{\@import\unsettag}}
\def\@import#1#2%
   {\tagisset\everything
      \def\next{\@@import{#2}\settag\everything}\else
         \def\next{\@@import{#2}\unsettag\everything}\fi
      #1\everything\next}
\def\@@import#1%
   {\edef\next{\noexpand\@@input #1.sty
      \catcode`\noexpand\@\the\catcode`\@}\makeatletter\next}

% We need to set \everything initially, so that if a module is read in
% as a .sty file, it behaves like \import*{fred}.

\settag\everything

% And to be a well-behaved module, we should set \modulemoduleloaded.

\settag\modulemoduleloaded

% Look to see if \selectfont is defined (as a check for whether we're
% using the new font selection scheme).

\@ifundefined{selectfont}{}{\settag\newfontselection}

% Old-fashioned LaTeX didn't have this:

\def\hexnumber@#1{\ifcase#1 \z@
 \or \@ne \or \tw@ \or \thr@@
 \or 4\or 5\or 6\or 7\or 8\or
 9\or A\or B\or C\or D\or E\or F\fi}

% A few extra commands for definitions:

\def\textchardef#1"#2#3#4{\edef#1{\noexpand\mathhexbox#2#3#4}}
\def\delimiterdef#1"#2#3#4#5#6#7#8{\edef#1{\delimiter"#2#3#4#5#6#7#8 }}

% And that's that.

SHAR_EOF
fi # end of overwriting check
if test -f 'msam.sty'
then
	echo shar: will not over-write existing file "'msam.sty'"
else
cat << \SHAR_EOF > 'msam.sty'
% Filename msam.sty
% Author Alan Jeffrey
% E-mail jeffrey@cs.chalmers.se
% Last modified 21 Jun 1991

% Copyright 1991 AlanJeffrey.

% 23 May 1991: file created.
%
% 21 Jun 1991: Updated for the new module.sty.

% This is the module for importing the AMS A symbol font.
% It's pretty incomplete at the moment, and specifically doesn't
% understand the \substitutesymbols tag.
%
% But it's a start.

\@ifundefined{modulemoduleloaded}{\input module.sty}{}

% The first time the module is loaded, we grab the fonts.

\iftest \tagisset\modulemsamloaded \then \else

   \iftest \tagisset\newfontselection \then

      \new@mathgroup\msa@group
      \define@mathgroup\mv@normal\msa@group{msa}{m}{n}
      \define@mathgroup\mv@bold\msa@group{msa}{m}{n}

      \new@fontshape{msa}{m}{n}{%
         <5>msam5%
         <6>msam6%
         <7>msam7%
         <8>msam8%
         <9>msam9%
         <10>msam10%
         <11>msam10 at10.95pt%
         <12>msam10 at12pt%
         <14>msam10 at14.4pt%
         <17>msam10 at17.28pt%
         <20>msam10 at20.736pt%
         <25>msam10 at24.8832pt}{}

   \else

      \newfam\msa@group

      \font\msamfiv  msam5
      \font\msamsix  msam6
      \font\msamsev  msam7
      \font\msamegt  msam8
      \font\msamnin  msam9
      \font\msamten  msam10
      \font\msamelv  msam10 at10.95pt
      \font\msamtwl  msam10 at12pt
      \font\msamfrtn msam10 at14.4pt
      \font\msamsvtn msam10 at17.28pt
      \font\msamtwty msam10 at20.736pt
      \font\msamtwfv msam10 at24.8832pt

      \@addfontinfo\@vpt{\textfont\msa@group\msamfiv
         \scriptfont\msa@group\msamfiv
         \scriptscriptfont\msa@group\msamfiv}
      \@addfontinfo\@vipt{\textfont\msa@group\msamsix
         \scriptfont\msa@group\msamsix
         \scriptscriptfont\msa@group\msamsix}
      \@addfontinfo\@viipt{\textfont\msa@group\msamsev
         \scriptfont\msa@group\msamsix
         \scriptscriptfont\msa@group\msamfiv}
      \@addfontinfo\@viiipt{\textfont\msa@group\msamegt
         \scriptfont\msa@group\msamsix
         \scriptscriptfont\msa@group\msamfiv}
      \@addfontinfo\@ixpt{\textfont\msa@group\msamnin
         \scriptfont\msa@group\msamsix
         \scriptscriptfont\msa@group\msamfiv}
      \@addfontinfo\@xpt{\textfont\msa@group\msamten
         \scriptfont\msa@group\msamsev
         \scriptscriptfont\msa@group\msamfiv}
      \@addfontinfo\@xipt{\textfont\msa@group\msamelv
         \scriptfont\msa@group\msamsev
         \scriptscriptfont\msa@group\msamfiv}
      \@addfontinfo\@xiipt{\textfont\msa@group\msamtwl
         \scriptfont\msa@group\msamegt
         \scriptscriptfont\msa@group\msamsix}
      \@addfontinfo\@xivpt{\textfont\msa@group\msamfrtn
         \scriptfont\msa@group\msamten
         \scriptscriptfont\msa@group\msamsev}
      \@addfontinfo\@xviipt{\textfont\msa@group\msamsvtn
         \scriptfont\msa@group\msamtwl
         \scriptscriptfont\msa@group\msamten}
      \@addfontinfo\@xxpt{\textfont\msa@group\msamtwty
         \scriptfont\msa@group\msamfrtn
         \scriptscriptfont\msa@group\msamtwl}
      \@addfontinfo\@xxvpt{\textfont\msa@group\msamtwfv
         \scriptfont\msa@group\msamtwty
         \scriptscriptfont\msa@group\msamsvtn}
   \fi

\fi

% For the rest of the style, ! is the hex number of the family.

\catcode`\!\active
\edef!{\hexnumber@\msa@group}

% Then we load those symbols!

\ifdef\then\mathchardef\square"0!03\fi
\ifdef\then\mathchardef\blacksquare"0!04\fi
\ifdef\then\mathchardef\lozenge"0!06\fi
\ifdef\then\mathchardef\blacklozenge"0!07\fi
\ifdef\then\mathchardef\backprime"0!38\fi
\ifdef\then\mathchardef\bigstar"0!46\fi
\ifdef\then\mathchardef\blacktriangledown"0!48\fi
\ifdef\then\mathchardef\blacktriangle"0!4E\fi
\ifdef\then\mathchardef\triangledown"0!4F\fi
\ifdef\then\mathchardef\measuredangle"0!5D\fi
\ifdef\then\mathchardef\sphericalangle"0!5E\fi
\ifdef\then\mathchardef\circledS"0!73\fi
\ifdef\then\mathchardef\complement"0!7B\fi

\ifdef\then\mathchardef\boxdot"2!00\fi
\ifdef\then\mathchardef\boxplus"2!01\fi
\ifdef\then\mathchardef\boxtimes"2!02\fi
\ifdef\then\mathchardef\centerdot"2!05\fi
\ifdef\then\mathchardef\boxminus"2!0C\fi
\ifdef\then\mathchardef\veebar"2!59\fi
\ifdef\then\mathchardef\barwedge"2!5A\fi
\ifdef\then\mathchardef\doublebarwedge"2!5B\fi
\ifdef\then\mathchardef\Cup"2!64\fi
\ifdef\then\mathchardef\doublecup"2!64\fi
\ifdef\then\mathchardef\Cap"2!65\fi
\ifdef\then\mathchardef\doublecap"2!65\fi
\ifdef\then\mathchardef\curlywedge"2!66\fi
\ifdef\then\mathchardef\curlyvee"2!67\fi
\ifdef\then\mathchardef\leftthreetimes"2!68\fi
\ifdef\then\mathchardef\rightthreetimes"2!69\fi
\ifdef\then\mathchardef\dotplus"2!75\fi
\ifdef\then\mathchardef\intercal"2!7C\fi
\ifdef\then\mathchardef\circledcirc"2!7D\fi
\ifdef\then\mathchardef\circledast"2!7E\fi
\ifdef\then\mathchardef\circleddash"2!7F\fi

\ifdef\then\mathchardef\circlearrowright"3!08\fi
\ifdef\then\mathchardef\circlearrowleft"3!09\fi
\ifdef\then\mathchardef\rightleftharpoons"3!0A\fi
\ifdef\then\mathchardef\leftrightharpoons"3!0B\fi
\ifdef\then\mathchardef\twoheadrightarrow"3!10\fi
\ifdef\then\mathchardef\twoheadleftarrow"3!11\fi
\ifdef\then\mathchardef\leftleftarrows"3!12\fi
\ifdef\then\mathchardef\rightrightarrows"3!13\fi
\ifdef\then\mathchardef\upuparrows"3!14\fi
\ifdef\then\mathchardef\downdownarrows"3!15\fi
\ifdef\then\mathchardef\upharpoonright"3!16\fi
\ifdef\then\mathchardef\restriction"3!16\fi
\ifdef\then\mathchardef\downharpoonright"3!17\fi
\ifdef\then\mathchardef\upharpoonleft"3!18\fi
\ifdef\then\mathchardef\downharpoonleft"3!19\fi
\ifdef\then\mathchardef\rightarrowtail"3!1A\fi
\ifdef\then\mathchardef\leftarrowtail"3!1B\fi
\ifdef\then\mathchardef\leftrightarrows"3!1C\fi
\ifdef\then\mathchardef\rightleftarrows"3!1D\fi
\ifdef\then\mathchardef\rightsquigarrow"3!20\fi
\ifdef\then\mathchardef\leftrightsquigarrow"3!21\fi
\ifdef\then\mathchardef\looparrowleft"3!22\fi
\ifdef\then\mathchardef\looparrowright"3!23\fi
\ifdef\then\mathchardef\Rrightarrow"3!56\fi
\ifdef\then\mathchardef\Lleftarrow"3!57\fi

\ifdef\then\mathchardef\Vdash"3!0D\fi
\ifdef\then\mathchardef\Vvdash"3!0E\fi
\ifdef\then\mathchardef\vDash"3!0F\fi
\ifdef\then\mathchardef\Lsh"3!1E\fi
\ifdef\then\mathchardef\Rsh"3!1F\fi
\ifdef\then\mathchardef\circeq"3!24\fi
\ifdef\then\mathchardef\succsim"3!25\fi
\ifdef\then\mathchardef\gtrsim"3!26\fi
\ifdef\then\mathchardef\gtrapprox"3!27\fi
\ifdef\then\mathchardef\multimap"3!28\fi
\ifdef\then\mathchardef\therefore"3!29\fi
\ifdef\then\mathchardef\because"3!2A\fi
\ifdef\then\mathchardef\doteqdot"3!2B\fi
\ifdef\then\mathchardef\Doteq"3!2B\fi
\ifdef\then\mathchardef\triangleq"3!2C\fi
\ifdef\then\mathchardef\precsim"3!2D\fi
\ifdef\then\mathchardef\lesssim"3!2E\fi
\ifdef\then\mathchardef\lessapprox"3!2F\fi
\ifdef\then\mathchardef\eqslantless"3!30\fi
\ifdef\then\mathchardef\eqslantgtr"3!31\fi
\ifdef\then\mathchardef\curlyeqprec"3!32\fi
\ifdef\then\mathchardef\curlyeqsucc"3!33\fi
\ifdef\then\mathchardef\preccurlyeq"3!34\fi
\ifdef\then\mathchardef\leqq"3!35\fi
\ifdef\then\mathchardef\leqslant"3!36\fi
\ifdef\then\mathchardef\lessgtr"3!37\fi
\ifdef\then\mathchardef\risingdotseq"3!3A\fi
\ifdef\then\mathchardef\fallingdotseq"3!3B\fi
\ifdef\then\mathchardef\succcurlyeq"3!3C\fi
\ifdef\then\mathchardef\geqq"3!3D\fi
\ifdef\then\mathchardef\geqslant"3!3E\fi
\ifdef\then\mathchardef\gtrless"3!3F\fi
\ifdef\then\mathchardef\vartriangleright"3!42\fi
\ifdef\then\mathchardef\vartriangleleft"3!43\fi
\ifdef\then\mathchardef\trianglerighteq"3!44\fi
\ifdef\then\mathchardef\trianglelefteq"3!45\fi
\ifdef\then\mathchardef\between"3!47\fi
\ifdef\then\mathchardef\blacktriangleright"3!49\fi
\ifdef\then\mathchardef\blacktriangleleft"3!4A\fi
\ifdef\then\mathchardef\vartriangle"3!4D\fi
\ifdef\then\mathchardef\eqcirc"3!50\fi
\ifdef\then\mathchardef\lesseqgtr"3!51\fi
\ifdef\then\mathchardef\gtreqless"3!52\fi
\ifdef\then\mathchardef\lesseqqgtr"3!53\fi
\ifdef\then\mathchardef\gtreqqless"3!54\fi
\ifdef\then\mathchardef\varpropto"3!5F\fi
\ifdef\then\mathchardef\smallsmile"3!60\fi
\ifdef\then\mathchardef\smallfrown"3!61\fi
\ifdef\then\mathchardef\Subset"3!62\fi
\ifdef\then\mathchardef\Supset"3!63\fi
\ifdef\then\mathchardef\subseteqq"3!6A\fi
\ifdef\then\mathchardef\supseteqq"3!6B\fi
\ifdef\then\mathchardef\bumpeq"3!6C\fi
\ifdef\then\mathchardef\Bumpeq"3!6D\fi
\ifdef\then\mathchardef\lll"3!6E\fi
\ifdef\then\mathchardef\llless"3!6E\fi
\ifdef\then\mathchardef\ggg"3!6F\fi
\ifdef\then\mathchardef\gggtr"3!6F\fi
\ifdef\then\mathchardef\pitchfork"3!74\fi
\ifdef\then\mathchardef\backsim"3!76\fi
\ifdef\then\mathchardef\backsimeq"3!77\fi

% Change the catcode of ! back to other.

\catcode`\!=12

% Set our own name:

\settag\modulemsamloaded

% And that's it.
SHAR_EOF
fi # end of overwriting check
if test -f 'msbm.sty'
then
	echo shar: will not over-write existing file "'msbm.sty'"
else
cat << \SHAR_EOF > 'msbm.sty'
% Filename msbm.sty
% Author Alan Jeffrey
% E-mail jeffrey@cs.chalmers.se
% Last modified 21 Jun 1991

% Copyright 1991 AlanJeffrey.

% 24 May 1991: file created.
%
% 21 Jun 1991: Updated for the new module.sty.

% This is the module for importing the AMS B symbol font.
% It's pretty incomplete at the moment, and specifically doesn't
% understand the \substitutesymbols tag.
%
% But it's a start.

\@ifundefined{modulemoduleloaded}{\input module.sty}{}

% The first time the module is loaded, we grab the fonts.

\iftest \tagisset\modulemsbmloaded \then \else

   \iftest \tagisset\newfontselection \then

      \new@mathgroup\msb@group
      \define@mathgroup\mv@normal\msb@group{msb}{m}{n}
      \define@mathgroup\mv@bold\msb@group{msb}{m}{n}

      \new@fontshape{msb}{m}{n}{%
         <5>msbm5%
         <6>msbm6%
         <7>msbm7%
         <8>msbm8%
         <9>msbm9%
         <10>msbm10%
         <11>msbm10 at10.95pt%
         <12>msbm10 at12pt%
         <14>msbm10 at14.4pt%
         <17>msbm10 at17.28pt%
         <20>msbm10 at20.736pt%
         <25>msbm10 at24.8832pt}{}

   \else

      \newfam\msb@group

      \font\msbmfiv  msbm5
      \font\msbmsix  msbm6
      \font\msbmsev  msbm7
      \font\msbmegt  msbm8
      \font\msbmnin  msbm9
      \font\msbmten  msbm10
      \font\msbmelv  msbm10 at10.95pt
      \font\msbmtwl  msbm10 at12pt
      \font\msbmfrtn msbm10 at14.4pt
      \font\msbmsvtn msbm10 at17.28pt
      \font\msbmtwty msbm10 at20.736pt
      \font\msbmtwfv msbm10 at24.8832pt

      \@addfontinfo\@vpt{\textfont\msb@group\msbmfiv
         \scriptfont\msb@group\msbmfiv
         \scriptscriptfont\msb@group\msbmfiv}
      \@addfontinfo\@vipt{\textfont\msb@group\msbmsix
         \scriptfont\msb@group\msbmsix
         \scriptscriptfont\msb@group\msbmsix}
      \@addfontinfo\@viipt{\textfont\msb@group\msbmsev
         \scriptfont\msb@group\msbmsix
         \scriptscriptfont\msb@group\msbmfiv}
      \@addfontinfo\@viiipt{\textfont\msb@group\msbmegt
         \scriptfont\msb@group\msbmsix
         \scriptscriptfont\msb@group\msbmfiv}
      \@addfontinfo\@ixpt{\textfont\msb@group\msbmnin
         \scriptfont\msb@group\msbmsix
         \scriptscriptfont\msb@group\msbmfiv}
      \@addfontinfo\@xpt{\textfont\msb@group\msbmten
         \scriptfont\msb@group\msbmsev
         \scriptscriptfont\msb@group\msbmfiv}
      \@addfontinfo\@xipt{\textfont\msb@group\msbmelv
         \scriptfont\msb@group\msbmsev
         \scriptscriptfont\msb@group\msbmfiv}
      \@addfontinfo\@xiipt{\textfont\msb@group\msbmtwl
         \scriptfont\msb@group\msbmegt
         \scriptscriptfont\msb@group\msbmsix}
      \@addfontinfo\@xivpt{\textfont\msb@group\msbmfrtn
         \scriptfont\msb@group\msbmten
         \scriptscriptfont\msb@group\msbmsev}
      \@addfontinfo\@xviipt{\textfont\msb@group\msbmsvtn
         \scriptfont\msb@group\msbmtwl
         \scriptscriptfont\msb@group\msbmten}
      \@addfontinfo\@xxpt{\textfont\msb@group\msbmtwty
         \scriptfont\msb@group\msbmfrtn
         \scriptscriptfont\msb@group\msbmtwl}
      \@addfontinfo\@xxvpt{\textfont\msb@group\msbmtwfv
         \scriptfont\msb@group\msbmtwty
         \scriptscriptfont\msb@group\msbmsvtn}
   \fi

\fi

% For the rest of the style, ! is the hex number of the family.

\catcode`\!\active
\edef!{\hexnumber@\msb@group}

% Then we load those symbols!

\ifdef\then\mathchardef\varnothing"0!3F\fi
\ifdef\then\mathchardef\nexists"0!40\fi
\ifdef\then\mathchardef\eth"0!67\fi
\ifdef\then\mathchardef\beth"0!69\fi
\ifdef\then\mathchardef\gimel"0!6A\fi
\ifdef\then\mathchardef\daleth"0!6B\fi
\ifdef\then\mathchardef\digamma"0!7A\fi
\ifdef\then\mathchardef\varkappa"0!7B\fi
\ifdef\then\mathchardef\hslash"0!7D\fi

\ifdef\then\mathchardef\divideontimes"2!3E\fi
\ifdef\then\mathchardef\ltimes"2!6E\fi
\ifdef\then\mathchardef\rtimes"2!6F\fi
\ifdef\then\mathchardef\smallsetminus"2!72\fi

\ifdef\then\mathchardef\lvertneqq"3!00\fi
\ifdef\then\mathchardef\gvertneqq"3!01\fi
\ifdef\then\mathchardef\nleq"3!02\fi
\ifdef\then\mathchardef\ngeq"3!03\fi
\ifdef\then\mathchardef\nless"3!04\fi
\ifdef\then\mathchardef\ngtr"3!05\fi
\ifdef\then\mathchardef\nprec"3!06\fi
\ifdef\then\mathchardef\nsucc"3!07\fi
\ifdef\then\mathchardef\lneqq"3!08\fi
\ifdef\then\mathchardef\gneqq"3!09\fi
\ifdef\then\mathchardef\nleqslant"3!0A\fi
\ifdef\then\mathchardef\ngeqslant"3!0B\fi
\ifdef\then\mathchardef\lneq"3!0C\fi
\ifdef\then\mathchardef\gneq"3!0D\fi
\ifdef\then\mathchardef\npreceq"3!0E\fi
\ifdef\then\mathchardef\nsucceq"3!0F\fi
\ifdef\then\mathchardef\precnsim"3!10\fi
\ifdef\then\mathchardef\succnsim"3!11\fi
\ifdef\then\mathchardef\lnsim"3!12\fi
\ifdef\then\mathchardef\gnsim"3!13\fi
\ifdef\then\mathchardef\nleqq"3!14\fi
\ifdef\then\mathchardef\ngeqq"3!15\fi
\ifdef\then\mathchardef\precneqq"3!16\fi
\ifdef\then\mathchardef\succneqq"3!17\fi
\ifdef\then\mathchardef\precnapprox"3!18\fi
\ifdef\then\mathchardef\succnapprox"3!19\fi
\ifdef\then\mathchardef\lnapprox"3!1A\fi
\ifdef\then\mathchardef\gnapprox"3!1B\fi
\ifdef\then\mathchardef\nsim"3!1C\fi
\ifdef\then\mathchardef\ncong"3!1D\fi
\ifdef\then\mathchardef\varsubsetneq"3!20\fi
\ifdef\then\mathchardef\varsupsetneq"3!21\fi
\ifdef\then\mathchardef\nsubseteqq"3!22\fi
\ifdef\then\mathchardef\nsupseteqq"3!23\fi
\ifdef\then\mathchardef\subsetneqq"3!24\fi
\ifdef\then\mathchardef\supsetneqq"3!25\fi
\ifdef\then\mathchardef\varsubsetneqq"3!26\fi
\ifdef\then\mathchardef\varsupsetneqq"3!27\fi
\ifdef\then\mathchardef\subsetneq"3!28\fi
\ifdef\then\mathchardef\supsetneq"3!29\fi
\ifdef\then\mathchardef\nsubseteq"3!2A\fi
\ifdef\then\mathchardef\nsupseteq"3!2B\fi
\ifdef\then\mathchardef\nparallel"3!2C\fi
\ifdef\then\mathchardef\nmid"3!2D\fi
\ifdef\then\mathchardef\nshortmid"3!2E\fi
\ifdef\then\mathchardef\nshortparallel"3!2F\fi
\ifdef\then\mathchardef\nvdash"3!30\fi
\ifdef\then\mathchardef\nVdash"3!31\fi
\ifdef\then\mathchardef\nvDash"3!32\fi
\ifdef\then\mathchardef\nVDash"3!33\fi
\ifdef\then\mathchardef\ntrianglerighteq"3!34\fi
\ifdef\then\mathchardef\ntrianglelefteq"3!35\fi
\ifdef\then\mathchardef\ntriangleleft"3!36\fi
\ifdef\then\mathchardef\ntriangleright"3!37\fi
\ifdef\then\mathchardef\nleftarrow"3!38\fi
\ifdef\then\mathchardef\nrightarrow"3!39\fi
\ifdef\then\mathchardef\nLeftarrow"3!3A\fi
\ifdef\then\mathchardef\nRightarrow"3!3B\fi
\ifdef\then\mathchardef\nLeftrightarrow"3!3C\fi
\ifdef\then\mathchardef\nleftrightarrow"3!3D\fi
\ifdef\then\mathchardef\eqsim"3!68\fi
\ifdef\then\mathchardef\lessdot"3!6C\fi
\ifdef\then\mathchardef\gtrdot"3!6D\fi
\ifdef\then\mathchardef\shortmid"3!70\fi
\ifdef\then\mathchardef\shortparallel"3!71\fi
\ifdef\then\mathchardef\thicksim"3!73\fi
\ifdef\then\mathchardef\thickapprox"3!74\fi
\ifdef\then\mathchardef\approxeq"3!75\fi
\ifdef\then\mathchardef\succapprox"3!76\fi
\ifdef\then\mathchardef\precapprox"3!77\fi
\ifdef\then\mathchardef\curvearrowleft"3!78\fi
\ifdef\then\mathchardef\curvearrowright"3!79\fi
\ifdef\then\mathchardef\backepsilon"3!7F\fi

% Change the catcode of ! back to other.

\catcode`\!=12

% A hack from amsfonts.sty to define \Bbb

\ifdef\then\def\Bbb{\protect\pBbb}
   \def\pBbb{\RIfM@\expandafter\Bbb@\else
                 \expandafter\nonmatherr@\expandafter\Bbb\fi}
   \edef\Bbb@{\noexpand\use@mathgroup
          \expandafter\noexpand\csname =msb\endcsname
          \msb@group}
   \def\RIfM@{\relax\protect\ifmmode}
\fi

% Set our own name:

\settag\modulemsbmloaded

% And that's it.
SHAR_EOF
fi # end of overwriting check
if test -f 'stmary10.mf'
then
	echo shar: will not over-write existing file "'stmary10.mf'"
else
cat << \SHAR_EOF > 'stmary10.mf'
if unknown cmbase: input cmbase fi;
def generate suffix t = enddef;
input cmsy10;
slant:= 0;
input stmaryrd;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmary5.mf'
then
	echo shar: will not over-write existing file "'stmary5.mf'"
else
cat << \SHAR_EOF > 'stmary5.mf'
if unknown cmbase: input cmbase fi;
def generate suffix t = enddef;
input cmsy5; slant:=0;
input stmaryrd;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmary6.mf'
then
	echo shar: will not over-write existing file "'stmary6.mf'"
else
cat << \SHAR_EOF > 'stmary6.mf'
if unknown cmbase: input cmbase fi;
def generate suffix t = enddef;
input cmsy6; slant:=0;
input stmaryrd;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmary7.mf'
then
	echo shar: will not over-write existing file "'stmary7.mf'"
else
cat << \SHAR_EOF > 'stmary7.mf'
if unknown cmbase: input cmbase fi;
def generate suffix t = enddef;
input cmsy7; slant:= 0;
input stmaryrd;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmary8.mf'
then
	echo shar: will not over-write existing file "'stmary8.mf'"
else
cat << \SHAR_EOF > 'stmary8.mf'
if unknown cmbase: input cmbase fi;
def generate suffix t = enddef;
input cmsy8; slant:=0;
input stmaryrd;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmary9.mf'
then
	echo shar: will not over-write existing file "'stmary9.mf'"
else
cat << \SHAR_EOF > 'stmary9.mf'
if unknown cmbase: input cmbase fi;
def generate suffix t = enddef;
input cmsy9; slant:=0;
input stmaryrd;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmaryaj.mf'
then
	echo shar: will not over-write existing file "'stmaryaj.mf'"
else
cat << \SHAR_EOF > 'stmaryaj.mf'
% Filename: stmaryaj.mf
% Author: Alan Jeffrey
% Email: jeffrey@cs.chalmers.se
% Last modified: 25 Jun 1991.

% These are Alan's symbols for the St Mary's Road font, stmaryrd.mf.

% Copyright 1991 Alan Jeffrey.

% 20 May 1991: Created the file from the ashes of alans.mf.
%
% 24 May 1991: Finished the first version.
%
% 25 Jun 1991: Corrected bugs with arrow_not and Arrow_not.

iff known left_right_arrow_eq:
cmchar "Left and right arrow equality"; 
compute_spread(.45x_height#,.55x_height#); 
beginchar(left_right_arrow_eq,14u#,v_center(spread#+.96asc_height#)); 
adjust_fit(0,0); pickup crisp.nib; pos1(rule_thickness,90); 
pos2(rule_thickness,90); pos3(bar,0); pos4(bar,0); 
y0=y1=y2=math_axis; x1=.5w; rt
x0=hround(w-.75u); y3-y0=y0-y4=.24asc_height+eps; 
x3=x4=x0-3u-eps; pos5(bar,angle(z4-z0)); z5l=z0; 
pos6(bar,angle(z3-z0)); z6l=z0; z9=.381966[.5[z3,z4],z0]; 
numeric t; path p; p=z4l{z9-z4}..z6r; t=xpart(p 
intersectiontimes((0,y2l)--(w,y2l))); x2=xpart point t of p; 
path p; p=z0..{z4-z9}z4r--subpath (0,t) 
of\\(z4l{z9-z4}..z6r) 
 --z2l---z1l..z1r---z2r--subpath (t,0) of\\(z3l{z9-z3}..z5r) 
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem 
p:=p shifted (0,.5spread); filldraw p; % top 
addto currentpicture also currentpicture xscaled -1 shifted (w,0);
pickup rule.nib;
lft x10=hround u; x11=w-x10; y10=y11=math_axis-.5spread;
draw z10--z11;  % bottom
penlabels(0,1,2,3,4,5,6,9,10,11); endchar; 

iff known curly_vee_down_arrow: 
cmchar "Upside-down upwards accumulate symbol";
beginchar(curly_vee_down_arrow,12u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup rule.nib;
x2=good.x .5w; w:=r:=2x2;
lft x1=0; x3=w-x1;
bot y1=-d; top y2=h+o; y3=y1;
x4=x2; y4=h-(x_height+d);
pickup crisp.nib;
pos11(rule_thickness,0); pos12(rule_thickness,0);     % arrow head nicked from
pos13(bar,90); pos14(bar,90);                         % up_arrow
lft x11l=hround(.5w-.5rule_thickness); y11-.5rule_thickness=-d;
x10=x11=x12; top y10=top y2; x10-x13=x14-x10=3u+eps;
y13=y14=y10-.24asc_height-eps;
pos15(bar,angle(z14-z10)); z15l=z10;
pos16(bar,angle(z13-z10)); z16l=z10;
z19=.381966[.5[z13,z14],z10];
numeric t; path p; p=z14l{z19-z14}..z16r;
t=xpart(p intersectiontimes((x12r,-d)--(x12r,h))); y12=ypart point t of p;
filldraw z10..{z14-z19}z14r--subpath (0,t) of\\(z14l{z19-z14}..z16r)
 --z12r
 -- % ---z11r..z11l---
 z12l--subpath (t,0) of\\(z13l{z19-z13}..z15r)
 --z13r{z19-z13}..z10 & cycle;  % arrowhead
pickup rule.nib;
numeric t; path p; p=z1{z4-z1}..{up}z2;
t=xpart(p intersectiontimes((0,y12)--(w,y12))); 
draw subpath (0,t) of\\(z1{z4-z1}..{up}z2);  % left arm
draw subpath (0,t) of\\(z3{z4-z3}..{up}z2);  % right arm
currentpicture:= currentpicture yscaled -1 shifted (0,h-d);
endchar;

iff known curly_vee_up_arrow: 
cmchar "Upside-down downwards accumulate symbol";
beginchar(curly_vee_up_arrow,12u#,asc_height#,asc_depth#);                
adjust_fit(0,0); pickup rule.nib;
x2=good.x .5w; w:=r:=2x2;
lft x1=0; x3=w-x1;
bot y1=-d; top y2=h+o; y3=y1;
x4=x2; y4=h-(x_height+d);
pickup crisp.nib;
numeric theta,delta; theta=angle(z4-z1); delta=3u++.24asc_height;
pos11(rule_thickness,-90+theta); pos12(rule_thickness,-90+theta);
pos13(bar,-180+theta); pos14(bar,-180+theta);
lft x10=0; bot y10=-d;
x11=w; z11=z10+whatever*(dir theta);  % where the arrow stem would go
y13a=y10; x14a=x10; x13a-x10=y14a-y10=delta+eps;
z13=z13a rotatedaround(z10,theta-45);
z14=z14a rotatedaround(z10,theta-45);
pos15(bar,theta+45); z15l=z10; pos16(bar,theta-45); z16l=z10;
z19=.381966[.5[z13,z14],z10];
numeric t; path p; p=z14l{z19-z14}..z16r;
t=xpart(p intersectiontimes (z11l--(z11l+2(z10-z11)))); z12l=point t of p;
filldraw z10..{z14-z19}z14r
 --subpath (0,t) of\\(z14l{z19-z14}..z16r)
 --z12l
 -- % ---z11l..z11r---
 z12r
 --subpath (t,0) of\\(z13l{z19-z13}..z15r)
 --z13r{z19-z13}..z10 & cycle;  % left arrowhead
numeric theta,delta; theta=angle(z3-z4); delta=3u++.24asc_height;
pos21(rule_thickness,90+theta); pos22(rule_thickness,90+theta);
pos23(bar,theta); pos24(bar,theta);
rt x20=w; bot y20=-d;
x21=0; z21=z20+whatever*-(dir theta);  % where the arrow stem would go
x23a=x20; y24a=y20; y23a-y20=x20-x24a=delta+eps;
z23=z23a rotatedaround(z20,theta+45);
z24=z24a rotatedaround(z20,theta+45);
pos25(bar,theta+225); z25l=z20; pos26(bar,theta+135); z26l=z20;
z29=.381966[.5[z23,z24],z20];
numeric t; path p; p=z24l{z29-z24}..z26r;
t=xpart(p intersectiontimes (z21l--(z21l+2(z20-z21)))); z22l=point t of p;
filldraw z20..{z24-z29}z24r
 --subpath (0,t) of\\(z24l{z29-z24}..z26r)
 --z22l
 -- % ---z21l..z21r---
 z22r
 --subpath (t,0) of\\(z23l{z29-z23}..z25r)
 --z23r{z29-z23}..z20 & cycle;  % right arrowhead
pickup rule.nib;
numeric t; path p; p=z2{down}..{z1-z4}z1;
t=xpart(p intersectiontimes(z12l--z12r)); 
draw subpath (0,t) of\\(z2{down}..{z1-z4}z1);  % left arm
draw subpath (0,t) of\\(z2{down}..{z3-z4}z3);  % right arm
currentpicture:= currentpicture yscaled -1 shifted (0,h-d);
endchar;

iff known nnw_arrow: cmchar "Northnorthwest arrow";
beginchar(nnw_arrow,11u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup crisp.nib;
x1+.5rule_thickness=hround(w-u); lft x0=hround 3u;  % This 3u used to be a u in
y1+.5rule_thickness=h; bot y0=-d;                   % the program for swarrow.
                                                    % 3u (with width 11u) gives
                                                    % arrow parallel to langle.
numeric theta,delta; theta=angle(z1-z0); delta=3u++.24asc_height;
if abs(theta-45)<2.5: theta:=45; y1:=y0+x1-x0; fi % near-45$^\circ$ angle
pos1(rule_thickness,-90+theta); pos2(rule_thickness,-90+theta);
pos3(bar,-180+theta); pos4(bar,-180+theta);
    %y3=y0; x4=x0; x3-x0=y4-y0=delta+eps;
y10=y0; x11=x0; x10-x0=y11-y0=delta+eps;   % Can now do arrows of any angle
z3=z10 rotatedaround(z0,theta-45);
z4=z11 rotatedaround(z0,theta-45);
pos5(bar,theta+45); z5l=z0; pos6(bar,theta-45); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes (z1l--(z1l+2(z0-z1)))); z2l=point t of p;
filldraw z0..{z4-z9}z4r
 --subpath (0,t) of\\(z4l{z9-z4}..z6r)
 --z2l---z1l..z1r---z2r
 --subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem
currentpicture:= currentpicture yscaled -1 shifted (0,h-d);
endchar;

iff known nne_arrow: cmchar "Northnortheast arrow";
beginchar(nne_arrow,11u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup crisp.nib;
x1-.5rule_thickness=hround u; rt x0=hround(w-3u);
y1+.5rule_thickness=h; bot y0=-d;
numeric theta,delta; theta=angle(z0-z1); delta=3u++.24asc_height;
if abs(theta+45)<2.5: theta:=-45; y1:=y0+x0-x1; fi % near-45$^\circ$ angle
pos1(rule_thickness,90+theta); pos2(rule_thickness,90+theta);
pos3(bar,theta); pos4(bar,theta);
   %x3=x0; y4=y0; y3-y0=x0-x4=delta+eps;
x10=x0; y11=y0; y10-y0=x0-x11=delta+eps;
z3=z10 rotatedaround(z0,theta+45);
z4=z11 rotatedaround(z0,theta+45);
pos5(bar,theta+225); z5l=z0; pos6(bar,theta+135); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes (z1l--(z1l+2(z0-z1)))); z2l=point t of p;
filldraw z0..{z4-z9}z4r
 --subpath (0,t) of\\(z4l{z9-z4}..z6r)
 --z2l---z1l..z1r---z2r
 --subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem
currentpicture:= currentpicture yscaled -1 shifted (0,h-d);
endchar;

iff known left_slice: cmchar "Left slice";
beginarithchar(left_slice); pickup rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; y8-y2 = .5(x2-x6);
circle_points;    % circle
draw z1--z6--z3;  % lessthan
draw z1..z2..z3;  % arc
labels(1,2,3,4,5,6,7,8); endchar;

iff known right_slice: cmchar "Right slice";
beginarithchar(right_slice); pickup rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; y8-y2 = .5(x2-x6);
circle_points;    % circle
draw z5--z2--z7;  % greaterthan
draw z5..z6..z7;  % arc
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_less_than: cmchar "Circular circle-lessthan operator";
begincircle(var_o_less_than);
draw z1--z6--z3;  % lessthan
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_greater_than: cmchar "Circular circle-greaterthan operator";
begincircle(var_o_greater_than);
draw z5--z2--z7;  % greaterthan
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_vee: cmchar "Circular circle-vee operator";
begincircle(var_o_vee); 
draw z1--z4--z7;  % vee
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_wedge: cmchar "Circular circle-wedge operator";
begincircle(var_o_wedge);
draw z3--z8--z5;  % wedge
labels(1,2,3,4,5,6,7,8); endchar;

iff known tall_oblong: cmchar "Tall oblong (Dijkstra choice symbol)";
beginchar(tall_oblong,9u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;
x1=x2; top y1=h; .5[y1,y2]=math_axis;
x3=x4=w-x1; y3=y1; y4=y2;
compute_spread(.45x_height#,.55x_height#); x3-x1=spread;
draw z1--z2--z4--z3--cycle;  % stems
labels(1,2,3,4); endchar;

iff known interleave:
cmchar "Triple vertical line (interleaving)";
beginchar(interleave,12.5u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;
compute_spread(.45x_height#,.55x_height#); 
x1=x2; top y1=h; .5[y1,y2]=math_axis;
x4=x3; x5=x6=w-x1; y5=y3=y1; y6=y4=y2;
x3-x1=x5-x3=hround spread;
draw z1--z2; draw z3--z4; draw z5--z6;  % stems
labels(1,2,3,4,5,6); endchar;

iff known o_bar: cmchar "Circle-bar operator";
beginarithchar(o_bar); pickup light_rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; top y8=h;
circle_points; draw_circle;  % circle
draw z4--z8;  % bar
labels(1,2,3,4,5,6,7,8); endchar;

iff known o_bslash: cmchar "Circle-backslash operator";
beginarithchar(o_bslash); pickup light_rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; top y8=h;
circle_points; draw_circle;  % circle
draw z3--z7;  % diagonal
labels(1,2,3,4,5,6,7,8); endchar;

iff known o_less_than: cmchar "Circle-lessthan operator";
beginarithchar(o_less_than); pickup light_rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; top y8=h;
circle_points; draw_circle;  % circle
draw z1--z6--z3;  % lessthan
labels(1,2,3,4,5,6,7,8); endchar;

iff known o_greater_than: cmchar "Circle-greaterthan operator";
beginarithchar(o_greater_than); pickup light_rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; top y8=h;
circle_points; draw_circle;  % circle
draw z5--z2--z7;  % greaterthan
labels(1,2,3,4,5,6,7,8); endchar;

iff known o_vee: cmchar "Circle-vee operator";
beginarithchar(o_vee); pickup light_rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; top y8=h;
circle_points; draw_circle;  % circle
draw z1--z4--z7;  % vee
labels(1,2,3,4,5,6,7,8); endchar;

iff known o_wedge: cmchar "Circle-wedge operator";
beginarithchar(o_wedge); pickup light_rule.nib; autorounded;
lft x6=hround u; x2=w-x6; y2=math_axis; top y8=h;
circle_points; draw_circle;  % circle
draw z3--z8--z5;  % wedge
labels(1,2,3,4,5,6,7,8); endchar;

iff known oblong:
cmchar "Oblong (Hoare choice)";
beginchar(oblong,12u#,.8asc_height#,0);
adjust_fit(0,0); pickup rule.nib;
lft x1=hround 1.1u; x2=x1; x4=x5=w-x1;
y1=good.y h+o; bot y2=0; y4=y2; y5=y1;
draw z1---z2---z4---z5--cycle;  % stems and bar
labels(1,2,4,5); endchar;

iff known in_plus: cmchar "Bag element sign";
compute_spread(5/4x_height#,3/2x_height#);
beginchar(in_plus,12u#,v_center(spread#+rule_thickness#));
italcorr h#*slant-u#;
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x2=hround 1.5u-eps; x1=x3=x6=w-x2;
y1-y3=spread; y2=y6=.5[y1,y3]=math_axis;
x4=x5=.5w+u; y4=y1; y5=y3;
draw z1---z4...z2{down}...z5---z3;  % arc and bars
draw z2--z6;  % middle bar
x12=x13=.47[x1,x2]; y12=y1-3rule_thickness+eps; y13=y3+3rule_thickness+eps;
draw z12--z13; % vertical bar
labels(1,2,3,4,5,6,12,13); endchar;

iff known ni_plus: cmchar "Reversed bag element sign";
compute_spread(5/4x_height#,3/2x_height#);
beginchar(ni_plus,12u#,v_center(spread#+rule_thickness#));
italcorr h#*slant-u#;
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x1=hround 1.5u-eps; x1=x3=x6=w-x2;
y1-y3=spread; y2=y6=.5[y1,y3]=math_axis;
x4=x5=.5w-u; y4=y1; y5=y3;
draw z1---z4...z2{down}...z5---z3;  % arc and bars
draw z2--z6;  % middle bar
x12=x13=.47[x1,x2]; y12=y1-3rule_thickness+eps; y13=y3+3rule_thickness+eps;
draw z12--z13; % vertical bar
labels(1,2,3,4,5,6,12,13); endchar;

iff known n_plus: cmchar "Bag intersection";
beginchar(n_plus,12u#,.8asc_height#,0);
italcorr .8asc_height#*slant-.5u#;
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x1=hround u; x2=x1; x3=w-x3; x4=x5=w-x1;
y3=good.y h+o; bot y1=-o; y2=y4=2/3[y1,y3]; y5=y1;
draw z1---z2...z3...z4---z5;  % stems and cap
y8=y9=.47[y1,y3]; x8=w-x9=x1+2rule_thickness+eps;
x6=x7=x3; .5[y6,y7]=y8; y7-y6=x9-x8;
draw z6--z7; draw z8--z9;  % enclosed plus sign
labels(1,2,3,4,5,6,7,8,9); endchar;

iff known sub_set_plus: cmchar "Proper subbag sign";
compute_spread(5/4x_height#,3/2x_height#);
beginchar(sub_set_plus,14u#,v_center(spread#+rule_thickness#));
italcorr h#*slant-u#;
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x2=hround 1.5u-eps; x1=x3=w-x2;
y1-y3=spread; y2=.5[y1,y3]=math_axis;
x4=x5=.5w; y4=y1; y5=y3;
draw z1---z4...z2{down}...z5---z3;  % arc and bars
x12=x13=.40[x1,x2]; y12=y1-3rule_thickness+eps; y13=y3+3rule_thickness+eps;
y10=y11=y2; .5[x10,x11]=x12; x11-x10=y12-y13;
draw z12--z13; draw z10--z11;  % enclosed plus sign
labels(1,2,3,4,5,10,11,12,13); endchar;

iff known sup_set_plus: cmchar "Proper superbag sign";
compute_spread(5/4x_height#,3/2x_height#);
beginchar(sup_set_plus,14u#,v_center(spread#+rule_thickness#));
italcorr h#*slant-u#;
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x1=hround 1.5u-eps; x2=w-x1; x3=x1;
y1-y3=spread; y2=.5[y1,y3]=math_axis;
x4=x5=.5w; y4=y1; y5=y3;
draw z1---z4...z2{down}...z5---z3;  % arc and bars
x12=x13=.40[x1,x2]; y12=y1-3rule_thickness+eps; y13=y3+3rule_thickness+eps;
y10=y11=y2; .5[x10,x11]=x12; x11-x10=y12-y13;
draw z12--z13; draw z10--z11;  % enclosed plus sign
labels(1,2,3,4,5,10,11,12,13); endchar;

iff known sub_set_plus_eq: cmchar "Subbag or equal to sign";
compute_spread(.45x_height#,.55x_height#);
spread#':=spread#; spread':=spread; % the spread of `$=$'
compute_spread(5/4x_height#,3/2x_height#);
beginchar(sub_set_plus_eq,14u#,v_center(spread#'+spread#+rule_thickness#));
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x2=hround 1.5u-eps; x1=x3=w-x2;
y1-y3=spread; y2=.5[y1,y3]; top y1=h;
x4=x5=.5w; y4=y1; y5=y3;
draw z1---z4...z2{down}...z5---z3;  % arc and bars
x8=x1; lft x9=x2; y8=y9; y3-y9=spread'; draw z8--z9;  % lower bar
x12=x13=.40[x1,x2]; y12=y1-3rule_thickness+eps; y13=y3+3rule_thickness+eps;
y10=y11=y2; .5[x10,x11]=x12; x11-x10=y12-y13;
draw z12--z13; draw z10--z11;  % enclosed plus sign
labels(1,2,3,4,5,7,8,10,11,12,13); endchar;

iff known sup_set_plus_eq: cmchar "Superbag or equal to sign";
compute_spread(.45x_height#,.55x_height#);
spread#':=spread#; spread':=spread; % the spread of `$=$'
compute_spread(5/4x_height#,3/2x_height#);
beginchar(sup_set_plus_eq,14u#,v_center(spread#'+spread#+rule_thickness#));
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x1=hround 1.5u-eps; x2=w-x1; x3=x1;
y1-y3=spread; y2=.5[y1,y3]; top y1=h;
x4=x5=.5w; y4=y1; y5=y3;
draw z1---z4...z2{down}...z5---z3;  % arc and bars
x8=x1; rt x9=x2; y8=y9; y3-y9=spread'; draw z8--z9;  % lower bar
x12=x13=.40[x1,x2]; y12=y1-3rule_thickness+eps; y13=y3+3rule_thickness+eps;
y10=y11=y2; .5[x10,x11]=x12; x11-x10=y12-y13;
draw z12--z13; draw z10--z11;  % enclosed plus sign
labels(1,2,3,4,5,7,8,10,11,12,13); endchar;

iff known L_bag: cmchar "Left bag bracket";
beginchar(L_bag,8u#,body_height#,paren_depth#); 
      % ht and dp from "left parenthesis" symbol
adjust_fit(0,0); pickup fine.nib;                
pos0(hair,180); pos1(vair,90); pos2(hair,0); 
pos3(cap_stem,0); pos4(vair,90); pos5(flare,180);
lft x0r=lft x3l=lft x5r=hround u; y0=h-2u;
x1=1/2[x0,x2]; top y1r=h;
x2=2/3[x0,x4]; y2=y0;
y3=0; 
x4=w-x0r; bot y4l=-d;
filldraw stroke z1e{right}..z2e{down}..z3e{down}..{right}z4e; % arc
bulb(1,0,5);
penlabels(0,1,2,3,4,5); endchar;

iff known R_bag: cmchar "Right bag bracket";
beginchar(R_bag,8u#,body_height#,paren_depth#); 
      % ht and dp from "left parenthesis" symbol
adjust_fit(0,0); pickup fine.nib;                
pos0(hair,180); pos1(vair,90); pos2(hair,0); 
pos3(cap_stem,0); pos4(vair,90); pos5(flare,180);
lft x0r=lft x3l=lft x5r=hround u; y0=h-2u;
x1=1/2[x0,x2]; top y1r=h;
x2=2/3[x0,x4]; y2=y0;
y3=0; 
x4=w-x0r; bot y4l=-d;
filldraw stroke z1e{right}..z2e{down}..z3e{down}..{right}z4e; % arc
bulb(1,0,5);
currentpicture:= currentpicture xscaled -1 shifted (w,0);  % OK, so sue me!
endchar;

iff known ll_bracket:
cmchar "Left semantic bracket [[";
beginchar(ll_bracket,7.25u#,body_height#,paren_depth#);
adjust_fit(0,0);
pickup crisp.nib; pos1(rule_thickness,0); pos2(rule_thickness,0);
top y1=h; bot y2=-d; lft x1l=lft x2l=hround(2.5u-.5rule_thickness)-1-eps;
filldraw stroke z1e--z2e;  % left stem
pos7(rule_thickness,0); pos8(rule_thickness,0);
top y7=h; bot y8=-d; lft x7l=lft x8l=hround(4.75u-.5rule_thickness)-1-eps;
filldraw stroke z7e--z8e;  % right stem
pos3(rule_thickness,90); pos4(rule_thickness,90);
pos5(rule_thickness,90); pos6(rule_thickness,90);
x3=x5=x1l; rt x4=rt x6=ceiling(w-.4u)+eps; y3r=y4r=y1; y5l=y6l=y2;
filldraw stroke z3e--z4e;  % upper bar
filldraw stroke z5e--z6e;  % lower bar
penlabels(1,2,3,4,5,6,7,8); endchar;

iff known rr_bracket:
cmchar "Right semantic bracket ]]";
beginchar(rr_bracket,7.25u#,body_height#,paren_depth#);
adjust_fit(0,0);
pickup crisp.nib; pos1(rule_thickness,0); pos2(rule_thickness,0);
top y1=h; bot y2=-d; rt x1r=rt x2r=hround(w-2.5u+.5rule_thickness)+1+eps;
filldraw stroke z1e--z2e;  % left stem
pos7(rule_thickness,0); pos8(rule_thickness,0);
top y7=h; bot y8=-d; rt x7r=rt x8r=hround(w-4.75u+.5rule_thickness)+1+eps;
filldraw stroke z7e--z8e;  % right stem
pos3(rule_thickness,90); pos4(rule_thickness,90);
pos5(rule_thickness,90); pos6(rule_thickness,90);
x3=x5=x1l; lft x4=lft x6=ceiling(.4u)-eps; y3r=y4r=y1; y5l=y6l=y2;
filldraw stroke z3e--z4e;  % upper bar
filldraw stroke z5e--z6e;  % lower bar
penlabels(1,2,3,4,5,6,7,8); endchar;

iff known ll_parenthesis:
cmchar "Left relational image (|";
beginchar(ll_parenthesis,7u#,body_height#,paren_depth#);
italcorr body_height#*slant-.5u#;
adjust_fit(0,0); pickup fine.nib;
pos1(vair,0); pos2(.75[hair,stem],0); pos3(vair,0);
rt x1r=rt x3r=hround(w-u); lft x2l=hround(x1-4u);
top y1=h; y2=.5[y1,y3]=math_axis;
filldraw stroke z1e{3(x2e-x1e),y2-y1}...z2e
 ...{3(x3e-x2e),y3-y2}z3e;  % arc
pos4(whatever,45); pos5(whatever,-45); 
rt x4r-lft x4l=rt x5r-lft x5l=rule_thickness;
z4r=z1r; z5r=z3r;
filldraw stroke z4e--z5e;
penlabels(1,2,3,4,5); endchar;

iff known rr_parenthesis:
cmchar "Right relational image |)";
beginchar(rr_parenthesis,7u#,body_height#,paren_depth#);
italcorr math_axis#*slant-.5u#;
adjust_fit(0,0); pickup fine.nib;
pos1(vair,0); pos2(.75[hair,stem],0); pos3(vair,0);
lft x1l=lft x3l=hround u; rt x2r=hround(x1+4u);
top y1=h; y2=.5[y1,y3]=math_axis;
filldraw stroke z1e{3(x2e-x1e),y2-y1}...z2e
 ...{3(x3e-x2e),y3-y2}z3e;  % arc
pos4(whatever,-45); pos5(whatever,45);
rt x4r-lft x4l=rt x5r-lft x5l=rule_thickness;
z4l=z1l; z5l=z3l;
filldraw stroke z4e--z5e;
penlabels(1,2,3,4,5); endchar;

iff known bin_ampersand:
cmchar "Binary operator ampersand (for linear logic)";
beginarithchar(bin_ampersand); pickup rule.nib; autorounded;
rt x1=hround(w-u)+eps; y1=.5[y2,y5]=math_axis;
x2=.25[x3,x1]; y5-y2=x1-x3;
lft x3=hround u-eps; y3=.45[y2,y1];
x5=.5[x3,x1]; x6=x1; y6=y2+o;
z4=whatever[z2,z5]; z4=z6+whatever*dir 140;
draw z1..z2{left}..z3{up}..z4..tension .85..z5{left}..tension .75..z4---z6;
labels(1,2,3,4,5,6);
endchar;

iff known bin_dnasrepma:
cmchar "Binary operator dnasrepma (for linear logic)";
beginarithchar(bin_dnasrepma); pickup rule.nib; autorounded;
rt x1=hround(w-u)+eps; y1=.5[y2,y5]=math_axis;
x2=.25[x3,x1]; y5-y2=x1-x3;
lft x3=hround u-eps; y3=.45[y2,y1];
x5=.5[x3,x1]; x6=x1; y6=y2+o;
z4=whatever[z2,z5]; z4=z6+whatever*dir 140;
draw z1..z2{left}..z3{up}..z4..tension .85..z5{left}..tension .75..z4---z6;
currentpicture:= currentpicture scaled -1 shifted (w,h-d);
endchar;

iff known triangle_left_eq_slant:
cmchar "Triangular less than or (slanted) equal sign";  
compute_spread(.45x_height#,.55x_height#); 
spread#':=spread#; spread':=spread; 
compute_spread(5/4x_height#,3/2x_height#);  
beginchar(triangle_left_eq_slant,14u#,
   v_center(spread#'+spread#+rule_thickness#)); 
italcorr h#*slant-u#; adjust_fit(0,0); pickup rule.nib;  
lft x2=hround 1.5u-eps; x1=x3=w-x2; y1-y3=spread; 
y2=.5[y1,y3]; y3-y8=y2-y9=spread'; top y1=h; 
x2=x9; x1=x8; 
draw z1--z2--z3--cycle;  % diagonals  
draw z8--z9; % equal sign 
penlabels(1,2,3,8,9); endchar; 

iff known triangle_right_eq_slant:
cmchar "Triangular greater than or (slanted) equal sign"; 
compute_spread(.45x_height#,.55x_height#); 
spread#':=spread#; spread':=spread; 
compute_spread(5/4x_height#,3/2x_height#); 
beginchar(triangle_right_eq_slant,14u#,
   v_center(spread#'+spread#+rule_thickness#)); 
italcorr h#*slant-u#; adjust_fit(0,0); pickup rule.nib;  
rt x2=hround(w-1.5u)+eps; x1=x3=w-x2; y1-y3=spread;  
x2=x9; x1=x8; 
y2=.5[y1,y3]; y3-y8=y2-y9=spread'; top y1=h; 
draw z1--z2--z3--cycle;  % diagonals 
draw z8--z9; 
penlabels(1,2,3,8,9); endchar;  

iff known n_triangle_left_eq_slant:
cmchar "Not triangular less than or (slanted) equal sign";  
compute_spread(.45x_height#,.55x_height#); 
spread#':=spread#; spread':=spread; 
compute_spread(5/4x_height#,3/2x_height#);  
beginchar(n_triangle_left_eq_slant,14u#,
   v_center(spread#'+spread#+rule_thickness#+6u#)); 
italcorr h#*slant-u#; adjust_fit(0,0); pickup rule.nib;  
lft x2=hround 1.5u-eps; x1=x3=w-x2; y1-y3=spread; 
y2=.5[y1,y3]; y3-y8=y2-y9=spread'; top y1=h-3u; 
x2=x9; x1=x8; 
draw z1--z2--z3--cycle;  % diagonals  
draw z8--z9; % equal sign 
char_center(c); x.t=w-3u; y.t=y1+3u;
char_negate(c,t,b);
penlabels(1,2,3,8,9); endchar; 

iff known n_triangle_right_eq_slant:
cmchar "Not triangular greater than or (slanted) equal sign";  
compute_spread(.45x_height#,.55x_height#); 
spread#':=spread#; spread':=spread; 
compute_spread(5/4x_height#,3/2x_height#); 
beginchar(n_triangle_right_eq_slant,14u#,
   v_center(spread#'+spread#+rule_thickness#+6u#)); 
italcorr h#*slant-u#; adjust_fit(0,0); pickup rule.nib;  
rt x2=hround(w-1.5u)+eps; x1=x3=w-x2; y1-y3=spread;  
x2=x9; x1=x8; 
y2=.5[y1,y3]; y3-y8=y2-y9=spread'; top y1=h-3u; 
draw z1--z2--z3--cycle;  % diagonals 
draw z8--z9; 
char_center(c); x.t=w-3u; y.t=y1+3u;
char_negate(c,t,b);
penlabels(1,2,3,8,9); endchar;  

iff known ll_floor:
cmchar "Left merge or left double-floor";
beginchar(ll_floor,10u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;
compute_spread(.45x_height#,.55x_height#); 
x1=x2; top y1=h; .5[y1,y2]=math_axis;
x4=x3; rt x5=rt x6=w; y5=y3=y1; y6=y4=y2;
x3-x1=x5-x3=hround spread;
draw z1--z2; draw z3--z4; % stems
draw z2--z6; % horizontal
labels(1,2,3,4,5,6); endchar;

iff known rr_floor:
cmchar "Right merge or right double-floor";
beginchar(rr_floor,10u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;
compute_spread(.45x_height#,.55x_height#); 
x5=x6; top y1=h; .5[y1,y2]=math_axis;
x4=x3; lft x1=lft x2=0; y5=y3=y1; y6=y4=y2;
x3-x1=x5-x3=hround spread;
draw z3--z4; draw z5--z6;  % stems
draw z2--z6; % horizontal
labels(1,2,3,4,5,6); endchar;

iff known ll_ceil:
cmchar "Left double-ceiling";
beginchar(ll_ceil,10u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;
compute_spread(.45x_height#,.55x_height#); 
x1=x2; bot y1=-d; .5[y1,y2]=math_axis;
x4=x3; rt x5=rt x6=w; y5=y3=y1; y6=y4=y2;
x3-x1=x5-x3=hround spread;
draw z1--z2; draw z3--z4; % stems
draw z2--z6; % horizontal
labels(1,2,3,4,5,6); endchar;

iff known rr_ceil:
cmchar "Right double-ceiling";
beginchar(rr_ceil,10u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;
compute_spread(.45x_height#,.55x_height#); 
x5=x6; bot y1=-d; .5[y1,y2]=math_axis;
x4=x3; lft x1=lft x2=0; y5=y3=y1; y6=y4=y2;
x3-x1=x5-x3=hround spread;
draw z3--z4; draw z5--z6;  % stems
draw z2--z6; % horizontal
labels(1,2,3,4,5,6); endchar;

iff known arrow_not:
cmchar "Negated nonexistant arrow";
compute_spread(.45x_height#,.55x_height#);
beginchar(arrow_not,18u#,v_center(spread#+rule_thickness#));
adjust_fit(0,0); pickup crisp.nib;
y3=.24asc_height+eps+math_axis;
char_center(100); top y101=top y3; x101=x100+2u;
char_negate(100,101,102);
zero_width; endchar;

iff known Arrow_not:
cmchar "Negated nonexistant double arrow";
compute_spread(.45x_height#,.55x_height#);
beginchar(Arrow_not,18u#,v_center(spread#+rule_thickness#));
adjust_fit(0,0); pickup rule.nib;
y1-y2=spread; .5[y1,y2]=math_axis;
y3=.24asc_height+eps+y1;
char_center(100); top y101=top y3; x101=x100+1.5u; char_negate(100,101,102);
zero_width; endchar;

iff known Maps_to_char:
cmchar "Maps-To relation";
compute_spread(.45x_height#,.55x_height#);
beginchar(Maps_to_char,14u#,v_center(spread#+rule_thickness#));
% this character should be followed immediately by equals or Rightarrow
adjust_fit(0,0); pickup rule.nib;
lft x1=hround u; x6=x2=x1+.5u; x3=x4=x5=x1;
.5[y1,y5]=.5[y2,y6]=math_axis; y5-y3=y4-y1=.24asc_height+eps; 
y1-y5=y2-y6=spread;
draw z3--z4;  % stem
draw z1--z2;  % top bar stub 
draw z5--z6;  % bottom bar stub 
labels(1,2,3,4,5,6); zero_width; endchar;

iff known maps_from_char:
cmchar "Maps-from relation";
compute_spread(.45x_height#,.55x_height#);
beginchar(maps_from_char,14u#,v_center(spread#+rule_thickness#));
% this character should be preceded immediately by minus or leftarrow
adjust_fit(0,0); pickup rule.nib;
lft x1=hround u; x2=x1+.5u; x3=x4=x1;
y1=y2=math_axis; y1-y3=y4-y1=.24asc_height+eps;
draw z3--z4;  % stem
draw z1--z2;  % bar stub
zero_width; 
currentpicture:= currentpicture xscaled -1;
endchar;

iff known Maps_from_char:
cmchar "Maps-Fromo relation";
compute_spread(.45x_height#,.55x_height#);
beginchar(Maps_from_char,14u#,v_center(spread#+rule_thickness#));
% this character should be preceded immediately by equals or Rightarrow
adjust_fit(0,0); pickup rule.nib;
lft x1=hround u; x6=x2=x1+.5u; x3=x4=x5=x1;
.5[y1,y5]=.5[y2,y6]=math_axis; y5-y3=y4-y1=.24asc_height+eps; 
y1-y5=y2-y6=spread;
draw z3--z4;  % stem
draw z1--z2;  % top bar stub 
draw z5--z6;  % bottom bar stub 
zero_width; 
currentpicture:= currentpicture xscaled -1;
endchar;

iff known left_right_arrow_triangle: 
cmchar "Left-right arrow with triangular heads";
beginchar(left_right_arrow_triangle,18u#,4u#+math_axis#,4u#-math_axis#); 
adjust_fit(0,0); pickup rule.nib;
z1=z2 + whatever*(dir -150); y4=y1=math_axis;
lft x1=hround u-eps; x4=x3=x2;
top y2=h-u; bot y3=-d+u;
z5=z6 + whatever*(dir 150); y8=y5=math_axis;
rt x5=hround(w-u)+eps; x8=x7=x6;
top y6=h-u; bot y7=-d+u;
draw z1--z2--z3--cycle; % left head
draw z5--z6--z7--cycle; % right head
draw z4--z8; % stem
labels(1,2,3,4,5); endchar;

iff known left_arrow_triangle: 
cmchar "Left arrow with triangular head";
beginchar(left_arrow_triangle,18u#,4u#+math_axis#,4u#-math_axis#); 
adjust_fit(0,0); pickup rule.nib;
rt x1=w-u; y1 = math_axis;
z2=z3 + whatever*(dir -150); y5=y2=y1;
lft x2=u; x5=x4=x3;
top y3=h-u; bot y4=-d+u;
draw z1--z5; draw z2--z3--z4--cycle;
labels(1,2,3,4,5); endchar;

iff known right_arrow_triangle: 
cmchar "Right arrow with triangular head";
beginchar(right_arrow_triangle,18u#,4u#+math_axis#,4u#-math_axis#); 
adjust_fit(0,0); pickup rule.nib;
lft x1=u; y1 = math_axis;
z2=z3 + whatever*(dir 150); y5=y2=y1;
rt x2=w-u; x5=x4=x3;
top y3=h-u; bot y4=-d+u;
draw z1--z5; draw z2--z3--z4--cycle;
labels(1,2,3,4,5); endchar;

iff known big_triangle_down:
cmchar "\textstyle triangular join";
beginchar(big_triangle_down,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y1=eps; bot y3=-d; y5=y1;
draw z1--z3--z5--cycle;  % diagonals
labels(1,3,5); endchar;

iff known big_triangle_up:
cmchar "\textstyle triangular meet";
beginchar(big_triangle_up,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y3=0; bot y1=-d-eps; y5=y1;
draw z1--z3--z5--cycle;  % diagonals
labels(1,3,5); endchar;

iff known big_curly_vee:
cmchar "\textstyle big curly vee";
beginchar(big_curly_vee,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y1=eps; bot y3=-d; y5=y1;
draw z1{dir -30}..{down}z3{up}..{dir 30}z5;  % diagonals
labels(1,3,5); endchar;

iff known big_curly_wedge:
cmchar "\textstyle big curly wedge";
beginchar(big_curly_wedge,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y3=0; bot y1=-d-eps; y5=y1;
draw z1{dir 30}..{up}z3{down}..{dir -30}z5;  % diagonals
labels(1,3,5); endchar;

iff known big_sq_cap:
cmchar "\textstyle square set intersection sign";
beginchar(big_sq_cap,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u; x2=x1; x4=x5=w-x1;
top y1=eps; bot y2=-d; y4=y2; y5=y1;
draw z2---z1---z5---z4;  % stems and bar
labels(1,2,4,5); endchar;

iff known big_box:
cmchar "\textstyle box sign";
beginchar(big_box,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u; x2=x1; x4=x5=w-x1;
top y1=eps; bot y2=-d; y4=y2; y5=y1;
draw z1---z2---z4---z5---cycle;  % stems and bar
labels(1,2,4,5); endchar;

iff known big_parallel:
cmchar "\textstyle big parallelism sign";
beginchar(big_parallel,8u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u; x2=x1; x4=x5=w-x1;
top y1=eps; bot y2=-d; y4=y2; y5=y1;
draw z1---z2;  % left line
draw z4---z5;  % right line
labels(1,2,4,5); endchar;

iff known big_interleave:
cmchar "\textstyle big interleaving sign";
beginchar(big_interleave,9u#,0,10/6dh#);
adjust_fit(u#,u#); pickup pencircle scaled stem;
lft x1=hround 0; x2=x1; 
top y1=eps; bot y2=-d; 
x4=x5=x1+2hround(.5w);
y4=y1;y5=y2;
x6=x7=x1+hround(.5w);
y6=y1;y7=y2;
draw z1---z2;  % left line
draw z4---z5;  % right line
draw z6---z7;  % middle line
labels(1,2,4,5,6,7); endchar;

iff known big_triangle_down:
cmchar "\displaystyle triangular join";
beginchar(big_triangle_down+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y1=eps; bot y3=-d; y5=y1;
draw z1--z3--z5--cycle;  % diagonals
labels(1,3,5); endchar;

iff known big_triangle_up:
cmchar "\displaystyle triangular meet";
beginchar(big_triangle_up+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y3=0; bot y1=-d-eps; y5=y1;
draw z1--z3--z5--cycle;  % diagonals
labels(1,3,5); endchar;

iff known big_curly_vee:
cmchar "\displaystyle big curly vee";
beginchar(big_curly_vee+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y1=eps; bot y3=-d; y5=y1;
draw z1{dir -30}..{down}z3{up}..{dir 30}z5;  % diagonals
labels(1,3,5); endchar;

iff known big_curly_wedge:
cmchar "\displaystyle big curly wedge";
beginchar(big_curly_wedge+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u-eps; x3=w-x3; x5=w-x1;
top y3=0; bot y1=-d-eps; y5=y1;
draw z1{dir 30}..{up}z3{down}..{dir -30}z5;  % diagonals
labels(1,3,5); endchar;

iff known big_sq_cap:
cmchar "\displaystyle square set union sign";
beginchar(big_sq_cap+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u; x2=x1; x4=x5=w-x1;
top y1=eps; bot y2=-d; y4=y2; y5=y1;
draw z2---z1---z5---z4;  % stems and bar
labels(1,2,4,5); endchar;

iff known big_box:
cmchar "\displaystyle box sign";
beginchar(big_box+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u; x2=x1; x4=x5=w-x1;
top y1=eps; bot y2=-d; y4=y2; y5=y1;
draw z1---z2---z4---z5---cycle;  % stems and bar
labels(1,2,4,5); endchar;

iff known big_parallel:
cmchar "\displaystyle big parallelism sign";
beginchar(big_parallel+8,10u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u; x2=x1; x4=x5=w-x1;
top y1=eps; bot y2=-d; y4=y2; y5=y1;
draw z1---z2;  % left line
draw z4---z5;  % right line
labels(1,2,4,5); endchar;

iff known big_interleave:
cmchar "\displaystyle big interleaving sign";
beginchar(big_interleave+8,13u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(u#,u#); pickup pencircle scaled curve;
lft x1=hround 0; x2=x1; 
top y1=eps; bot y2=-d; 
x4=x5=x1+2hround(.5w);
y4=y1;y5=y2;
x6=x7=x1+hround(.5w);
y6=y1;y7=y2;
draw z1---z2;  % left line
draw z4---z5;  % right line
draw z6---z7;  % middle line
labels(1,2,4,5,6,7); endchar;

iff known big_n_plus:
cmchar "\textstyle multiset intersection sign";
beginchar(big_n_plus,15u#,0,10/6dh#);
adjust_fit(0,0); pickup pencircle scaled stem;
lft x1=hround u; x2=x1; x3=w-x3; x4=x5=w-x1;
top y3=0; bot y1=-d-eps; y2=y4=2/3[y1,y3]; y5=y1;
draw z1---z2...z3...z4---z5;  % stems and cap
y8=y9=.47[y1,y3]; x8=w-x9=x1+2stem+eps; x6=x7=x3;
.5[y6,y7]=y8; y7-y6=x9-x8; draw z8--z9; draw z6--z7;  % enclosed `$+$'
labels(1,2,3,4,5,6,7,8,9); endchar;

iff known big_ll_bracket:
cmchar "\big left semantic bracket";
beginchar(big_ll_bracket,8u#,rule_thickness#,2dh#-rule_thickness#);
adjust_fit(1.5u#,0); left_semantic_bracket(rule_thickness,true,true); endchar;

iff known big_ll_bracket:
cmchar "\Big left semantic bracket";
beginchar(big_ll_bracket+1,8.5u#,rule_thickness#,3dh#-rule_thickness#);
adjust_fit(2u#,0); left_semantic_bracket(.25[rule_thickness,stem],true,true); endchar;

iff known big_ll_bracket:
cmchar "\bigg left semantic bracket";
beginchar(big_ll_bracket+2,9u#,rule_thickness#,4dh#-rule_thickness#);
adjust_fit(2.5u#,0); left_semantic_bracket(.5[rule_thickness,stem],true,true); endchar;

iff known big_ll_bracket:
cmchar "\Bigg left semantic bracket";
beginchar(big_ll_bracket+3,9.5u#,rule_thickness#,5dh#-rule_thickness#);
adjust_fit(3u#,0); left_semantic_bracket(.75[rule_thickness,stem],true,true); endchar;

iff known big_ll_bracket:
cmchar "Extensible left semantic bracket---top";
beginchar(big_ll_bracket+4,10u#,rule_thickness#,3dh#-rule_thickness#);
adjust_fit(4u#,0); pickup crisp.nib;
pos1(stem,0); pos2(stem,0);
top y1=h-1; y2=-d-eps; lft x1l=lft x2l=hround(2.5u-.5stem);
filldraw stroke z1e--z2e;  % stem1
pos3(stem,90); pos4(stem,90);
x3=x1l; rt x4=hround(w-.75u+.5stem); y3r=y4r=y1;
filldraw stroke z3e--z4e;  % upper bar
pos7(stem,0); pos8(stem,0);
y7=y1; y8=y2; x7=x8=0.5(x1+x4);
filldraw stroke z7e--z8e;  % stem2
penlabels(1,2,3,4,7,8); endchar;

iff known big_ll_bracket:
cmchar "Extensible left semantic bracket---bottom";
beginchar(big_ll_bracket+5,10u#,rule_thickness#,3dh#-rule_thickness#);
adjust_fit(4u#,0); pickup crisp.nib;
pos1(stem,0); pos2(stem,0);
y1=h+eps; bot y2=1-d; lft x1l=lft x2l=hround(2.5u-.5stem);
filldraw stroke z1e--z2e;  % stem1
pos5(stem,90); pos6(stem,90);
x5=x1l; rt x6=hround(w-.75u+.5stem); y5l=y6l=y2;
filldraw stroke z5e--z6e;  % lower bar
pos7(stem,0); pos8(stem,0);
y7=y1; y8=y2; x7=x8=0.5(x1+x6);
filldraw stroke z7e--z8e;  % stem2
penlabels(1,2,5,6); endchar;

iff known big_ll_bracket:
cmchar "Extensible left semantic bracket---extension module";
beginchar(big_ll_bracket+6,10u#,0,dh#);
adjust_fit(4u#,0); pickup crisp.nib;
pos1(stem,0); pos2(stem,0);
y1=h+1+eps; bot y2=-d-1-eps; lft x1l=lft x2l=hround(2.5u-.5stem);
filldraw stroke z1e--z2e;  % stem1
rt x6=hround(w-.75u+.5stem);
pos7(stem,0); pos8(stem,0);
y7=y1; y8=y2; x7=x8=0.5(x1+x6);
filldraw stroke z7e--z8e;  % stem2
penlabels(1,2,7,8); endchar;

iff known big_n_plus:
cmchar "\displaystyle multiset intersection sign";
beginchar(big_n_plus+8,20u#,0,14/6dh#); padded 1/6dh#;
adjust_fit(0,0); pickup pencircle scaled curve;
lft x1=hround u; x2=x1; x3=w-x3; x4=x5=w-x1;
top y3=0; bot y1=-d-eps; y2=y4=2/3[y1,y3]; y5=y1;
draw z1---z2...z3...z4---z5;  % stems and cap
y8=y9=.47[y1,y3]; x8=w-x9=x1+2curve+eps; x6=x7=x3;
.5[y6,y7]=y8; y7-y6=x9-x8; draw z8--z9; draw z6--z7;  % enclosed `$+$'
labels(1,2,3,4,5,6,7,8,9); endchar;

iff known big_rr_bracket:
cmchar "\big right semantic bracket";
beginchar(big_rr_bracket,8u#,rule_thickness#,2dh#-rule_thickness#);
adjust_fit(0,1.5u#); right_semantic_bracket(rule_thickness,true,true); endchar;

iff known big_rr_bracket:
cmchar "\Big right semantic bracket";
beginchar(big_rr_bracket+1,8.5u#,rule_thickness#,3dh#-rule_thickness#);
adjust_fit(0,2u#); right_semantic_bracket(.25[rule_thickness,stem],true,true); endchar;

iff known big_rr_bracket:
cmchar "\bigg right semantic bracket";
beginchar(big_rr_bracket+2,9u#,rule_thickness#,4dh#-rule_thickness#);
adjust_fit(0,2.5u#); right_semantic_bracket(.5[rule_thickness,stem],true,true); endchar;

iff known big_rr_bracket:
cmchar "\Bigg right semantic bracket";
beginchar(big_rr_bracket+3,9.5u#,rule_thickness#,5dh#-rule_thickness#);
adjust_fit(0,3u#); right_semantic_bracket(.75[rule_thickness,stem],true,true); endchar;

iff known big_rr_bracket:
cmchar "Extensible right semantic bracket---top";
beginchar(big_rr_bracket+4,10u#,rule_thickness#,3dh#-rule_thickness#);
adjust_fit(0,4u#); pickup crisp.nib;
pos1(stem,0); pos2(stem,0);
top y1=h-1; y2=-d-eps; rt x1r=rt x2r=hround(w-2.5u+.5stem);
filldraw stroke z1e--z2e;  % stem1
pos3(stem,90); pos4(stem,90);
x3=x1r; lft x4=hround(.75u-.5stem); y3r=y4r=y1;
filldraw stroke z3e--z4e;  % upper bar
pos7(stem,0); pos8(stem,0);
y7=y1; y8=y2; x7=x8=0.5(x1+x4);
filldraw stroke z7e--z8e;  % stem2
penlabels(1,2,3,4,7,8); endchar;

iff known big_rr_bracket:
cmchar "Extensible right semantic bracket---bottom";
beginchar(big_rr_bracket+5,10u#,rule_thickness#,3dh#-rule_thickness#);
adjust_fit(0,4u#); pickup crisp.nib;
pos1(stem,0); pos2(stem,0);
y1=h+eps; bot y2=1-d; rt x1r=rt x2r=hround(w-2.5u+.5stem);
filldraw stroke z1e--z2e;  % stem1
pos5(stem,90); pos6(stem,90);
x5=x1r; lft x6=hround(.75u-.5stem); y5l=y6l=y2;
filldraw stroke z5e--z6e;  % lower bar
pos7(stem,0); pos8(stem,0);
y7=y1; y8=y2; x7=x8=0.5(x1+x6);
filldraw stroke z7e--z8e;  % stem2
penlabels(1,2,5,6,7,8); endchar;

iff known big_rr_bracket:
cmchar "Extensible right semantic bracket---extension module";
beginchar(big_rr_bracket+6,10u#,0,dh#);
adjust_fit(0,4u#); pickup crisp.nib;
pos1(stem,0); pos2(stem,0);
y1=h+1+eps; bot y2=-d-1-eps; rt x1r=rt x2r=hround(w-2.5u+.5stem);
filldraw stroke z1e--z2e;  % stem1
lft x6=hround(.75u-.5stem);
pos7(stem,0); pos8(stem,0);
y7=y1; y8=y2; x7=x8=0.5(x1+x6);
filldraw stroke z7e--z8e;  % stem2
penlabels(1,2,7,8); endchar;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmaryba.mf'
then
	echo shar: will not over-write existing file "'stmaryba.mf'"
else
cat << \SHAR_EOF > 'stmaryba.mf'
% Filename: stmabase.mf
% Authors: Jeremy Gibbons and Alan Jeffrey
% Maintained by: Alan Jeffrey
% E-mail: jeffrey@cs.chalmers.se
% Last modified: 24 May 1991

% This is the base file for the St Mary's Road symbol font, stmaryrd.mf.

% Copyright 1991 Jeremy Gibbons and Alan Jeffrey.

% 20 May 1991: Created the base file out of macros from alans.mf,
% galileo.mf and msbm.mf.


% The following stolen from the AMS bsymbols.mf file:

def char_negate(suffix c,t,b) = %c is center point; t is top point; b is bottom
pickup rule.nib;
w-x.t=x.b; y.t-y.c=y.c-y.b; draw z.t--z.b;
penlabels(t,c,b); enddef;
def char_center(suffix c) = % find center of type character
x.c=w/2; y.c=.5[-d,h]; enddef;

% The command to draw semantic brackets:

def left_semantic_bracket(expr breadth,do_top,do_bot) =
 pickup crisp.nib;
 numeric thickness; thickness=hround breadth;
 pos1(thickness,0); pos2(thickness,0);
 top y1=h; bot y2=1-d; lft x1l=lft x2l=hround(2.5u-.5thickness);
 filldraw stroke z1e--z2e;  % stem1
 pos3(thickness,90); pos4(thickness,90);
 pos5(thickness,90); pos6(thickness,90);
 x3=x5=x1l; rt x4=rt x6=hround(w-.75u+.5thickness);
 y3r=y4r=y1; y5l=y6l=y2;
 if do_top: filldraw stroke z3e--z4e; fi  % upper bar
 if do_bot: filldraw stroke z5e--z6e; fi  % lower bar
 pos7(thickness,0); pos8(thickness,0);
 y7=y1; y8=y2; x7=x8=x1+hround(0.5(w - 3.25u));
 filldraw stroke z7e--z8e;  % stem2 
 penlabels(1,2,3,4,5,6,7,8); enddef;

def right_semantic_bracket(expr breadth,do_top,do_bot) =
 pickup crisp.nib;
 numeric thickness; thickness=hround breadth;
 pos1(thickness,0); pos2(thickness,0);
 top y1=h; bot y2=1-d; rt x1r=rt x2r=hround(w-2.5u+.5thickness);
 filldraw stroke z1e--z2e;  % stem1
 pos3(thickness,90); pos4(thickness,90);
 pos5(thickness,90); pos6(thickness,90);
 x3=x5=x1r; lft x4=lft x6=hround(.75u-.5thickness);
 y3r=y4r=y1; y5l=y6l=y2;
 if do_top: filldraw stroke z3e--z4e; fi  % upper bar
 if do_bot: filldraw stroke z5e--z6e; fi  % lower bar
 pos7(thickness,0); pos8(thickness,0);
 y7=y1; y8=y2; x7=x8=x1-hround(0.5(w - 3.25u));
 filldraw stroke z7e--z8e;  % stem2 
 penlabels(1,2,3,4,5,6,7,8); enddef;

% The command to draw a circle (with free symmetry hacks):

def begincircle (expr n) =
   beginarithchar(n);
      pickup rule.nib; 
      if .5w <> good.x .5w: change_width; fi
      lft x6=hround u-eps; x2=w-x6; y2=math_axis; y8-y2 = .5(x2-x6);
      circle_points; draw_circle  % circle
enddef;

% And to draw a box (with free symmetry hacks):

def beginbox (expr n) =
   beginarithchar(n); 
      pickup rule.nib; 
      if .5w <> good.x .5w: change_width; fi
      lft x1=hround 1.5u-eps; x2=w-x1; x3=x2; x4=x1;
      y1-y4 = x2-x1; .5[y1,y4]=math_axis; y1=y2; y3=y4;
      draw z1--z2--z3--z4--cycle; % box
enddef
SHAR_EOF
fi # end of overwriting check
if test -f 'stmarych.mf'
then
	echo shar: will not over-write existing file "'stmarych.mf'"
else
cat << \SHAR_EOF > 'stmarych.mf'
% Filename: stmarych.mf
% Authors: Jeremy Gibbons and Alan Jeffrey
% Maintained by: Alan Jeffrey
% E-mail: jeffrey@cs.chalmers.se
% Last modified: 24 May 1991

% Defines the character positions and extension information for the St
% Mary's Road font, stmaryrd.mf.

% Copyright 1991 Jeremy Gibbons and Alan Jeffrey.

% 20 May 1991: Created the file out of which.mf, which performed a
% similar job for alans.mf and galileo.mf.

% 21 May 1991: Renamed some of the characters to be more AMSy.

short_left_arrow                := 0;
short_right_arrow               := 1;
short_up_arrow                  := 2;
short_down_arrow                := 3;

Y_up                            := 4;
Y_down                          := 5;
Y_left                          := 6;
Y_right                         := 7;

var_curly_vee                   := 8;
var_curly_wedge                 := 9;

minus_o                         := 10;
bar_o                           := 11;

sslash                          := 12;
bbslash                         := 13;

moo                             := 14;

var_o_times                     := 15;
var_o_ast                       := 16;
var_o_bar                       := 17;
var_o_dot                       := 18;
var_o_slash                     := 19;
var_o_bslash                    := 20;
var_o_circle                    := 21;
var_o_plus                      := 22;
var_o_minus                     := 23;

box_ast                         := 24;
box_bar                         := 25;
box_dot                         := 26;
box_slash                       := 27;
box_bslash                      := 28;
box_circle                      := 29;
box_box                         := 30;
box_empty                       := 31;

lightning                       := 32;
merge                           := 33;
var_times                       := 34;

fat_semi                        := 35;

ssw_arrow                       := 36;
sse_arrow                       := 37;

curly_wedge_up_arrow            := 38;
curly_wedge_down_arrow          := 39;

fat_slash                       := 40;
fat_bslash                      := 41;

l_bag                           := 42;
r_bag                           := 43;

var_big_circ                    := 44;

left_right_arrow_eq             := 45;

curly_vee_down_arrow            := 46;
curly_vee_up_arrow              := 47;

nnw_arrow                       := 48;
nne_arrow                       := 49;

left_slice                      := 50;
right_slice                     := 51;

var_o_less_than                 := 52;
var_o_greater_than              := 53;
var_o_vee                       := 54;
var_o_wedge                     := 55;

tall_oblong                     := 56;
interleave                      := 57;

o_bar                           := 58;
o_bslash                        := 59;
o_less_than                     := 60;
o_greater_than                  := 61;
o_vee                           := 62;
o_wedge                         := 63;

oblong                          := 64;

in_plus                         := 65;
ni_plus                         := 66;
n_plus                          := 67;
sub_set_plus                    := 68;
sup_set_plus                    := 69;
sub_set_plus_eq                 := 70;
sup_set_plus_eq                 := 71;

L_bag                           := 72;
R_bag                           := 73;
ll_bracket                      := 74;
rr_bracket                      := 75;
ll_parenthesis                  := 76;
rr_parenthesis                  := 77;

bin_ampersand                   := 78;
bin_dnasrepma                   := 79;

triangle_left_eq_slant          := 80;
triangle_right_eq_slant         := 81;
n_triangle_left_eq_slant        := 82;
n_triangle_right_eq_slant       := 83;

ll_floor                        := 84;
rr_floor                        := 85;

ll_ceil                         := 86;
rr_ceil                         := 87;

arrow_not                       := 88;
Arrow_not                       := 89;

Maps_to_char                    := 90;
maps_from_char                  := 91;
Maps_from_char                  := 92;

left_right_arrow_triangle       := 93;
left_arrow_triangle             := 94;
right_arrow_triangle            := 95;

big_triangle_down               := 96;
big_triangle_up                 := 97;
big_curly_vee                   := 98;
big_curly_wedge                 := 99;
big_sq_cap                      := 100;
big_box                         := 101;
big_parallel                    := 102;
big_interleave                  := 103;

big_n_plus                      := 112;

big_ll_bracket                  := 113;
big_rr_bracket                  := 121;

charlist big_sq_cap: big_sq_cap+8;
charlist big_box: big_box+8;
charlist big_parallel: big_parallel+8;
charlist big_interleave: big_interleave+8;
charlist big_n_plus: big_n_plus+8;
charlist big_triangle_down: big_triangle_down+8;
charlist big_triangle_up: big_triangle_up+8;
charlist big_curly_vee: big_curly_vee+8;
charlist big_curly_wedge: big_curly_wedge+8; 

charlist big_ll_bracket: 
   big_ll_bracket+1: big_ll_bracket+2: big_ll_bracket+3: big_ll_bracket+4;
extensible big_ll_bracket+4:
   big_ll_bracket+4,0,big_ll_bracket+5,big_ll_bracket+6;
charlist big_rr_bracket: 
   big_rr_bracket+1: big_rr_bracket+2: big_rr_bracket+3: big_rr_bracket+4;
extensible big_rr_bracket+4:
   big_rr_bracket+4,0,big_rr_bracket+5,big_rr_bracket+6;  

SHAR_EOF
fi # end of overwriting check
if test -f 'stmaryjg.mf'
then
	echo shar: will not over-write existing file "'stmaryjg.mf'"
else
cat << \SHAR_EOF > 'stmaryjg.mf'
% Filename: stmaryjg.mf
% Author: Jeremy Gibbons
% Maintained by: Alan Jeffrey
% Email: jeffrey@cs.chalmers.se
% Last modified: 24 May 1991.

% These are Jeremy's symbols for the St Mary's Road font, stmaryrd.mf.

% Copyright 1991 Alan Jeffrey.

% 20 May 1991: Created the file from galileo.mf.

iff known short_left_arrow: cmchar "Short leftwards arrow";
compute_spread(.45x_height#,.55x_height#);
beginchar(short_left_arrow,14u#,v_center(spread#+rule_thickness#));
adjust_fit(0,0); pickup crisp.nib;
pos1(rule_thickness,90); pos2(rule_thickness,90); pos3(bar,0); pos4(bar,0);
y0=y1=y2=math_axis; x1+.5rule_thickness=hround(w-u); lft x0=hround u;
y3-y0=y0-y4=.24asc_height+eps; x3=x4=x0+3u+eps;
pos5(bar,angle(z4-z0)); z5l=z0; pos6(bar,angle(z3-z0)); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4r{z9-z4}..z6r;
t=xpart(p intersectiontimes((0,y2l)--(w,y2l))); x2=xpart point t of p;
filldraw z0..{z4-z9}z4l--subpath (0,t) of\\(z4r{z9-z4}..z6r)
 --z2l---z1l..z1r---z2r--subpath (t,0) of\\(z3r{z9-z3}..z5r)
 --z3l{z9-z3}..z0 & cycle;  % arrowhead and stem
penlabels(0,1,2,3,4,5,6,9); 
endchar;

iff known short_right_arrow: cmchar "Short rightwards arrow";
compute_spread(.45x_height#,.55x_height#);
beginchar(short_right_arrow,14u#,v_center(spread#+rule_thickness#));
adjust_fit(0,0); pickup crisp.nib;
pos1(rule_thickness,90); pos2(rule_thickness,90); pos3(bar,0); pos4(bar,0);
y0=y1=y2=math_axis; x1-.5rule_thickness=hround u; rt x0=hround(w-u);
y3-y0=y0-y4=.24asc_height+eps; x3=x4=x0-3u-eps;
pos5(bar,angle(z4-z0)); z5l=z0; pos6(bar,angle(z3-z0)); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes((0,y2l)--(w,y2l))); x2=xpart point t of p;
filldraw z0..{z4-z9}z4r--subpath (0,t) of\\(z4l{z9-z4}..z6r)
 --z2l---z1l..z1r---z2r--subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem
penlabels(0,1,2,3,4,5,6,9); 
endchar;

iff known short_up_arrow: cmchar "Upward arrow";
beginchar(short_up_arrow,9u#,
   if monospace: 27/7u#+math_axis#,27/7u#-math_axis#
           else: 6u#+math_axis#,6u#-math_axis#
   fi);
italcorr .76asc_height#*slant+.5crisp#-u#;
adjust_fit(0,0); pickup crisp.nib;
pos1(rule_thickness,0); pos2(rule_thickness,0);
pos3(bar,90); pos4(bar,90);
lft x1l=hround(.5w-.5rule_thickness); y1-.5rule_thickness=-d;
x0=x1=x2; top y0=h; x0-x3=x4-x0=3u+eps;
y3=y4=y0-.24asc_height-eps;
pos5(bar,angle(z4-z0)); z5l=z0;
pos6(bar,angle(z3-z0)); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes((x2r,-d)--(x2r,h))); y2=ypart point t of p;
filldraw z0..{z4-z9}z4r--subpath (0,t) of\\(z4l{z9-z4}..z6r)
 --z2r---z1r..z1l---z2l--subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem
penlabels(0,1,2,3,4,5,6,9); endchar;

iff known short_down_arrow: cmchar "Downward arrow";
beginchar(short_down_arrow,9u#,
   if monospace: 27/7u#+math_axis#,27/7u#-math_axis#
           else: 6u#+math_axis#,6u#-math_axis#
   fi);
italcorr .76asc_height#*slant+.5crisp#-u#;
adjust_fit(0,0); pickup crisp.nib;
pos1(rule_thickness,0); pos2(rule_thickness,0);
pos3(bar,90); pos4(bar,90);
lft x1l=hround(.5w-.5rule_thickness); y1+.5rule_thickness=h;
x0=x1=x2; bot y0=-d; x0-x3=x4-x0=3u+eps;
y3=y4=y0+.24asc_height+eps;
pos5(bar,angle(z4-z0)); z5l=z0;
pos6(bar,angle(z3-z0)); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4r{z9-z4}..z6r;
t=xpart(p intersectiontimes((x2r,-d)--(x2r,h))); y2=ypart point t of p;
filldraw z0..{z4-z9}z4l--subpath (0,t) of\\(z4r{z9-z4}..z6r)
 --z2r---z1r..z1l---z2l--subpath (t,0) of\\(z3r{z9-z3}..z5r)
 --z3l{z9-z3}..z0 & cycle;  % arrowhead and stem
penlabels(0,1,2,3,4,5,6,9); endchar;

iff known Y_up: cmchar "Fork (upside-down Y)";
beginchar(Y_up,10u#,6u#+math_axis#,5u#-math_axis#); pickup rule.nib;
adjust_fit(0,0);
x1=.5w; top y1=h-u;
x2=x1; y2=math_axis;
lft x3=u; rt x4=w-u; bot y3 = -d+u; y4=y3;
draw z1--z2; draw z3--z2--z4;
labels(1,2,3,4); endchar;

iff known Y_down: cmchar "Join (Y)";
beginchar(Y_down,10u#,5u#+math_axis#,6u#-math_axis#); pickup rule.nib;
adjust_fit(0,0);
x1=.5w; bot y1=-d+u;
x2=x1; y2=math_axis;
lft x3=u; rt x4=w-u; top y3 = h-u; y4=y3;
draw z1--z2; draw z3--z2--z4;
labels(1,2,3,4); endchar;

iff known Y_left: cmchar "Leftwards pointing Y -<";
beginchar(Y_left,11u#,5u#+math_axis#,5u#-math_axis#); pickup rule.nib;
adjust_fit(0,0);
lft x1=hround u; x2=6u; y1=y2=vround math_axis;
rt x3=rt x4=hround(w-u); top y3=vround(h-u)+eps; bot y4=vround(u-d)+eps;
draw z1--z2; draw z3--z2--z4;
labels(1,2,3,4); endchar;

iff known Y_right: cmchar "Rightwards pointing Y >-";
beginchar(Y_right,11u#,5u#+math_axis#,5u#-math_axis#); pickup rule.nib;
adjust_fit(0,0);
rt x1=hround(w-u); x2=5u; y1=y2=vround math_axis;
lft x3=lft x4=hround u; top y3=vround(h-u)+eps; bot y4=vround(u-d)+eps;
draw z1--z2; draw z3--z2--z4;
labels(1,2,3,4); endchar;

iff known var_curly_vee: cmchar "Zipwith symbol";  
beginchar(var_curly_vee,12u#,asc_height#,asc_depth#);     
adjust_fit(0,0); pickup rule.nib;
x2=good.x .5w; w:=r:=2x2;
lft x1=0; x3=w-x1;
top y1=h; bot y2=-d-o; y3=y1;
x4=x2; y4=x_height;
draw z1{z4-z1}..{down}z2;  % left arm
draw z3{z4-z3}..{down}z2;  % right arm
labels(1,2,3,4); endchar;

iff known var_curly_wedge: cmchar "Upside-down zipwith symbol";  
beginchar(var_curly_wedge,12u#,asc_height#,asc_depth#);     
adjust_fit(0,0); pickup rule.nib;
x2=good.x .5w; w:=r:=2x2;
lft x1=0; x3=w-x1;
top y2=h; bot y1=-d-o; y3=y1;
x4=x2; y4=h-(x_height+d);
draw z1{z4-z1}..{up}z2;  % left arm
draw z3{z4-z3}..{up}z2;  % right arm
labels(1,2,3,4); endchar;

iff known minus_o: cmchar "Above sign";    % Parts nicked from "plus"
beginchar(minus_o,14u#,5u#+math_axis#,5u#-math_axis#); pickup rule.nib;
adjust_fit(0,0);
%x11=x12=good.x .5w; top y11=h+eps; .5[y11,y12]=math_axis;
lft x13=hround u-eps; x14=w-x13; y13=y14=math_axis;
%draw z11--z12;  % stem
draw z13--z14;  % crossbar
top y8=vround h-u-eps; y8-math_axis = math_axis-y4; x4=.5w; .5(y8-y4) = x2-x4;
circle_points; draw_circle;  % circle
labels(1,2,3,4,5,6,7,8,13,14); endchar;

iff known bar_o: cmchar "Beside sign";
beginchar(bar_o,10u#,6u#+math_axis#,6u#-math_axis#); pickup rule.nib;
adjust_fit(0,0);
x11=x12=good.x .5w; top y11=h+eps; .5[y11,y12]=math_axis;
%lft x3=hround u-eps; x4=w-x3; y3=y4=math_axis;
draw z11--z12;  % stem
%draw z3--z4;  % crossbar
lft x6=hround u; x2=w-x6; y2=math_axis; y8-y2 = .5(x2-x6);
circle_points; draw_circle;  % circle
penlabels(1,2,3,4,5,6,7,8,11,12); endchar;

iff known sslash: cmchar "Double forwards slash";
beginchar(sslash,9u#+slash_separation#,body_height#, paren_depth#);
adjust_fit(0,0); pickup rule.nib;
lft x2=hround u-eps; bot y4=bot y2=-d-eps;
rt x3=hround(w-u)+eps; top y3=top y1= h+eps;
x1=x3-hround slash_separation;
x4=x2+hround slash_separation;
draw z1--z2; draw z3--z4;
penlabels(1,2,3,4);
endchar;

iff known bbslash: cmchar "Double backwards slash";
beginchar(bbslash,9u#+slash_separation#,body_height#, paren_depth#);
adjust_fit(0,0); pickup rule.nib;
lft x2=hround u-eps; bot y3=bot y1=-d-eps;
rt x3=hround(w-u)+eps; top y4=top y2= h+eps;
x1=x3-hround slash_separation;
x4=x2+hround slash_separation;
draw z1--z2; draw z3--z4;
penlabels(1,2,3,4);
endchar;

iff known moo: cmchar "Moo (Chinese for `tree')";
beginarithchar(moo); pickup rule.nib;
if .5w <> good.x .5w: change_width; fi
x1= .5w; y1-y3=y3-y7; 
lft x3=hround 2u-eps; x4=w-x3; y3=y4=math_axis;
z2 = .5[z3,z4];
lft x5=hround 2u-eps; x6=w-x5; y6=y5=.3[y7,y3];
x7 = .4[x5,x1]; x8=w-x7; bot y7 = vround -o; y8=y7;
draw z1--z2{down}..z7{left}..z5;  % left leg
draw z1--z2{down}..z8{right}..z6;  % right leg
draw z3--z4;  % crossbar
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_times: cmchar "Circular circle-times operator";
begincircle(var_o_times);
draw z1--z5; draw z3--z7;  % diagonals
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_ast: cmchar "Circular circle-asterisk operator";
begincircle(var_o_ast);
z0=.5[z2,z6]; % centre of circle
numeric ast_flare; ast_flare=hround .7[thin_join,stem];
for d=-150 step 60 until 150: z[d]=z0+.7dir d scaled (y8-y2); % ie scaled radius
 numeric theta; theta=angle(z[d]-z0);
 fill z0+.5(0,-thin_join)rotated theta
  ---z[d]+.5(-ast_flare,-ast_flare)rotated theta
  ..z[d]..z[d]+.5(-ast_flare,ast_flare)rotated theta
  ---z0+.5(0,thin_join)rotated theta--cycle; endfor  % diagonal at angle |d|
labels(0,[-150],[-90],[-30],30,90,150,1,2,3,4,5,6,7,8); endchar;

iff known var_o_bar: cmchar "Circular circle-bar operator";
begincircle(var_o_bar);
draw z4--z8;  % bar
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_dot: cmchar "Circle-dot operator";
begincircle(var_o_dot);
fill fullcircle scaled(1.3dot_size+eps) shifted(.5[z4,z8]);  % dot
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_slash: cmchar "Circular circle-slash operator";
begincircle(var_o_slash); 
draw z1--z5;  % diagonal
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_bslash: cmchar "Circular circle-backslash operator";
begincircle(var_o_bslash);
draw z3--z7;  % diagonal
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_circle: cmchar "Circular circle-circle operator";
begincircle(var_o_circle);
z0=.5[z2,z6]; % centre of circle
for i = 1 upto 8:
   z[i+8]=.5[z0,z[i]];
endfor;
draw z16{right}...z9{z10-z16}...z10{down}...z11{z12-z10}...z12{left}
  ...z13{z14-z12}...z14{up}...z15{z16-z14}...cycle; % inner circle
labels(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16); endchar;

iff known var_o_plus: cmchar "Circular circle-plus operator";
begincircle(var_o_plus); 
draw z2--z6; draw z4--z8;  % bar and stem
labels(1,2,3,4,5,6,7,8); endchar;

iff known var_o_minus: cmchar "Circular circle-minus operator";
begincircle(var_o_minus);
draw z2--z6;  % bar
labels(1,2,3,4,5,6,7,8); endchar;

% Changed hround to floor in the following to make sure that x1<>x2,
% otherwise theta ends up being angle(0,0).   AJ.

iff known box_ast: cmchar "Box_ast operator";
beginbox(box_ast);
z0=.5[z1,z3];
numeric ast_flare; ast_flare=hround .7[thin_join,stem];
for d=-150 step 60 until 150: z[d]=z0+.7dir d scaled .5(x2-x1); % ie scaled `radius'
 numeric theta; theta=angle(z[d]-z0);
 fill z0+.5(0,-thin_join)rotated theta
  ---z[d]+.5(-ast_flare,-ast_flare)rotated theta
  ..z[d]..z[d]+.5(-ast_flare,ast_flare)rotated theta
  ---z0+.5(0,thin_join)rotated theta--cycle; endfor  % diagonal at angle |d|
labels(0,[-150],[-90],[-30],30,90,150,1,2,3,4); endchar; 

iff known box_bar: cmchar "Box_bar operator";
beginbox(box_bar);
draw .5[z1,z2]--.5[z3,z4];
labels(1,2,3,4); endchar; 

iff known box_dot: cmchar "Box_dot operator";
beginbox(box_dot);
fill fullcircle scaled(1.3dot_size+eps) shifted(.5[z1,z3]);  % dot
labels(1,2,3,4); endchar; 

iff known box_slash: cmchar "Box_slash operator";
beginbox(box_slash);
draw z2--z4;
labels(1,2,3,4); endchar; 

iff known box_bslash: cmchar "Box_bslash operator";
beginbox(box_bslash); 
draw z1--z3; 
labels(1,2,3,4); endchar; 

iff known box_circle: cmchar "Box_circle operator";
beginarithchar(box_circle); 
if .5w <> good.x .5w: change_width; fi
pickup rule.nib; autorounded;
lft x11=hround 1.5u; x12=w-x11; x13=x12; x14=x11;
y11-y14 = x12-x11; .5[y11,y14]=math_axis; y11=y12; y13=y14;
lft x6=hround .25[x11,x12]; x2=w-x6; y2=math_axis; y8-y2 = .5(x2-x6);
circle_points; draw_circle;  % circle
draw z11--z12--z13--z14--cycle; % box
labels(11,12,13,14); endchar; 

iff known box_box: cmchar "Box_box operator";
beginbox(box_box); 
z0=.5[z1,z3];
for i = 1 upto 4: z[i+4]=.4[z0,z[i]]; endfor
draw z5--z6--z7--z8--cycle;
labels(1,2,3,4); endchar; 

iff known box_empty: cmchar "Box operator";
beginbox(box_empty);
labels(1,2,3,4); endchar;   % like LaTeX Box, only with less side bearing

iff known lightning: cmchar "Lightning strike";    % Adapted from sswarrow
beginchar(lightning,11u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup crisp.nib;
x1+.5rule_thickness=hround(w-u); lft x0=hround 3u;
y1+.5rule_thickness=h; bot y0=-d;
numeric theta,delta; theta=angle(z1-z0); delta=3u++.24asc_height;
if abs(theta-45)<2.5: theta:=45; y1:=y0+x1-x0; fi % near-45$^\circ$ angle
pos1(rule_thickness,-90+theta); pos2(rule_thickness,-90+theta);
pos3(bar,-180+theta); pos4(bar,-180+theta);
    %y3=y0; x4=x0; x3-x0=y4-y0=delta+eps;
y10=y0; x11=x0; x10-x0=y11-y0=delta+eps;   % Can now do arrows of any angle
z3=z10 rotatedaround(z0,theta-45);
z4=z11 rotatedaround(z0,theta-45);
pos5(bar,theta+45); z5l=z0; pos6(bar,theta-45); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes (z1l--(z1l+2(z0-z1)))); z2l=point t of p;
filldraw z0..{z4-z9}z4r
 --subpath (0,t) of\\(z4l{z9-z4}..z6r)
 % --z2l---z1l..z1r---z2r
 --subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead
z20=.45[z1,z2];
z21=z22 + .55(z2-z1);
x22=x1-3u; y22=y1;
pickup rule.nib; draw z2--z20--z21--z22; % stem
penlabels(0,1,2,3,4,5,6,9); endchar;

iff known merge: cmchar "Merge symbol";
beginchar(merge,16u#,asc_height#,0);
adjust_fit(0,0); pickup rule.nib;
lft x1=hround 1.1u; x3 = .65[x1,x6]; x2 = .5[x1,x3];
y2=h+o; bot y1=0; y3 = y1;
x6=w-x1; y6=y1;
z4-z1 = z5-z2 = z6-z3;
draw z1---z2---z3;  % left-hand
draw z4--z5--z6;  % right-hand
labels(1,2,3,4,5,6); endchar;

iff known var_times: cmchar "Cartesian Product operator";  % bits of this taken
beginchar(var_times,10u#,asc_height#,0);                   % from "exists"
adjust_fit(0,0); pickup rule.nib;                
lft x1=hround u-eps; x2=x3=w-x1; x4=x1;
top y1=h; bot y4=0; y2=y1; y3=y4;
draw z1--z3; draw z2--z4;  % diagonals
labels(1,2,3,4); endchar;

iff known fat_semi: cmchar "Fat semicolon";
beginchar(fat_semi,6u#,0.5[x_height#,asc_height#],comma_depth#);
adjust_fit(0,0); pickup rule.nib; autorounded;
lft x3=lft x7=hround u; rt x1=rt x5=hround(w-u); x2=x4=x6=x8=w/2;
top y4=h; bot y6=0; y4-y2=y8-y6=x1-x3; y1=y3=0.5[y2,y4];
y5=y7=0.5[y6,y8]; lft x9=2u; bot y9=-d;
draw z1..z2..z3..z4..cycle;
draw z5{down}..z6..z7..z8..z5{down}..{curl 0}z9;
labels(1,2,3,4,5,6,7,8,9); endchar;

iff known ssw_arrow: cmchar "Southsouthwest arrow";
beginchar(ssw_arrow,11u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup crisp.nib;
x1+.5rule_thickness=hround(w-u); lft x0=hround 3u;  % This 3u used to be a u in
y1+.5rule_thickness=h; bot y0=-d;                   % the program for swarrow.
                                                    % 3u (with width 11u) gives
                                                    % arrow parallel to langle.
numeric theta,delta; theta=angle(z1-z0); delta=3u++.24asc_height;
if abs(theta-45)<2.5: theta:=45; y1:=y0+x1-x0; fi % near-45$^\circ$ angle
pos1(rule_thickness,-90+theta); pos2(rule_thickness,-90+theta);
pos3(bar,-180+theta); pos4(bar,-180+theta);
    %y3=y0; x4=x0; x3-x0=y4-y0=delta+eps;
y10=y0; x11=x0; x10-x0=y11-y0=delta+eps;   % Can now do arrows of any angle
z3=z10 rotatedaround(z0,theta-45);
z4=z11 rotatedaround(z0,theta-45);
pos5(bar,theta+45); z5l=z0; pos6(bar,theta-45); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes (z1l--(z1l+2(z0-z1)))); z2l=point t of p;
filldraw z0..{z4-z9}z4r
 --subpath (0,t) of\\(z4l{z9-z4}..z6r)
 --z2l---z1l..z1r---z2r
 --subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem
penlabels(0,1,2,3,4,5,6,9); endchar;

iff known sse_arrow: cmchar "Southsoutheast arrow";
beginchar(sse_arrow,11u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup crisp.nib;
x1-.5rule_thickness=hround u; rt x0=hround(w-3u);
y1+.5rule_thickness=h; bot y0=-d;
numeric theta,delta; theta=angle(z0-z1); delta=3u++.24asc_height;
if abs(theta+45)<2.5: theta:=-45; y1:=y0+x0-x1; fi % near-45$^\circ$ angle
pos1(rule_thickness,90+theta); pos2(rule_thickness,90+theta);
pos3(bar,theta); pos4(bar,theta);
   %x3=x0; y4=y0; y3-y0=x0-x4=delta+eps;
x10=x0; y11=y0; y10-y0=x0-x11=delta+eps;
z3=z10 rotatedaround(z0,theta+45);
z4=z11 rotatedaround(z0,theta+45);
pos5(bar,theta+225); z5l=z0; pos6(bar,theta+135); z6l=z0;
z9=.381966[.5[z3,z4],z0];
numeric t; path p; p=z4l{z9-z4}..z6r;
t=xpart(p intersectiontimes (z1l--(z1l+2(z0-z1)))); z2l=point t of p;
filldraw z0..{z4-z9}z4r
 --subpath (0,t) of\\(z4l{z9-z4}..z6r)
 --z2l---z1l..z1r---z2r
 --subpath (t,0) of\\(z3l{z9-z3}..z5r)
 --z3r{z9-z3}..z0 & cycle;  % arrowhead and stem
penlabels(0,1,2,3,4,5,6,9); endchar;

iff known curly_wedge_up_arrow: 
cmchar "Upwards accumulate symbol"; 
beginchar(curly_wedge_up_arrow,12u#,asc_height#,asc_depth#);
adjust_fit(0,0); pickup rule.nib;
x2=good.x .5w; w:=r:=2x2;
lft x1=0; x3=w-x1;
bot y1=-d; top y2=h+o; y3=y1;
x4=x2; y4=h-(x_height+d);
pickup crisp.nib;
pos11(rule_thickness,0); pos12(rule_thickness,0);     % arrow head nicked from
pos13(bar,90); pos14(bar,90);                         % up_arrow
lft x11l=hround(.5w-.5rule_thickness); y11-.5rule_thickness=-d;
x10=x11=x12; top y10=top y2; x10-x13=x14-x10=3u+eps;
y13=y14=y10-.24asc_height-eps;
pos15(bar,angle(z14-z10)); z15l=z10;
pos16(bar,angle(z13-z10)); z16l=z10;
z19=.381966[.5[z13,z14],z10];
numeric t; path p; p=z14l{z19-z14}..z16r;
t=xpart(p intersectiontimes((x12r,-d)--(x12r,h))); y12=ypart point t of p;
filldraw z10..{z14-z19}z14r--subpath (0,t) of\\(z14l{z19-z14}..z16r)
 --z12r
 -- % ---z11r..z11l---
 z12l--subpath (t,0) of\\(z13l{z19-z13}..z15r)
 --z13r{z19-z13}..z10 & cycle;  % arrowhead
pickup rule.nib;
numeric t; path p; p=z1{z4-z1}..{up}z2;
t=xpart(p intersectiontimes((0,y12)--(w,y12))); 
draw subpath (0,t) of\\(z1{z4-z1}..{up}z2);  % left arm
draw subpath (0,t) of\\(z3{z4-z3}..{up}z2);  % right arm
penlabels(10,11,12,13,14,15,16,19);
labels(1,2,3,4); endchar;

iff known curly_wedge_down_arrow: 
cmchar "Downwards accumulate symbol";
beginchar(curly_wedge_down_arrow,12u#,asc_height#,asc_depth#);                
adjust_fit(0,0); pickup rule.nib;
x2=good.x .5w; w:=r:=2x2;
lft x1=0; x3=w-x1;
bot y1=-d; top y2=h+o; y3=y1;
x4=x2; y4=h-(x_height+d);
pickup crisp.nib;
numeric theta,delta; theta=angle(z4-z1); delta=3u++.24asc_height;
pos11(rule_thickness,-90+theta); pos12(rule_thickness,-90+theta);
pos13(bar,-180+theta); pos14(bar,-180+theta);
lft x10=0; bot y10=-d;
x11=w; z11=z10+whatever*(dir theta);  % where the arrow stem would go
y13a=y10; x14a=x10; x13a-x10=y14a-y10=delta+eps;
z13=z13a rotatedaround(z10,theta-45);
z14=z14a rotatedaround(z10,theta-45);
pos15(bar,theta+45); z15l=z10; pos16(bar,theta-45); z16l=z10;
z19=.381966[.5[z13,z14],z10];
numeric t; path p; p=z14l{z19-z14}..z16r;
t=xpart(p intersectiontimes (z11l--(z11l+2(z10-z11)))); z12l=point t of p;
filldraw z10..{z14-z19}z14r
 --subpath (0,t) of\\(z14l{z19-z14}..z16r)
 --z12l
 -- % ---z11l..z11r---
 z12r
 --subpath (t,0) of\\(z13l{z19-z13}..z15r)
 --z13r{z19-z13}..z10 & cycle;  % left arrowhead
numeric theta,delta; theta=angle(z3-z4); delta=3u++.24asc_height;
pos21(rule_thickness,90+theta); pos22(rule_thickness,90+theta);
pos23(bar,theta); pos24(bar,theta);
rt x20=w; bot y20=-d;
x21=0; z21=z20+whatever*-(dir theta);  % where the arrow stem would go
x23a=x20; y24a=y20; y23a-y20=x20-x24a=delta+eps;
z23=z23a rotatedaround(z20,theta+45);
z24=z24a rotatedaround(z20,theta+45);
pos25(bar,theta+225); z25l=z20; pos26(bar,theta+135); z26l=z20;
z29=.381966[.5[z23,z24],z20];
numeric t; path p; p=z24l{z29-z24}..z26r;
t=xpart(p intersectiontimes (z21l--(z21l+2(z20-z21)))); z22l=point t of p;
filldraw z20..{z24-z29}z24r
 --subpath (0,t) of\\(z24l{z29-z24}..z26r)
 --z22l
 -- % ---z21l..z21r---
 z22r
 --subpath (t,0) of\\(z23l{z29-z23}..z25r)
 --z23r{z29-z23}..z20 & cycle;  % right arrowhead
pickup rule.nib;
numeric t; path p; p=z2{down}..{z1-z4}z1;
t=xpart(p intersectiontimes(z12l--z12r)); 
draw subpath (0,t) of\\(z2{down}..{z1-z4}z1);  % left arm
draw subpath (0,t) of\\(z2{down}..{z3-z4}z3);  % right arm
penlabels(10,11,12,13,14,15,16,19);
labels(1,2,3,4); endchar;

iff known fat_slash: cmchar "Fat slash";
beginchar(fat_slash,13u#,body_height#,paren_depth#);
numeric fatness; fatness = w-9u;
adjust_fit(0,0); pickup rule.nib;
rt x1=hround(w-u)+eps; top y1=h+eps; z4 = z1+fatness*right;
lft x2=hround(fatness+u)+eps; bot y2=-d-eps; z3 = z2+fatness*right;
draw z1--z2--z3--z4--z1;  % diagonal
labels(1,2); endchar;

iff known fat_bslash: cmchar "Fat reverse slash";
beginchar(fat_bslash,13u#,body_height#,paren_depth#);
numeric fatness; fatness = w-9u;
adjust_fit(0,0); pickup rule.nib;
lft x1=hround u-eps; top y1=h+eps; z4 = z1+fatness*right;
rt x2=hround(w-fatness-u)+eps; bot y2=-d-eps; z3 = z2+fatness*right;
draw z1--z2--z3--z4--z1;  % diagonal
labels(1,2); endchar;

iff known l_bag: cmchar "Left bag bracket";
beginchar(l_bag,8u#,body_height#,paren_depth#); 
      % ht and dp from "left parenthesis" symbol
adjust_fit(0,0); pickup rule.nib;                
lft x0=u; y0=h-2u;
x1=1/2[x0,x2]; top y1=h;
x2=2/3[x0,x3]; y2=y0;
bot rt z3=(w-u,-d);
draw z0..z1{right}..z2{down}..{right}z3;
penlabels(0,1,2,3); endchar;

iff known r_bag: cmchar "Right bag bracket";
beginchar(r_bag,8u#,body_height#,paren_depth#);
adjust_fit(0,0); pickup rule.nib;                
rt x0=w-u; y0=h-2u;
x1=1/2[x0,x2]; top y1=h;
x2=2/3[x0,x3]; y2=y0;
bot lft z3=(u,-d);
draw z0..z1{left}..z2{down}..{left}z3;
penlabels(0,1,2,3); endchar;

iff known var_big_circ: cmchar "Circular circle for copyright, etc.";
beginchar(var_big_circ,18u#,asc_height#,desc_depth#); autorounded;
adjust_fit(if monospace:-3u#,-3u# else: 0,0 fi); pickup rule.nib;
lft x6=hround u; x2=w-x6; y2=.5[h+o,-d-o]; y8-y2 = .5(x2-x6);
circle_points; draw_circle;  % circle
labels(1,2,3,4,5,6,7,8); endchar;
SHAR_EOF
fi # end of overwriting check
if test -f 'stmaryrd.mf'
then
	echo shar: will not over-write existing file "'stmaryrd.mf'"
else
cat << \SHAR_EOF > 'stmaryrd.mf'
% Filename: stmaryrd.mf
% Authors: Jeremy Gibbons and Alan Jeffrey
% Maintained by: Alan Jeffrey
% E-mail: jeffrey@cs.chalmers.se
% Last modified: 20 May 1991

% This is the driver file for the St Mary's Road symbol font, named
% after the palatial mansion (currently under investigation by the
% Enviromental Health Officer) where we lived, and where many of the
% symbols were designed and discussed over a bottle of wine and some
% halva.

% Copyright 1991 Jeremy Gibbons and Alan Jeffrey.

% Many of the symbols are derived (or `stolen', to use the technical
% phrase from Knuth's Computer Modern fonts, and the American
% Mathematical Society's msam and msbm fonts.  Please don't sue.

% 20 May 1991: Created the font out of alans.mf and galileo.mf.

% We assume the parameters have been set by whichever file called us
% (for example stmary10.mf).

% Here we steal a bit from mathsy

mode_setup; font_setup;
autorounding:=0;

font_slant slant; font_x_height x_height#;
font_quad 18u# if not monospace:+4letter_fit# fi;
slant:=mono_charic#:=0;  % the remaining characters will not be slanted
currenttransform:=identity yscaled aspect_ratio scaled granularity;

% The parameters for slashes for reductions:

slash_width := 7u; % horizontal extent of a slash
slash_height := body_height;
define_pixels(paren_depth); slash_depth := paren_depth;
slash_offset := 3u; % offset of slash from arrowhead for reduction and accm
slash_separation# := 3u#; % gap between slashes for accumulates

define_pixels(slash_separation);

% The input files:

input stmaryba; % Various macros we need.
input stmarych; % Defines the character positions and extension information.
input stmaryjg; % Jeremy's symbols.
input stmaryaj; % Alan's symbols.

end
SHAR_EOF
fi # end of overwriting check
if test -f 'stmaryrd.sty'
then
	echo shar: will not over-write existing file "'stmaryrd.sty'"
else
cat << \SHAR_EOF > 'stmaryrd.sty'
% Filename stmaryrd.sty
% Author Alan Jeffrey
% E-mail jeffrey@cs.chalmers.se
% Last modified 25 Jun 1991

% The module for importing the St Mary's Road symbol font.

% Copyright 1991 Alan Jeffrey.

% 23 May 1991: file created.
%
% 25 May 1991: Updated for the new module.sty and stmaryrd.mf.
%
% 5 Jun 1991: By mistake, \varotimes wasn't swapped for \otimes.
%
% 25 Jun 1991: Added \longarrownot and \Longarrownot.
%
% 27 Jun 1991: The default is now for the defult circles, not the
% heavier ones.  If you want \oplus, \otimes, etc. to generate the
% heavier symbols, set the tag \heavycircles.

% This module loads in the St Mary's Road symbol font, and defines loads
% of new commands to access it.  It understands the tag \heavycircles
% to mean `please give me the heavy versions of \oplus etc.'  It
% can cope with new or obsolete font selection, but doesn't understand the
% \substitutesymbols tag yet.

\@ifundefined{modulemoduleloaded}{\input module.sty}{}

% Dependency information:

\dependent\Mapsto\Mapstochar
\dependent\mapsfrom\mapsfromchar
\dependent\Mapsfrom\Mapsfromchar
\dependent\longarrownot\arrownot
\dependent\Longarrownot\Arrownot
\dependent\Longmapsto\Mapstochar
\dependent\longmapsfrom\mapsfromchar
\dependent\Longmapsfrom\Mapsfromchar

% If we're replacing the old eggshaped \oplus-like symbols, we need to
% make sure they're defined.

\iftest\tagisset\heavycircles\then
   \settag\varotimes
   \settag\varoast
   \settag\varobar
   \settag\varodot
   \settag\varoslash
   \settag\varobslash
   \settag\varocircle
   \settag\varoplus
   \settag\varominus
   \settag\varbigcirc
\fi

% The first time the module is loaded, we grab the fonts.

\iftest \tagisset\modulestmaryrdloaded \then \else

   \iftest \tagisset\newfontselection \then

      \new@mathgroup\stmaryrdfam
      \define@mathgroup\mv@normal\stmaryrdfam{stmaryrd}{m}{n}
      \define@mathgroup\mv@bold\stmaryrdfam{stmaryrd}{m}{n}

      \new@fontshape{stmaryrd}{m}{n}{%
         <5>stmary5%
         <6>stmary6%
         <7>stmary7%
         <8>stmary8%
         <9>stmary9%
         <10>stmary10%
         <11>stmary10 at10.95pt%
         <12>stmary10 at12pt%
         <14>stmary10 at14.4pt%
         <17>stmary10 at17.28pt%
         <20>stmary10 at20.736pt%
         <25>stmary10 at24.8832pt}{}

   \else

      \newfam\stmaryrdfam

      \font\stmaryfiv  stmary5
      \font\stmarysix  stmary6
      \font\stmarysev  stmary7
      \font\stmaryegt  stmary8
      \font\stmarynin  stmary9
      \font\stmaryten  stmary10
      \font\stmaryelv  stmary10 at10.95pt
      \font\stmarytwl  stmary10 at12pt
      \font\stmaryfrtn stmary10 at14.4pt
      \font\stmarysvtn stmary10 at17.28pt
      \font\stmarytwty stmary10 at20.736pt
      \font\stmarytwfv stmary10 at24.8832pt

      \@addfontinfo\@vpt{\textfont\stmaryrdfam\stmaryfiv
         \scriptfont\stmaryrdfam\stmaryfiv
         \scriptscriptfont\stmaryrdfam\stmaryfiv}
      \@addfontinfo\@vipt{\textfont\stmaryrdfam\stmarysix
         \scriptfont\stmaryrdfam\stmarysix
         \scriptscriptfont\stmaryrdfam\stmarysix}
      \@addfontinfo\@viipt{\textfont\stmaryrdfam\stmarysev
         \scriptfont\stmaryrdfam\stmarysix
         \scriptscriptfont\stmaryrdfam\stmaryfiv}
      \@addfontinfo\@viiipt{\textfont\stmaryrdfam\stmaryegt
         \scriptfont\stmaryrdfam\stmarysix
         \scriptscriptfont\stmaryrdfam\stmaryfiv}
      \@addfontinfo\@ixpt{\textfont\stmaryrdfam\stmarynin
         \scriptfont\stmaryrdfam\stmarysix
         \scriptscriptfont\stmaryrdfam\stmaryfiv}
      \@addfontinfo\@xpt{\textfont\stmaryrdfam\stmaryten
         \scriptfont\stmaryrdfam\stmarysev
         \scriptscriptfont\stmaryrdfam\stmaryfiv}
      \@addfontinfo\@xipt{\textfont\stmaryrdfam\stmaryelv
         \scriptfont\stmaryrdfam\stmarysev
         \scriptscriptfont\stmaryrdfam\stmaryfiv}
      \@addfontinfo\@xiipt{\textfont\stmaryrdfam\stmarytwl
         \scriptfont\stmaryrdfam\stmaryegt
         \scriptscriptfont\stmaryrdfam\stmarysix}
      \@addfontinfo\@xivpt{\textfont\stmaryrdfam\stmaryfrtn
         \scriptfont\stmaryrdfam\stmaryten
         \scriptscriptfont\stmaryrdfam\stmarysev}
      \@addfontinfo\@xviipt{\textfont\stmaryrdfam\stmarysvtn
         \scriptfont\stmaryrdfam\stmarytwl
         \scriptscriptfont\stmaryrdfam\stmaryten}
      \@addfontinfo\@xxpt{\textfont\stmaryrdfam\stmarytwty
         \scriptfont\stmaryrdfam\stmaryfrtn
         \scriptscriptfont\stmaryrdfam\stmarytwl}
      \@addfontinfo\@xxvpt{\textfont\stmaryrdfam\stmarytwfv
         \scriptfont\stmaryrdfam\stmarytwty
         \scriptscriptfont\stmaryrdfam\stmarysvtn}
   \fi

\fi

% For the rest of the style, ! is the hex number of the family.

\catcode`\!\active
\edef!{\hexnumber@\stmaryrdfam}

% Then we load those symbols!

\ifdef\then\mathchardef\shortleftarrow"3!00\fi
\ifdef\then\mathchardef\shortrightarrow"3!01\fi
\ifdef\then\mathchardef\shortuparrow"3!02\fi
\ifdef\then\mathchardef\shortdownarrow"3!03\fi
\ifdef\then\mathchardef\Yup"2!04\fi
\ifdef\then\mathchardef\Ydown"2!05\fi
\ifdef\then\mathchardef\Yleft"2!06\fi
\ifdef\then\mathchardef\Yright"2!07\fi
\ifdef\then\mathchardef\varcurlyvee"2!08\fi
\ifdef\then\mathchardef\varcurlywedge"2!09\fi
\ifdef\then\mathchardef\minuso"2!0A\fi
\ifdef\then\mathchardef\baro"2!0B\fi
\ifdef\then\mathchardef\sslash"2!0C\fi
\ifdef\then\mathchardef\bbslash"2!0D\fi
\ifdef\then\mathchardef\moo"2!0E\fi
\ifdef\then\mathchardef\varotimes"2!0F\fi
\ifdef\then\mathchardef\varoast"2!10\fi
\ifdef\then\mathchardef\varobar"2!11\fi
\ifdef\then\mathchardef\varodot"2!12\fi
\ifdef\then\mathchardef\varoslash"2!13\fi
\ifdef\then\mathchardef\varobslash"2!14\fi
\ifdef\then\mathchardef\varocircle"2!15\fi
\ifdef\then\mathchardef\varoplus"2!16\fi
\ifdef\then\mathchardef\varominus"2!17\fi
\ifdef\then\mathchardef\boxast"2!18\fi
\ifdef\then\mathchardef\boxbar"2!19\fi
\ifdef\then\mathchardef\boxdot"2!1A\fi
\ifdef\then\mathchardef\boxslash"2!1B\fi
\ifdef\then\mathchardef\boxbslash"2!1C\fi
\ifdef\then\mathchardef\boxcircle"2!1D\fi
\ifdef\then\mathchardef\boxbox"2!1E\fi
\ifdef\then\mathchardef\boxempty"2!1F\fi
\ifdef\then\mathchardef\lightning"0!20\fi
\ifdef\then\mathchardef\merge"2!21\fi
\ifdef\then\mathchardef\vartimes"2!22\fi
\ifdef\then\mathchardef\fatsemi"2!23\fi
\ifdef\then\mathchardef\sswarrow"3!24\fi
\ifdef\then\mathchardef\ssearrow"3!25\fi
\ifdef\then\mathchardef\curlywedgeuparrow"3!26\fi
\ifdef\then\mathchardef\curlywedgedownarrow"3!27\fi
\ifdef\then\mathchardef\fatslash"2!28\fi
\ifdef\then\mathchardef\fatbslash"2!29\fi
\ifdef\then\mathchardef\lbag"2!2A\fi
\ifdef\then\mathchardef\rbag"2!2B\fi
\ifdef\then\mathchardef\varbigcirc"2!2C\fi
\ifdef\then\mathchardef\leftrightarroweq"3!2D\fi
\ifdef\then\mathchardef\curlyveedownarrow"3!2E\fi
\ifdef\then\mathchardef\curlyveeuparrow"3!2F\fi
\ifdef\then\mathchardef\nnwarrow"3!30\fi
\ifdef\then\mathchardef\nnearrow"3!31\fi
\ifdef\then\mathchardef\leftslice"2!32\fi
\ifdef\then\mathchardef\rightslice"2!33\fi
\ifdef\then\mathchardef\varolessthan"2!34\fi
\ifdef\then\mathchardef\varogreaterthan"2!35\fi
\ifdef\then\mathchardef\varovee"2!36\fi
\ifdef\then\mathchardef\varowedge"2!37\fi
\ifdef\then\mathchardef\talloblong"2!38\fi
\ifdef\then\mathchardef\interleave"2!39\fi
\ifdef\then\mathchardef\obar"2!3A\fi
\ifdef\then\mathchardef\obslash"2!3B\fi
\ifdef\then\mathchardef\olessthan"2!3C\fi
\ifdef\then\mathchardef\ogreaterthan"2!3D\fi
\ifdef\then\mathchardef\ovee"2!3E\fi
\ifdef\then\mathchardef\owedge"2!3F\fi
\ifdef\then\mathchardef\oblong"2!40\fi
\ifdef\then\mathchardef\inplus"3!41\fi
\ifdef\then\mathchardef\niplus"3!42\fi
\ifdef\then\mathchardef\nplus"2!43\fi
\ifdef\then\mathchardef\subsetplus"3!44\fi
\ifdef\then\mathchardef\supsetplus"3!45\fi
\ifdef\then\mathchardef\subsetpluseq"3!46\fi
\ifdef\then\mathchardef\supsetpluseq"3!47\fi
\ifdef\then\mathchardef\Lbag"4!48\fi
\ifdef\then\mathchardef\Rbag"5!49\fi

\ifdef\then\mathchardef\llparenthesis"4!4C\fi
\ifdef\then\mathchardef\rrparenthesis"5!4D\fi
\ifdef\then\mathchardef\binampersand"4!4E\fi
\ifdef\then\mathchardef\bindnasrepma"5!4F\fi
\ifdef\then\mathchardef\trianglelefteqslant"3!50\fi
\ifdef\then\mathchardef\trianglerighteqslant"3!51\fi
\ifdef\then\mathchardef\ntrianglelefteqslant"3!52\fi
\ifdef\then\mathchardef\ntrianglerighteqslant"3!53\fi
\ifdef\then\mathchardef\llfloor"4!54\fi
\ifdef\then\mathchardef\rrfloor"5!55\fi
\ifdef\then\mathchardef\llceil"4!56\fi
\ifdef\then\mathchardef\rrceil"5!57\fi
\ifdef\then\mathchardef\arrownot"3!58\fi
\ifdef\then\mathchardef\Arrownot"3!59\fi
\ifdef\then\mathchardef\Mapstochar"3!5A\fi
\ifdef\then\mathchardef\mapsfromchar"3!5B\fi
\ifdef\then\mathchardef\Mapsfromchar"3!5C\fi
\ifdef\then\mathchardef\leftrightarrowtriangle"2!5D\fi
\ifdef\then\mathchardef\leftarrowtriangle"3!5E\fi
\ifdef\then\mathchardef\rightarrowtriangle"3!5F\fi
\ifdef\then\mathchardef\bigtriangledown"1!60\fi
\ifdef\then\mathchardef\bigtriangleup"1!61\fi
\ifdef\then\mathchardef\bigcurlyvee"1!62\fi
\ifdef\then\mathchardef\bigcurlywedge"1!63\fi
\ifdef\then\mathchardef\bigsqcap"1!64\fi
\ifdef\then\mathchardef\bigbox"1!65\fi
\ifdef\then\mathchardef\bigparallel"1!66\fi
\ifdef\then\mathchardef\biginterleave"1!67\fi
\ifdef\then\mathchardef\bignplus"1!70\fi

\ifdef\then\delimiterdef\llbracket"4!4A!71\fi
\ifdef\then\delimiterdef\rrbracket"5!4B!79\fi

\def\@tempa#1{\ifdef\then\def\varcopyright
   {{\ooalign{\hfil\raise.07ex\hbox{c}\hfil\crcr\mathhexbox#12C}}}\fi}
\expandafter\@tempa!

% The long arrow negations.

\ifdef\then\def\longarrownot{\mathrel{\mkern5.5mu\arrownot\mkern-5.5mu}}\fi
\ifdef\then\def\Longarrownot{\mathrel{\mkern5.5mu\Arrownot\mkern-5.5mu}}\fi

% The variants on \mapsto:

\ifdef\then\def\Mapsto{\Mapstochar\Rightarrow}\fi
\ifdef\then\def\mapsfrom{\leftarrow\mapsfromchar}\fi
\ifdef\then\def\Mapsfrom{\Leftarrow\Mapsfromchar}\fi
\ifdef\then\def\Longmapsto{\Mapstochar\Longrightarrow}\fi
\ifdef\then\def\longmapsfrom{\longleftarrow\mapsfromchar}\fi
\ifdef\then\def\Longmapsfrom{\Longleftarrow\Mapsfromchar}\fi

\catcode`\!=12

% The circular circles:

\iftest
   \andtest{\tagisset\heavycircles}{\nottest{\tagisset\swappedcircles}}
\then
   \def\@swap#1#2{\let\@tempa#1\let#1#2\let#2\@tempa}
   \@swap\varotimes\otimes
   \@swap\varolessthan\olessthan
   \@swap\varogreaterthan\ogreaterthan
   \@swap\varovee\ovee
   \@swap\varowedge\owedge
   \@swap\varoast\oast
   \@swap\varobar\obar
   \@swap\varodot\odot
   \@swap\varoslash\oslash
   \@swap\varobslash\obslash
   \@swap\varocircle\ocircle
   \@swap\varoplus\oplus
   \@swap\varominus\ominus
   \@swap\varbigcirc\bigcirc
   \@swap\varcopyright\copyright
   \settag\swappedcircles
\fi

% Set our own name:

\settag\modulestmaryrdloaded

% And that's it.
SHAR_EOF
fi # end of overwriting check
if test -f 'stmaryrd.tex'
then
	echo shar: will not over-write existing file "'stmaryrd.tex'"
else
cat << \SHAR_EOF > 'stmaryrd.tex'
% Filename: stmaryrd.tex
% Authors: Jeremy Gibbons and Alan Jeffrey
% Maintained by: Alan Jeffrey
% E-mail: jeffrey@cs.chalmers.se
% Last modified: 27 Jun 1991

% The documentation for the St Mary's Road symbols package.

% Copyright 1991 Jeremy Gibbons and Alan Jeffrey.  Permission is granted 
% for TUGboat to publish this.

% A keyboard check:
%
%     @ # $ % ^ & * ~   at hash dollar percent caret ampersand asterisk tilde
%     : ; , .           colon semicolon comma period 
%     ? !               question-mark exclamation-mark
%     " ' `             double-quote apostrophe back-quote
%     ( ) { } [ ]       parentheses braces square-brackets 
%     - + = / \         minus plus equals forward-slash backslash
%     _ | < >           underscore vertical-bar less-than greater-than
%

\documentstyle[ltugboat,stmaryrd]{article}

\title{The St Mary's Road symbol package}

\author{Jeremy Gibbons}
\address{Programming Research Group\\
         Oxford University\\
         11 Keble Road\\
         Oxford OX1 3QD\\
         UK}
\netaddress{jg@prg.ox.ac.uk}

\author{Alan Jeffrey}
\address{Department of Computer Sciences\\
         Chalmers University\\
         S-412 96 G\"oteborg\\
         Sweden}
\netaddress{jeffrey@cs.chalmers.se}

% The symbols environment for laying out symbol declarations.

\def\symbols#1{\hbox\bgroup\count0=#1\startcolumn}
\def\endsymbols{\endcolumn\egroup}
\def\startcolumn{\vtop\bgroup\count1=\count0\relax}
\def\endcolumn{\egroup}
\def\dosymbol#1{\hbox to .33\textwidth{\hbox to 
   2em{\hfil$#1$\hfil}{\tt\string#1}\hfil}%
   \advance\count1 by-1\relax
   \ifnum \count1=0\endcolumn\startcolumn\fi
}

% The \table macro from testfont.tex.

\newcount\n
\newcount\m
\newcount\p
\newdimen\dim
\newif\ifskipping
\def\oct#1{\hbox{\rm\'{}\kern-.2em\it#1\/\kern.05em}} % octal constant
\def\hex#1{\hbox{\rm\H{}\tt#1}} % hexadecimal constant
\def\setdigs#1"#2{\gdef\h{#2}% \h=hex prefix; \0\1=corresponding octal
 \m=\n \divide\m by 64 \xdef\0{\the\m}%
 \multiply\m by-64 \advance\m by\n \divide\m by 8 \xdef\1{\the\m}}
\def\testrow{\setbox0=\hbox{\penalty 1\def\\{\char"\h}%
 \\0\\1\\2\\3\\4\\5\\6\\7\\8\\9\\A\\B\\C\\D\\E\\F%
 \global\p=\lastpenalty}} % \p=1 if none of the characters exist
\def\oddline{\cr
  \noalign{\nointerlineskip}
  \multispan{19}\hrulefill&
  \setbox0=\hbox{\lower 2.3pt\hbox{\hex{\h x}}}\smash{\box0}\cr
  \noalign{\nointerlineskip}}
\def\evenline{\loop\skippingfalse
 \ifnum\n<256 \m=\n \divide\m 16 \chardef\next=\m
 \expandafter\setdigs\meaning\next \testrow
 \ifnum\p=1 \skippingtrue \fi\fi
 \ifskipping \global\advance\n 16 \repeat
 \ifnum\n=256 \let\next=\endchart\else\let\next=\morechart\fi
 \next}
\def\morechart{\cr\noalign{\hrule\penalty5000}
 \chartline \oddline \m=\1 \advance\m 1 \xdef\1{\the\m}
 \chartline \evenline}
\def\chartline{&\oct{\0\1x}&&\:&&\:&&\:&&\:&&\:&&\:&&\:&&\:&&}
\def\chartstrut{\lower4.5pt\vbox to14pt{}}
\def\table{$$\global\n=0
  \halign to\hsize\bgroup
    \chartstrut##\tabskip0pt plus10pt&
    &\hfil##\hfil&\vrule##\cr
    \lower6.5pt\null
    &&&\oct0&&\oct1&&\oct2&&\oct3&&\oct4&&\oct5&&\oct6&&\oct7&\evenline}
\def\endchart{\cr\noalign{\hrule}
  \raise11.5pt\null&&&\hex 8&&\hex 9&&\hex A&&\hex B&
  &\hex C&&\hex D&&\hex E&&\hex F&\cr\egroup$$\par}
\def\:{\setbox0=\hbox{\char\n}%
  \ifdim\ht0>7.5pt\reposition
  \else\ifdim\dp0>2.5pt\reposition\fi\fi
  \box0\global\advance\n 1 }
\def\reposition{\setbox0=\vbox{\kern2pt\box0}\dim=\dp0
  \advance\dim 2pt \dp0=\dim}

% A little hackette to make <foo> expand out to $\langle${\it foo}$\rangle$.

\catcode`\<=\active
\def<#1>{\leavevmode\hbox{$\langle$\rm\it#1\/$\rangle$}}

\ifx\normalshape\undefined 
   \def\stmaryrd{\stmaryten}
\else
   \def\stmaryrd{\family{stmaryrd}\selectfont}
\fi

\begin{document}

\maketitle

\section{Introduction}

This is a guide to the St Mary's Road symbol package for \LaTeX.  It 
contains a number of new commands for use in math mode, and a new 
document style option {\tt module}, for modularizing large {\tt sty} 
files.  The package is available as free software, the only restriction 
we make is that it should always be distributed as a package, not as 
individual files.  The package consists of:
\begin{itemize}
\item {\tt README}: a short description.
\item {\tt stmaryrd.tex}: this documentation.
\item {\tt ltugboat.sty}: the {\tt sty} file this document uses.
\item {\tt stmaryrd.sty}: loads the St Mary's Road symbol font.
\item {\tt msam.sty}: loads the AMS symbol A font.
\item {\tt msbm.sty}: loads the AMS symbol B font.
\item {\tt module.sty}: provides commands for modularizing document style 
   options.
\item Various \MF\ files, which generate the St Mary's Road symbol 
   font.
\end{itemize}
At its simplest, you can use the St~Mary's Road symbol font by saying
\begin{verbatim}
   \documentstyle[stmaryrd]{article}
\end{verbatim}
This gives you the new symbols in Tables~\ref{Tab-op}, \ref{Tab-bin}, 
\ref{Tab-rel}, \ref{Tab-arrow} and~\ref{Tab-delim}.  However, this 
defines over 100 new commands, and if you are using a \TeX\ 
implementation with limited memory, you might want to be more selective 
about which commands you use.  In that case, you should read on, in order 
to find out about how modules work. 

\begin{table*}
\begin{symbols}{3}
\dosymbol\bigbox
\dosymbol\bigcurlyvee
\dosymbol\bigcurlywedge
\dosymbol\biginterleave
\dosymbol\bignplus
\dosymbol\bigparallel
\dosymbol\bigsqcap
\dosymbol\bigtriangledown
\dosymbol\bigtriangleup
\end{symbols}
\caption{New large operators}
\label{Tab-op}
\end{table*}

\begin{table*}
\begin{symbols}{19}
\dosymbol\baro
\dosymbol\bbslash
\dosymbol\binampersand
\dosymbol\bindnasrepma
\dosymbol\boxast
\dosymbol\boxbar
\dosymbol\boxbox
\dosymbol\boxbslash
\dosymbol\boxcircle
\dosymbol\boxdot
\dosymbol\boxempty
\dosymbol\boxslash
\dosymbol\curlyveedownarrow
\dosymbol\curlyveeuparrow
\dosymbol\curlywedgedownarrow
\dosymbol\curlywedgeuparrow
\dosymbol\fatbslash
\dosymbol\fatsemi
\dosymbol\fatslash
\dosymbol\interleave
\dosymbol\leftslice
\dosymbol\merge
\dosymbol\minuso
\dosymbol\moo
\dosymbol\nplus
\dosymbol\obar
\dosymbol\oblong
\dosymbol\obslash
\dosymbol\ogreaterthan
\dosymbol\olessthan
\dosymbol\ovee
\dosymbol\owedge
\dosymbol\rightslice
\dosymbol\sslash
\dosymbol\talloblong
\dosymbol\varbigcirc
\dosymbol\varcurlyvee
\dosymbol\varcurlywedge
\dosymbol\varoast
\dosymbol\varobar
\dosymbol\varobslash
\dosymbol\varocircle
\dosymbol\varodot
\dosymbol\varogreaterthan
\dosymbol\varolessthan
\dosymbol\varominus
\dosymbol\varoplus
\dosymbol\varoslash
\dosymbol\varotimes
\dosymbol\varovee
\dosymbol\varowedge
\dosymbol\vartimes
\dosymbol\Ydown
\dosymbol\Yleft
\dosymbol\Yright
\dosymbol\Yup
\end{symbols}
\caption{New binary operators}
\label{Tab-bin}
\end{table*}

\begin{table*}
\begin{symbols}{4}
\dosymbol\inplus
\dosymbol\niplus
\dosymbol\ntrianglelefteqslant
\dosymbol\ntrianglerighteqslant
\dosymbol\subsetplus
\dosymbol\subsetpluseq
\dosymbol\supsetplus
\dosymbol\supsetpluseq
\dosymbol\trianglelefteqslant
\dosymbol\trianglerighteqslant
\end{symbols}
\caption{New relations}
\label{Tab-rel}
\end{table*}

\begin{table*}
\begin{symbols}{7}
\dosymbol\leftarrowtriangle
\dosymbol\leftrightarroweq
\dosymbol\leftrightarrowtriangle
\dosymbol\lightning
\dosymbol\Longmapsfrom
\dosymbol\longmapsfrom
\dosymbol\Longmapsto
\dosymbol\Mapsfrom
\dosymbol\mapsfrom
\dosymbol\Mapsto
\dosymbol\nnearrow
\dosymbol\nnwarrow
\dosymbol\rightarrowtriangle
\dosymbol\shortdownarrow
\dosymbol\shortleftarrow
\dosymbol\shortrightarrow
\dosymbol\shortuparrow
\dosymbol\ssearrow
\dosymbol\sswarrow
\end{symbols}
\caption{New arrows}
\label{Tab-arrow}
\end{table*}

\begin{table*}
\begin{symbols}{4}
\dosymbol\Lbag
\dosymbol\lbag
\dosymbol\llbracket
\dosymbol\llceil
\dosymbol\llfloor
\dosymbol\llparenthesis
\dosymbol\Rbag
\dosymbol\rbag
\dosymbol\rrbracket
\dosymbol\rrceil
\dosymbol\rrfloor
\dosymbol\rrparenthesis
\end{symbols}
\caption{New delimiters}
\label{Tab-delim}
\end{table*}

\section{Modules}

It is not uncommon for some document style options, particularly those 
loading new symbol fonts, to define hundreds of new commands, of which 
each user only wants a handful.  This is not a problem on machines with 
memory to spare, but on a PC one has to be careful about these things.

The solution adopted by the AMS, in their {\tt amsfonts} document style 
option, is to provide a new command \verb|\newsymbol|.  For example, to 
use the symbol \verb|\lneq|, you say
\begin{verbatim}
   \newsymbol\lneqq 2308
\end{verbatim}
Unfortunately, this requires the user to look up the four-digit code for 
each symbol whenever they want to use it.  The {\tt module} document 
style option is designed to get around this problem, by allowing 
the user to specify which new commands they want, without having to 
remember how they are defined.  

The main concept the user needs is that of a {\em tag\/} which is a
request to a module saying `please give me this facility'.  Usually
these are just command names that the module will define---for
example the module {\tt stmaryrd} has tags \verb|\varoplus|, 
\verb|\llbracket|, and so on.  But there are other tags which control 
how the module behaves, for example the tag \verb|\heavycircles| 
means `please redefine $\oplus$, $\otimes$, etc.~to make them 
heavier.'

To set the tag \verb|\foo|, you say \verb|\settag{\foo}|.  To set 
\verb|\foo|, \verb|\baz| and \verb|\bar|, you say:
\begin{verbatim}
   \begin{settags} 
      \foo\baz\bar 
   \end{settags}
\end{verbatim}
To unset the tag \verb|\foo|, you say \verb|\unsettag{\foo}|.  To unset 
\verb|\foo|, \verb|\baz| and \verb|\bar|, you say:
\begin{verbatim}
   \begin{unsettags} 
      \foo\baz\bar 
   \end{unsettags}
\end{verbatim}
You can then import a module.  This can be done in various ways:
\begin{itemize}
\item By saying \verb|\import{fred}|, which only loads the commands whose 
   tags you set.
\item By saying \verb|\import*{fred}|, which loads in all the commands.
\item In the same way as a \verb|\documentstyle| option, 
   e.g.~\verb|\documentstyle[module,fred]{report}|. 
   This is equivalent to \verb|\import*{fred}|.
\end{itemize}
For example, to load in the St Mary's Road symbol font, but only define 
\verb|\Lbag| and \verb|\Rbag|, you say:
\begin{verbatim}
   \settag\Lbag \settag\Rbag
   \import{stmaryrd}
\end{verbatim}
The St Mary's Road package comes with three modules---{\tt stmaryrd}, 
which loads the St Mary's Road symbol font, {\tt msam}, which loads the 
AMS A font, and {\tt msbm}, which loads the AMS B font.  

\section{The {\tt stmaryrd} module}

The St Mary's Road symbol font is designed to live with the AMS symbol 
fonts, and complement their focus on `concrete mathematics' by adding symbols 
for `abstract nonsense' such as domain theory ($\bigsqcap$), linear logic 
($\binampersand$ and $\bindnasrepma$), process theory ($\llfloor$
and $\lightning$) and program calculation ($\moo$ and $\merge$).

It also contains a number of circular characters (such as $\varotimes$, 
$\varoplus$, etc.)~which duplicate Knuth's.  The only difference is that 
they have had digitization kludges added, so they are guaranteed to be 
symmetrical and circular.  At low resolutions, Knuth's $\oplus$ tends to
be rather egg-shaped.  We have also made them the same weight as the 
other symbols.  If you want \verb|\oplus| to produce $\varoplus$ and
\verb|\varoplus| to produce $\oplus$, you should set the
\verb|\heavycircles| tag.

Note that \verb|\llbracket| and \verb|\rrbracket| are the only `growing' 
delimiters.  For example:
\[
   \left\llbracket {\cal P} \right\rrbracket \quad
   \left\llbracket \bigbox {\cal P} \right\rrbracket \quad
   \left\llbracket \bigbox_{i\inplus I}^{a \varoplus b} P_i
       \right\rrbracket \quad
   \left\llbracket \begin{array}{c}a\\b\\c\end{array} \right\rrbracket \quad
   \left\llbracket \begin{array}{c}a\\b\\c\\d\\e\\f\end{array} \right\rrbracket
\]
Table~\ref{Tab-special} contains characters that are only used to build 
other ones.
For example:
\begin{itemize}
\item \verb|$\arrownot\rightarrow$| is $\arrownot\rightarrow$.
\item \verb|$\Arrownot\Rightarrow$| is $\Arrownot\Rightarrow$.
\item \verb|$\longarrownot\longrightarrow$| is $\longarrownot\longrightarrow$.
\item \verb|$\Longarrownot\Longrightarrow$| is $\Longarrownot\Longrightarrow$.
\end{itemize}
The characters \verb|\mapsfromchar|, \verb|\Mapstochar| and
\verb|\Mapsfromchar| are used in defining \verb|\mapsfrom|,
\verb|\Mapsto| and \verb|\Mapsfrom|.

\begin{table*}
\begin{symbols}{3}
\dosymbol\Arrownot
\dosymbol\arrownot
\dosymbol\Longarrownot
\dosymbol\longarrownot
\dosymbol\Mapsfromchar
\dosymbol\mapsfromchar
\dosymbol\Mapstochar
\end{symbols}
\caption{Special symbols used for building other symbols}
\label{Tab-special}
\end{table*}

\begin{table*}
{\stmaryrd\table}
\caption{The font layout for {\tt stmary10}}
\end{table*}

\section{Implementing a module}

So, how does this magic with tags work?  Well, a module {\tt fred} is 
just a {\tt sty} file like any other, but uses some extra commands 
defined in the {\tt module} document style option, including 
\verb|\settag| and \verb|\unsettag|.  

Each module {\tt fred} should include the command 
\verb|\settag\modulefredloaded|, to tell other modules (including itself, 
if {\tt fred} is loaded more than once) that it has been loaded.  For 
example, a module can check to see if the {\tt module} document style 
option has been loaded by saying:
\begin{verbatim}
   \@ifundefined{modulemoduleloaded}
      {\input module.sty}{}
\end{verbatim}
The most important new command a module-writer has is \verb|\iftest|, 
which tests to see if a <test> is true or not.  It has the syntax:
\begin{verbatim}
   \iftest <test>
   \then <true text> 
   \fi
\end{verbatim}
or:
\begin{verbatim}
   \iftest <test> 
   \then <true text> 
   \else <false text> 
   \fi
\end{verbatim}
meaning `if the test is true, do the true text, otherwise do
the false text.'  A <test> is of the form:
\begin{verbatim}
   \truetest
   \falsetest
   \tagisset<tag>
   \ortest{<test>}{<test>}
   \andtest{<test>}{<test>}
   \nottest{<test>}
\end{verbatim}
For example, there is a special tag \verb|\everything|, which is 
set if the module was imported with \verb|\import*| or loaded as a 
document style option.  So if we are defining a command \verb|\foo|, we 
would like to test if either \verb|\foo| or \verb|\everything| has 
been set.  We can do this by saying
\begin{verbatim}
   \iftest\ortest
     {\tagisset\foo}{\tagisset\everything} 
   \then\def\foo{<definition>}
   \fi
\end{verbatim}
This is so common as to warrant its own syntactic sugar:
\begin{verbatim}
   \ifdef\then\def\foo{<definition>}\fi
\end{verbatim}
This can also be used with \verb|\mathchardef|, \verb|\let|, or any other 
defining command.  There are extra commands for defining new text
characters (such as \verb|\varcopyright|) and delimiters (such as
\verb|\llbracket|), since such definitions are so common:
\begin{verbatim}
   \delimiterdef\foo"<7 digits>  
   \textchardef\foo"<3 digits>
\end{verbatim}
Another common usage is
\begin{verbatim}
   \iftest\tagisset\foo 
   \then\settag\baz 
   \fi
\end{verbatim}
meaning `If we are exporting \verb|\foo|, we should export \verb|\baz| as 
well.' This sort of dependency information is so common as to warrant its 
own syntactic sugar:
\begin{verbatim}
   \dependent\foo\baz
\end{verbatim}
Note that since modules may well be loaded in more than once, care is 
needed to make sure the definitions stand up to being executed 
repeatedly.  Unfortunately, this is not always the case---commands such 
as \verb|\newfam| or \verb|\font| should only be executed once. To get round
this, the module {\tt fred} can look to see whether 
\verb|\modulefredloaded| is set. For example, you can say:
\begin{verbatim}
   \iftest\tagisset\modulefredloaded
   \then\else <sensitive material> 
   \fi
\end{verbatim}
There is also a tag \verb|\newfontselection| which is set if Mittelbach 
and Sch\"opf's new font selection scheme is in force.

\section{Implementing {\tt stmaryrd.sty}}

As an example, we can look to see how the St Mary's Road module is 
implemented.  To begin with, it looks to see if the {\tt module} document 
style is loaded, and inputs it if necessary:
\begin{verbatim}
   \@ifundefined{modulemoduleloaded}
      {\input module.sty}{}
\end{verbatim}
Then it sets up the dependency information.  For example, we need 
\verb|\Mapstochar| in order to build \verb|\Mapsto|.
\begin{verbatim}
   \dependent\Mapsto\Mapstochar
   ...
   \dependent\Longmapsfrom\Mapsfromchar
\end{verbatim}
If the  \verb|\heavycircles| tag is set, we need to define
\verb|\varotimes|, \verb|\varoast|, etc.
\begin{verbatim}
   \iftest\tagisset\heavycircles
   \then
      \settag\varotimes
      ...
      \settag\varbigcirc
   \fi
\end{verbatim}
Then we can do the real work of the module, which is to load the fonts 
in.  We only do this the first time the module is loaded.
\begin{verbatim}
   \iftest\tagisset\modulestmaryrdloaded
   \then\else
      \iftest\tagisset\newfontselection
      \then <load the fonts the new way>
      \else <load the fonts the old way>
      \fi
   \fi
\end{verbatim}
We can then define all those symbols, but first a quick cheat to make 
\verb|!| expand out to the hex digit for the St Mary's Road family.
\begin{verbatim}
   \catcode`\!\active
   \edef!{\hexnumber@\stmaryrdfam}
\end{verbatim}
Then we have a huge number of definitions:
\begin{verbatim}
   \ifdef\then\mathchardef\shortleftarrow
      "3!00\fi
   ...
   \ifdef\then\def\Longmapsfrom
      {\Longleftarrow\Mapsfromchar}\fi
\end{verbatim}
There's then a little hackette to swap the circular operators around if 
necessary.  This works by keeping a tag \verb|\swappedcircles| which is 
set once we've swapped the circles round.  So we swap the circles if 
\verb|\heavycircles| is set and \verb|\swappedcircles| is not.
\begin{verbatim}
   \iftest\andtest
      {\tagisset\heavycircles}
      {\nottest{\tagisset\swappedcircles}}
   \then\else
      \def\@swap#1#2{\let\@tempa#1
         \let#1#2\let#2\@tempa}
      \@swap\varotimes\otimes
      ...
      \@swap\varcopyright\copyright
      \settag\swappedcircles
   \fi
\end{verbatim}
Finally, the St Mary's Road module sets its own name.
\begin{verbatim}
   \settag\modulestmaryrdloaded
\end{verbatim}
And that's it.

\section{Implementing {\tt module.sty}}

So the only question left is how the {\tt module} document style option 
is defined.  The main problem is to implement \verb|\iftest| in a 
reasonably efficient manner, even though \TeX\ doesn't have primitives 
for `and' and `or' on booleans.

The solution adopted here is to make a <test> a command which expands out 
to either \verb|\iftrue| or \verb|\iffalse|.  Note that \verb|\iftrue| 
and \verb|\iffalse| are not good tests, since they would fall foul of 
\TeX's \verb|\if...\fi| matching.
\begin{verbatim}
   \def\truetest{\iftrue}
   \def\falsetest{\iffalse}
\end{verbatim}
The definition of `or':
\begin{verbatim}
   \def\ortest#1{#1\expandafter\K@true
      \else\expandafter\@identity\fi}
   \def\@identity#1{#1}
   \def\K@true#1{\iftrue}
\end{verbatim}
The definition of `and':
\begin{verbatim}
   \def\andtest#1#2{#1\@fi#2}
   \def\@fi{\fi}
\end{verbatim}
The definition of `not':
\begin{verbatim}
   \def\nottest#1{#1\expandafter\falsetest
      \else\expandafter\truetest\fi}
\end{verbatim}
Then all that \verb|\iftest<test>\then| has to do is expand out to <test>.
\begin{verbatim}
   \def\iftest#1\then{#1}
\end{verbatim}
However, in order to make sure that nested uses of \verb|\if...\fi| and 
\verb|\iftest...\then...\fi| work, we need to make \verb|\then| an 
\verb|\if|-like command.  It doesn't matter which, since we're only using 
it to match against \verb|\fi| properly.
\begin{verbatim}
   \let\then\true
\end{verbatim}
Then we can set a tag by making it the same as some magic value 
\verb|\magic@value|.
\begin{verbatim}
   \def\tagisset#1{\ifx\magic@value#1}
   \def\settag#1{\let#1\magic@value}
   \def\unsettag#1{\let#1\unmagic@value}
\end{verbatim}
It doesn't matter which magic value we choose, so we let 
\verb|\magic@value| produce an error message.  That way, if the user sets 
a tag, but none of the modules actually defines it, then they will get an 
error message if they try to use it.
\begin{verbatim}
   \def\magic@value{\set@error}
   \def\set@error{<error message>}
   \def\unmagic@value{\unset@error}
   \def\unset@error{<error message>}
\end{verbatim}
The rest of the {\tt module} document style option is fairly routine.

\section{Acknowledgements}

We'd like to thank Dave Murphy for many thought-provoking comments, and 
Simon, Nigel and Stuart for making our life in St~Mary's Road livable.

\makesignature

\end{document}

SHAR_EOF
fi # end of overwriting check
if test -f 'tugboat.com'
then
	echo shar: will not over-write existing file "'tugboat.com'"
else
cat << \SHAR_EOF > 'tugboat.com'
% version 1.0
% 1 Nov 89
%
%               *****     TUGBOAT.COM   *****
%
%       This file contains macros which are common to both the PLAIN
%       and LaTeX style files for TUGboat.

%       Among other things, it contains supplementary definitions for
%       abbreviations and logos that appear in TUGboat.  See the bottom
%       of the file (after \endinput) for a list of items defined.

% *************************************************************************

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%     *****  helpful shorthand  *****
%

%  The following allow for easier changes of category.  These require that
%  the character be addressed as a control-sequence: e.g. \makeescape\/ will
%  make the / an escape character.

\def\makeescape#1{\catcode`#1=0 }
\def\makebgroup#1{\catcode`#1=1 }
\def\makeegroup#1{\catcode`#1=2 }
\def\makemath#1{\catcode`#1=3 }
\def\makealign#1{\catcode`#1=4 }
\def\makeeol#1{\catcode`#1=5 }
\def\makeparm#1{\catcode`#1=6 }
\def\makesup#1{\catcode`#1=7 }
\def\makesub#1{\catcode`#1=8 }
\def\makeignore#1{\catcode`#1=9 }
\def\makespace#1{\catcode`#1=10 }
\def\makeletter#1{\catcode`#1=11 }
\def\makeother#1{\catcode`#1=12 }
\def\makeactive#1{\catcode`#1=13 }
\def\makecomment#1{\catcode`#1=14 }

\def\makeatletter{\catcode`\@=11 }      % included for historical reasons
\chardef\other=12
\def\makeatother{\catcode`\@=\other}

                                        % alternative to localization
\def\savecat#1{%
  \expandafter\xdef\csname\string#1savedcat\endcsname{\the\catcode`#1}}
\def\restorecat#1{\catcode`#1=\csname\string#1savedcat\endcsname}


\savecat\@
\makeletter\@           % used, as in PLAIN, in protected control sequences

                        % for restoring meanings of global control sequences
\def\SaveCS#1{%
  \def\scratch{\expandafter\let\csname saved@@#1\endcsname}%
  \expandafter\scratch\csname#1\endcsname}
\def\RestoreCS#1{%
  \def\scratch{\expandafter\let\csname#1\endcsname}%
  \expandafter\scratch\csname saved@@#1\endcsname}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%     *****  abbreviations and logos  *****
%


\def\AMS{American Mathematical Society}

\def\AmSTeX{{\the\textfont2 A}\kern-.1667em\lower.5ex\hbox
        {\the\textfont2 M}\kern-.125em{\the\textfont2 S}-\TeX}

\def\aw{A\kern.1em-W}
\def\AW{Addison\kern.1em-\penalty\z@\hskip\z@skip Wesley}

\def\BibTeX{{\rm B\kern-.05em{\smc i\kern-.025emb}\kern-.08em\TeX}}

\def\CandT{{\sl Computers \& Typesetting}}

\def\DVItoVDU{DVIto\kern-.12em VDU}

%       Japanese TeX
\def\JTeX{\leavevmode\hbox{\lower.5ex\hbox{J}\kern-.18em\TeX}}

\def\JoT{{\sl The Joy of \TeX}}

%       note -- \LaTeX definition is from LATEX.TEX 2.09 of 7 Jan 86,
%               adapted for additional flexibility in TUGboat
%\def\LaTeX{\TestCount=\the\fam \leavevmode L\raise.42ex
%       \hbox{$\fam\TestCount\scriptstyle\kern-.3em A$}\kern-.15em\TeX}
%       note -- broken in two parts, to permit separate use of La,
%               as in (La)TeX
\def\La{\TestCount=\the\fam \leavevmode L\raise.42ex
        \hbox{$\fam\TestCount\scriptstyle\kern-.3em A$}}
\def\LaTeX{\La\kern-.15em\TeX}


%       for Robert McGaffey
\def\Mc{\setbox\TestBox=\hbox{M}M\vbox to\ht\TestBox{\hbox{c}\vfil}}

\font\manual=logo10 % font used for the METAFONT logo, etc.
\def\MF{{\manual META}\-{\manual FONT}}
\def\mf{{\smc Metafont}}
\def\MFB{{\sl The \slMF book}}

%       multilingual (INRS) TeX
\def\mtex{T\kern-.1667em\lower.5ex\hbox{\^E}\kern-.125emX}

\def\pcMF{\leavevmode\raise.5ex\hbox{p\kern-.3ptc}MF}
\def\PCTeX{PC\thinspace\TeX}
\def\pcTeX{\leavevmode\raise.5ex\hbox{p\kern-.3ptc}\TeX}

\def\Pas{Pascal}

\def\PiC{P\kern-.12em\lower.5ex\hbox{I}\kern-.075emC}
\def\PiCTeX{\PiC\kern-.11em\TeX}

\def\plain{{\tt plain}}

\def\POBox{P.\thinspace O.~Box }
\def\POBoxTUG{\POBox\unskip~9506, Providence, RI~02940}

\def\PS{{Post\-Script}}

\def\SC{Steering Committee}

\def\SliTeX{{\rm S\kern-.06em{\smc l\kern-.035emi}\kern-.06em\TeX}}

\def\slMF{{\manual 89:;}\-{\manual <=>:}} % slant the logo

%       Atari ST (Klaus Guntermann)
\def\stTeX{{\smc st\rm\kern-0.13em\TeX}}

\def\TANGLE{{\tt TANGLE}}

\def\TB{{\sl The \TeX book}}

\def\TeX{T\hbox{\kern-.1667em\lower.424ex\hbox{E}\kern-.125emX}}

\def\TeXhax{\TeX hax}

%       Don Hosek
\def\TeXMaG{\TeX M\kern-.1667em\lower.5ex\hbox{A}\kern-.2267emG}

%\def\TeXtures{\TestCount=\the\fam
%       \TeX\-\hbox{$\fam\TestCount\scriptstyle TURES$}}
\def\TeXtures{{\it Textures}}

\def\TeXXeT{\TeX--X\kern-.125em\lower.5ex\hbox{E}\kern-.1667emT}

\def\tubfont{\sl}               % redefined in other situations
\def\TUB{{\tubfont TUGboat\/}}

\def\TUG{\TeX\ \UG}

\def\UG{Users Group}

\def\UNIX{{\smc unix}}

\def\VAX{\leavevmode\hbox{V\kern-.12em A\kern-.1em X}}

\def\VorTeX{V\kern-2.7pt\lower.5ex\hbox{O\kern-1.4pt R}\kern-2.6pt\TeX}

\def\XeT{\leavevmode\hbox{X\kern-.125em\lower.424ex\hbox{E}\kern-.1667emT}}

\def\WEB{{\tt WEB}}
\def\WEAVE{{\tt WEAVE}}



%********************************************************************

\newlinechar=`\^^J
\normallineskiplimit=1pt

\clubpenalty=10000
\widowpenalty=10000

\def\NoParIndent{\parindent=\z@}
\newdimen\normalparindent        \normalparindent=20pt          % plain = 20pt
\def\NormalParIndent{\global\parindent=\normalparindent}
\NormalParIndent

\def\BlackBoxes{\overfullrule=5pt }
\def\NoBlackBoxes{\overfullrule=\z@ }
\def\newline{\hskip\z@ plus \pagewd \break}
\def\nohyphens{\hyphenpenalty\@M\exhyphenpenalty\@M}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%     *****  utility registers and definitions  *****
%

%       test registers for transient use; paired - internal/external
\newbox\T@stBox                 \newbox\TestBox
\newcount\T@stCount             \newcount\TestCount
\newdimen\T@stDimen             \newdimen\TestDimen
\newif\ifT@stIf                 \newif\ifTestIf


%       \cs existence test, stolen from TeXbook exercise 7.7
\def\ifundefined#1{\expandafter\ifx\csname#1\endcsname\relax }

%       Smashes repeated from AMS-TeX; PLAIN implements only full \smash .
\newif\iftop@           \newif\ifbot@
\def\topsmash{\top@true\bot@false\smash@}
\def\botsmash{\top@false\bot@true\smash@}
\def\smash{\top@true\bot@true\smash@}
\def\smash@{\relax\ifmmode\def\next{\mathpalette\mathsm@sh}%
        \else\let\next\makesm@sh\fi \next }
\def\finsm@sh{\iftop@\ht\z@\z@\fi\ifbot@\dp\z@\z@\fi\box\z@}


%       Vertical `laps'; cf. \llap and \rlap
\long\def\ulap#1{\vbox to \z@{\vss#1}}
\long\def\dlap#1{\vbox to \z@{#1\vss}}

%       And centered horizontal and vertical `laps'
\def\xlap#1{\hbox to \z@{\hss#1\hss}}
\long\def\ylap#1{\vbox to \z@{\vss#1\vss}}
\long\def\zlap#1{\ylap{\xlap{#1}}}


%       Avoid unwanted vertical glue when making up pages.
\def\basezero{\baselineskip\z@skip \lineskip\z@skip}


%  Empty rules for special occasions
\def\nullhrule{\hrule height\z@ depth\z@ width\z@ }
\def\nullvrule{\vrule height\z@ depth\z@ width\z@ }

%       Support ad-hoc strut construction.
\def\makestrut[#1;#2]{\vrule height#1 depth#2 width\z@ }


%       Today's date, to be printed on drafts.  Based on TeXbook, p.406.

\def\today{\number\day\space \ifcase\month\or
        Jan \or Feb \or Mar \or Apr \or May \or Jun \or
        Jul \or Aug \or Sep \or Oct \or Nov \or Dec \fi
        \number\year}

%       Current time; this may be system dependent!
\newcount\hours
\newcount\minutes
\def\SetTime{\hours=\time
        \global\divide\hours by 60
        \minutes=\hours
        \multiply\minutes by 60
        \advance\minutes by-\time
        \global\multiply\minutes by-1 }
\SetTime
\def\now{\number\hours:\ifnum\minutes<10 0\fi\number\minutes}

\def\Now{\today\ \now}

\newif\ifPrelimDraft            \PrelimDraftfalse

\def\midrtitle{\ifPrelimDraft {{\tensl preliminary draft, \Now}}\fi}

%  Section heads.  The following set of macros is used to set the large
%  TUGboat section heads (e.g. "General Delivery", "Fonts", etc.)

\newdimen\PreTitleDrop   \PreTitleDrop=\z@

\newskip\AboveTitleSkip  \AboveTitleSkip=12pt
\newskip\BelowTitleSkip  \BelowTitleSkip=8pt

\newdimen\strulethickness       \strulethickness=.6pt
\def\sthrule{\hrule height\strulethickness depth \z@ }
\def\stvrule{\vrule width\strulethickness }

\newdimen\stbaselineskip        \stbaselineskip=18pt

\def\@sectitle #1{%
  \par \SecTitletrue
  \penalty-1000
  \secsep
  \vbox{
    \sthrule
    \hbox{%
      \stvrule
      \vbox{
        \advance\hsize by -2\strulethickness
        \raggedcenter
        \def\\{\unskip\break}%
        \sectitlefont
        \makestrut[2\stfontheight;\z@]
        #1%
        \makestrut[\z@;\stfontheight]\endgraf
        }%
      \stvrule }
    \sthrule }
  \nobreak
  \vskip\baselineskip }

%  distance between articles which are run together
\def\secsep{\vskip 5\baselineskip}

\newif\ifSecTitle
\SecTitlefalse





%  Registration marks

\def\HorzR@gisterRule{\vrule height 0.2pt depth \z@ width 0.5in }
\def\DownShortR@gisterRule{\vrule height 0.2pt depth 1pc width 0.2pt }
\def\UpShortR@gisterRule{\vrule height 1pc depth \z@ width 0.2pt }


%               ``T'' marks centered on top and bottom edges of paper

\def\ttopregister{\dlap{%
        \hbox to \trimwd{\HorzR@gisterRule \hfil \HorzR@gisterRule
                        \HorzR@gisterRule \hfil \HorzR@gisterRule}%
        \hbox to \trimwd{\hfil \DownShortR@gisterRule \hfil}}}
\def\tbotregister{\ulap{%
        \hbox to \trimwd{\hfil \UpShortR@gisterRule \hfil}%
        \hbox to \trimwd{\HorzR@gisterRule \hfil \HorzR@gisterRule
                        \HorzR@gisterRule \hfil \HorzR@gisterRule}}}

\def\topregister{\ttopregister}
\def\botregister{\tbotregister}



%       PLAIN's definition of \raggedright doesn't permit any stretch, and
%       results in too many overfull boxes.  We also turn off hyphenation.
\newdimen\raggedskip    \raggedskip=\z@
\newdimen\raggedstretch \raggedstretch=5em    % ems of font set now (10pt)
\newskip\raggedparfill  \raggedparfill=\z@ plus 1fil

\def\raggedspaces{\spaceskip=.3333em \relax \xspaceskip=.5em \relax }
%       Some applications may have to add stretch, in order to avoid
%       all overfull boxes.

\def\raggedright{%
  \nohyphens
  \rightskip=\raggedskip plus\raggedstretch \raggedspaces
  \parfillskip=\raggedparfill }
\def\raggedleft{%
  \nohyphens
  \leftskip=\raggedskip plus\raggedstretch \raggedspaces
  \parfillskip=\z@skip }
\def\raggedcenter{%
  \nohyphens
  \leftskip=\raggedskip plus\raggedstretch
  \rightskip=\leftskip \raggedspaces
  \parindent=\z@ \parfillskip=\z@skip }

\def\normalspaces{\spaceskip\z@skip \xspaceskip\z@skip }


%       Miscellaneous useful stuff

% FMi missing \relax added before \ifmmode also made the same as LaTeX
%     version, i.e., robust.
\let\protect\relax
\def\,{\protect\pcomma}
\def\pcomma{\ifmmode\mskip\thinmuskip\else\thinspace\fi}

%\def~{\penalty\@M \ } % tie -- this is PLAIN value; it is reset in AMS-TeX
\def~{\unskip\nobreak\ \ignorespaces} % AMS-TeX value

\def\newbox{\alloc@4\box\chardef\insc@unt}   % remove \outer
\def\boxcs#1{\box\csname#1\endcsname}
\def\setboxcs#1{\setbox\csname#1\endcsname}
\def\newboxcs#1{\expandafter\newbox\csname#1\endcsname}

\def\gobble#1{}

\def\vellipsis{%
  \leavevmode\kern0.5em
  \raise1pt\vbox{\baselineskip6pt\vskip7pt\hbox{.}\hbox{.}\hbox{.}}
  }

\def\bull{\vrule height 1ex width .8ex depth -.2ex } % square bullet
\def\cents{{\rm\raise.2ex\rlap{\kern.05em$\scriptstyle/$}c}}
\def\Dag{\raise .6ex\hbox{$\scriptstyle\dagger$}}

\def\careof{\leavevmode\hbox{\raise.75ex\hbox{c}\kern-.15em
                /\kern-.125em\smash{\lower.3ex\hbox{o}}} \ignorespaces}
\def\sfrac#1/#2{\leavevmode\kern.1em
        \raise.5ex\hbox{\the\scriptfont\z@ #1}\kern-.1em
        /\kern-.15em\lower.25ex\hbox{\the\scriptfont\z@ #2}}

\def\d@sh#1{\nobreak\thinspace#1\penalty\z@\thinspace}
\def\dash{\d@sh{--}}
\def\Dash{\d@sh{---}}

%       Hack to permit automatic hyphenation after an actual hyphen.

\def\hyph{-\penalty\z@\hskip\z@skip }

\def\slash{/\penalty\z@\hskip\z@skip }        % "breakable" slash
%       Dates and other items which identify the volume and issue

%       To use: \vol 5, 2.
%               \issdate October 1984.
%               \issueseqno=10
%       For production, these are set in a separate file, TUGBOT.DATES,
%       which is issue-specific.

\newcount\issueseqno            \issueseqno=-1

\def\v@lx{\gdef\volx{Volume~\volno~(\volyr), No.~\issno}}
\def\volyr{}
\def\volno{}
\def\vol #1,#2.{\gdef\volno{#1\unskip}%
        \gdef\issno{\ignorespaces#2\unskip}%
        \setbox\TestBox=\hbox{\volyr}%
        \ifdim \wd\TestBox > .2em \v@lx \fi }

\def\issdate #1#2 #3.{\gdef\issdt{#1#2 #3}\gdef\volyr{#3}%
        \gdef\bigissdt{#1{\smc\uppercase{#2}} #3}%
        \setbox\TestBox=\hbox{\volno}%
        \ifdim \wd\TestBox > .2em \v@lx \fi }


\vol 0, 0.                      % volume, issue.
\issdate Thermidor, 2001.       % month, year of publication


\def\xEdNote{{\tenuit Editor's note:\enspace }}


%       TUGboat conventions include the issue number in the file name.
%       Permit this to be incorporated into file names automatically.
%       If issue number = 11, \Input filnam  will read tb11filnam.tex.


\def\infil@{\jobname}
\def\Input #1 {\ifnum\issueseqno<0 \def\infil@{#1}%
                \else \def\infil@{tb\number\issueseqno#1}\fi
                \input \infil@
                \ifRMKopen\immediate\closeout\TBremarkfile\RMKopenfalse\fi}

\newif\ifRMKopen        \RMKopenfalse
\newwrite\TBremarkfile
\def\TBremarkON#1{%
  \ifRMKopen\else\RMKopentrue\immediate\openout\TBremarkfile=\infil@.rmk \fi
  \toks@={#1}%
  \immediate\write\TBremarkfile{^^J\the\toks@}%
  \immediate\write16{^^JTBremark:: \the\toks@^^J}}
\def\TBremarkOFF#1{}
\let\TBremark=\TBremarkOFF


%       Write out (both to a file and to the log) the starting page number
%       of an article, to be used for cross references and in contents.
%       \pagexref  is used for articles fully processed in the TUGboat run.
%       \PageXref  is used for "extra" pages, where an item is submitted
%               as camera copy, and only running heads (at most) are run.
\def\pagexrefON#1{\ifFirstPar \nobreak \fi  % don't clobber switch by accident
        \write-1{\def\expandafter\noexpand\csname#1\endcsname{\number\pageno}}%
        \write\ppoutfile{%
                \def\expandafter\noexpand\csname#1\endcsname{\number\pageno}}%
        \ifFirstPar \nobreak \fi }      % and don't allow page break
\def\PageXrefON#1{%
        \immediate\write-1{\def\expandafter
                        \noexpand\csname#1\endcsname{\number\pageno}}%
        \immediate\write\ppoutfile{\def\expandafter
                        \noexpand\csname#1\endcsname{\number\pageno}}}

\def\pagexrefOFF#1{}
\let\pagexref=\pagexrefOFF
\def\PageXrefOFF#1{}
\let\PageXref=\PageXrefOFF

\def\xreftoON#1{%
  \ifundefined{#1}%
    ???\TBremark{Need cross reference for #1.}%
  \else\csname#1\endcsname\fi}
\def\xreftoOFF#1{???}
\let\xrefto=\xreftoOFF

\def\TBdriver#1{}


%  Authors, addresses, signatures

\def\theauthor#1{\csname theauthor#1\endcsname}
\def\theaddress#1{\csname theaddress#1\endcsname}
\def\thenetaddress#1{\csname thenetaddress#1\endcsname}

\newcount\count@@
\def\@defaultauthorlist{%         % standard way of listing authors
   \count@=\authornumber
   \advance\count@ by -2
   \count@@=0
   \loop
   \ifnum\count@>0
      \advance\count@@ by 1
      \ignorespaces\csname theauthor\number\count@@\endcsname\unskip,
      \advance\count@ by -1
   \repeat
   \count@=\authornumber
   \advance\count@ by -\count@@
   \ifnum\authornumber>0
     \ifnum\count@>1
       \count@=\authornumber
       \advance\count@ by -1
       \ignorespaces\csname theauthor\number\count@\endcsname\unskip\ and
       \fi
     \ignorespaces\csname theauthor\number\authornumber\endcsname\unskip
   \fi
  }

\def\signature#1{\def\@signature{#1}}
\def\@signature{\@defaultsignature}

\def\@defaultsignature{%
  \count@=0
  \loop
  \ifnum\count@<\authornumber
    \medskip
    \advance\count@ by \@ne
    \signaturemark
    \theauthor{\number\count@}\\
    \theaddress{\number\count@}\\
    \thenetaddress{\number\count@}\\
  \repeat
  }

\def\makesignature{%
  \par
  \rightline{%
    \vbox{\hsize=12pc \ninepoint \raggedright
      \parindent \z@ \everypar={\hangindent 1pc }
      \parskip \z@skip
      \netaddrat
      \netaddrpercent
      \def\|{\unskip\hfil\break}%
      \def\\{\endgraf}%
      \def\net{\tt}%
      \def\phone{\rm Phone: } \rm
      \medskip
      \@signature}}
  }

{\makeactive\@
 \gdef\signatureat{\makeactive\@\def@{\char"40\discretionary{}{}{}}}
 \makeactive\%
 \gdef\signaturepercent{\makeactive\%\def%{\char"25\discretionary{}{}{}}}
}

\def\signaturemark{\leavevmode\llap{$\diamond$\enspace}}




%       some hyphenation exceptions:
\hyphenation{man-u-script man-u-scripts}


\restorecat\@

\endinput


Contents and Notes
------------------

\makeescape, ..., \makecomment allow users to change category
codes a little more easily.

\savecat#1 and \restorecat#1 will save and restore the category
of a given character.  These are useful in cases where one doesn't
wish to localize the settings and therefore be required to globally
define or set things.

\SaveCS#1 and \RestoreCS#1 save and restore `meanings' of control
sequences.  Again this is useful in cases where one doesn't want to
localize or where global definitions clobber a control sequence which
is needed later with its `old' definition.

Abbreviations.  Just a listing with indications of expansion where
that may not be obvious.  For full definitions, see real code above.

\AMS            American Mathematical Society
\AmSTeX
\aw             A-W (abbreviation for Addison-Wesley)
\AW             Addison Wesley
\BibTeX
\CandT          Computers \& Typesetting
\DVItoVDU       DVItoVDU
\JTeX
\JoT            The Joy of \TeX
\LaTeX
\Mc             M ``w/ raised c''
\MF             METAFONT
\mf             Metafont (using small caps)
\MFB            The Metafont book
\mtex           multilingual TeX
\pcMF           pcMF
\PCTeX
\pcTeX
\Pas            Pascal
\PiCTeX
\plain          plain (in typewriter font)
\POBox          P. O. Box
\POBoxTUG       TUG PO Box
\PS             PostScript
\SC             Steering Committee
\SliTeX
\slMF           Metafont (slanted)
\stTeX          TeX for the Atari ST
\TANGLE
\TB             The \TeX book
\TeX
\TeXhax
\TeXMaG
\TeXtures
\TeXXeT
\TUB            TUGboat
\TUG            TeX Users Group
\UNIX
\VAX
\VorTeX
\XeT
\WEB
\WEAVE

\NoBlackBoxes           turns off marginal rules marking overfull boxes
\BlackBoxes             turns them back on
\newline                horizontal glue plus a break

\ifundefined#1          checks argument with \csname against \relax

\topsmash               smashes above baseline  (from AMSTeX)
\botsmash               smashes below baseline  (from AMSTeX)
\smash                  smashes both            (from plain)

\ulap                   lap upwards
\dlap                   lap downwards
\xlap                   reference point at center horizontally; 0 width
\ylap                   reference point at center vertically; 0 height, depth
\zlap                   combination \xlap and \ylap

\basezero               to avoid insertion of baselineskip and lineskip glue

\nullhrule              empty \hrule
\nullvrule              empty \vrule

\makestrut[#1;#2]       ad hoc struts;  #1=height, #2=depth

\today                  today's date
\SetTime                converts \time to hours, minutes
\now                    displays time in hours and minutes
\Now                    shows current date and time

\ifPrelimDraft          flag to indicate status as preliminary draft

\rtitlex                TUGboat volume and number info for running head
\midrtitle              information for center of running head

\HorzR@gisterRule       pieces of registration marks ("trimmarks")
\DownShortR@gisterRule
\UpShortR@gisterRule

\ttopregister           top registration line with `T' in center
\tbotregister           bottom registration line with inverted `T' in center
\topregister            register actually used
\botregister


\raggedskip             parameters used for ragged settings
\raggedstretch
\raggedparfill
\raggedspaces

\raggedright
\raggedleft
\raggedcenter
\normalspaces
\raggedbottom

\bull                   square bullet
\cents                  ``cents'' sign
\Dag                    superscripted dagger
\careof                 c/o
\sfrac                  slashed fraction

\dash                   en-dash surrounded by thinspaces; only breakable AFTER
\Dash                   em-dash, as above

\hyph                   permit automatic hyphenation after an actual hyphen

\slash                  "breakable" slash

\xEdNote                Editor's Note:

\Input                  \input with some other bookkeepping for
                        case where multiple articles are put together

\TBremark               reminder to TUGboat editorial staff
\TBremarkON
\TBremarkOFF

\pagexref               used to write out page numbers to screen and
\pagexrefON             external files
\pagexrefOFF
\PageXref
\PageXrefON
\PageXrefOFF

\xrefto                 used for symbolic cross-reference to other pages
\xreftoON               in TUGboat
\xreftoOFF

\TBdriver               marks code which only takes effect when articles
                        are run together in a driver file

\signatureat            items for signatures
\signaturepercent
\signaturemark

SHAR_EOF
fi # end of overwriting check
#	End of shell archive
exit 0


